/*The Gobbler - A tool to audit DHCP networks
 *Copyright (C) 2002 Steven Jones root@networkpenetration.com
 *www.networkpenetration.com
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "gobbler.h"

pthread_mutex_t portcudplistlock = PTHREAD_MUTEX_INITIALIZER;
extern int vll;

//linked list of ports that are open
//where srcip is the packets source IP eg the target we are scanning, dst ip being the ip we scanned it with
int addclosedudpport(u_short num, u_char *srcip, u_char *dstip)
{
	cudpport * portcudppointer;
	int i;

	//printf("port %d to be added with src %d.%d.%d.%d\n", num, srcip[0], srcip[1], srcip[2], srcip[3]);
	pthread_mutex_lock(&portcudplistlock);
	portcudppointer = portcudppoint;
	if(portcudppointer != NULL){ //not 1st entry
		while(portcudppointer->nextport != NULL){
			if(portcudppointer->num == num){
				if(v)printf("Opps: UDP Port already in list llport %d openport %d before %d.%d.%d.%d\n",portcudppointer->num, num, dstip[0], dstip[1], dstip[2], dstip[3]);
				pthread_mutex_unlock(&portcudplistlock);
				return(0);
			}
		
			portcudppointer = (PCPT) portcudppointer->nextport;
			
			if(portcudppointer->num == num){
				if(v)printf("Opps: UDP Port already in list llport %d openport %d after ip %d.%d.%d.%d\n", portcudppointer->num, num, dstip[0], dstip[1], dstip[2], dstip[3]);
				pthread_mutex_unlock(&portcudplistlock);
				return(0);
			}
		}
		
		if(portcudppointer->num == num){
			pthread_mutex_unlock(&portcudplistlock);
			return(0);
		}

		
		portcudppointer->nextport = (struct cudpport *) malloc(sizeof(cudpport));
		if(portcudppointer->nextport == NULL){
			printf("Opps: Malloc error not 1st\n");
			exit(1);
		}

		portcudppointer = (PCPT) portcudppointer->nextport;
		portcudppointer->nextport = NULL;
		portcudppointer->num = num;
		for(i=0;i<4;i++){
			portcudppointer->ipaddr[i] = srcip[i];
		}
		for(i=0;i<4;i++){
			portcudppointer->uipaddr[i] = dstip[i];
		}
		if(vll)printcudpportll();
		pthread_mutex_unlock(&portcudplistlock);
		return(0);
	}
		
	else {
		//1st entry
		portcudppoint = (PCPT) calloc(sizeof(cudpport), 1);
		portcudppoint->nextport = NULL;

		portcudppoint->num = num;
		for(i=0;i<4;i++){
			portcudppoint->ipaddr[i] = srcip[i];
		}
		for(i=0;i<4;i++){
			portcudppoint->uipaddr[i] = dstip[i];
		}
		if(vll)printcudpportll();
		pthread_mutex_unlock(&portcudplistlock);
		return(0);
	}

	//shouldn;t reach here
	return(0);
}

int portcudpllcount(void)
{
	PCPT p_curr;
	int c = 0;
	p_curr = portcudppoint;

	if(portcudppoint == NULL) return(0);
	else {
		while(p_curr != NULL){
			c++;
			p_curr = (PCPT)p_curr->nextport;
		}
	}
	return(c);
}
			

void printcudpportll(void)
{
	PCPT p_curr;
	struct servent *se;
	char proto[4]; 
	p_curr = portcudppoint;
	strcpy(proto, "udp");
	printf("closed usp portscan results\n");
	
	if(portcudppoint == NULL) printf("No udp closed ports found\n");
	else{
		while(p_curr != NULL){
			if((se = getservbyport(htons(p_curr->num), proto)) == NULL){
				printf("%d.%d.%d.%d port udp closed %d (unknown) (%d.%d.%d.%d)\n", p_curr->ipaddr[0], p_curr->ipaddr[1], p_curr->ipaddr[2], p_curr->ipaddr[3], p_curr->num,  p_curr->uipaddr[0], p_curr->uipaddr[1], p_curr->uipaddr[2], p_curr->uipaddr[3]);
			}
			else {
				printf("%d.%d.%d.%d port udp closed %d (%s) (%d.%d.%d.%d)\n", p_curr->ipaddr[0], p_curr->ipaddr[1], p_curr->ipaddr[2], p_curr->ipaddr[3], p_curr->num, se->s_name, p_curr->uipaddr[0], p_curr->uipaddr[1], p_curr->uipaddr[2], p_curr->uipaddr[3]);
			}
			p_curr = (PCPT) p_curr->nextport;
		}
	}
}

void freecportudpll(void)
{
	PCPT p_curr;
	
	if(v>2)printf("\nFreeing open ports list\n");
	while(portcudppoint != NULL){
		p_curr = portcudppoint;
		portcudppoint = (PCPT) portcudppoint->nextport;
		free(p_curr);
	}
}
	
