/*The Gobbler - A tool to audit DHCP networks
 *Copyright (C) 2002 Steven Jones root@networkpenetration.com
 *www.networkpenetration.com
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "gobbler.h"
extern int dhcpdetected;
extern int dhcpgobbling;
extern int dhcpgobblestarted;
extern int dhcpreplyinfo;
extern int phosts;
extern int noprintinfo;
extern int gobblecreate;
extern int speccreate;
extern int ipgobblecount;
extern int dontreplytoping;

//creates a single host... mainly for testing purposes
void startcreatehost(void)
{
	
	extern int checkdhcp(int);
	extern void startdhcpdiscover(void);
	extern u_int countll(void);
	int i, k, d;
	PMT p_curr;
	u_char *srcip;
	//int dhcpreplyinfo;
	
	printf("Creating some hosts for your pleasure\n");
	if(gobblecreate){
		dhcpgobblestarted = 1;
		dhcpreplyinfo = 1;
		dhcpgobbling = 1;
		if(!phosts) phosts = 1;
		for(i=0;i<phosts;i++){
			startdhcpdiscover();
			usleep(200000);
			//sleep(1);
			noprintinfo = 1;
		}
		
		d = (phosts / 5) + 2;
				
		for(i=0;i<d;i++){
			if((k = checkdhcp(1)) != 0){
				if(k == 1){
					printf("Opps: checkdhcp error\n");
					exit(1);
				}
				//usleep(50000);
				sleep(4);
			}
		}
	
		if((k = checkdhcp(0)) != 0){
			if(k == 1){
				printf("Opps: checkdhcp error\n");
				exit(1);
			}
		}

		dhcpreplyinfo = 0;
		dhcpgobblestarted = 0;
		dhcpgobbling = 0;

		if(!dhcpdetected){
			printf("Opps: DHCP service not detected\n");
			exit(1);
		}
	}
	
	else{
		//not gobbled create.... specified
		if(!dontreplytoping){
			//by default ping not enabled on specified hosts 
			//so we enable here
			p_curr = mtpoint;
			if(p_curr == NULL){
				printf("Opps: linked list empty\n2");
				exit(1);
			}
			
			while(p_curr != NULL){
				p_curr->ping = 1;	
				srcip = (u_char *)&p_curr->ipaddress;
				printf("Created %d.%d.%d.%d %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n", srcip[0], srcip[1], srcip[2], srcip[3], p_curr->srcmac[0],p_curr->srcmac[1], p_curr->srcmac[2], p_curr->srcmac[3], p_curr->srcmac[4], p_curr->srcmac[5]);
				p_curr = (PMT) p_curr->nextmt;
			}
		}
	}
	printf("\ncreated.... do what you will\n\n");
	printf("ctrl+c to exit\n\n");
	for(;;){
		sleep(1);
	}
}

