// BSD version taken fromhttp://groups.google.com/groups?q=libnet+mac+address&hl=en&lr=&ie=UTF-8&oe=UTF-8&selm=Pine.BSO.4.10.9910060916230.22448-100000%40funky.monkey.org&rnum=10 - dug song

//linux version modded from libnet - mike schiffman



#include "gobbler.h"

#ifndef LINUX //ifdef BSDOS && osx
#include <sys/param.h>
#include <sys/sysctl.h>
#include <net/route.h>
#include <net/if_dl.h>
#endif

#ifndef LINUX //ifdef bsd && osx
struct ether_addr * get_hwaddr(const u_char *device)
{
    int mib[6];
    size_t len;
    char *buf, *next, *end;
    struct if_msghdr *ifm;
    struct sockaddr_dl *sdl;
    struct ether_addr *ea = NULL;

    mib[0] = CTL_NET;
    mib[1] = AF_ROUTE;
    mib[2] = 0;
    mib[3] = AF_LINK;
    mib[4] = NET_RT_IFLIST;
    mib[5] = 0;

    if (sysctl(mib, 6, NULL, &len, NULL, 0) < 0) {
        return (NULL);
    }

    if (!(buf = (char *)malloc(len))) {
        return NULL;
    }
   if (sysctl(mib, 6, buf, &len, NULL, 0) < 0) {
        free(buf);
        return (NULL);
    }
    end = buf + len;

    for (next = buf ; next < end ; next += ifm->ifm_msglen) {
        ifm = (struct if_msghdr *)next;
        if (ifm->ifm_type == RTM_IFINFO) {
            sdl = (struct sockaddr_dl *)(ifm + 1);
            if (strncmp(&sdl->sdl_data[0], device, sdl->sdl_nlen) == 0) {
                if (!(ea = malloc(sizeof(struct ether_addr)))) {
                    return (NULL);
                }
                memcpy(ea->ether_addr_octet, LLADDR(sdl), ETHER_ADDR_LEN);
                break;
            }
        }
    }
    free(buf);
    return (ea);
}

#endif

#ifdef LINUX
struct ether_addr * get_hwaddr(const u_char *device)
{
	int fd = 0;
	struct ifreq ifr;
	struct ether_addr *ea;
	/*
		XXX - non-re-entrant!
	*/
	static struct ether_addr sea;

	if(device == NULL){
		printf("Opps: can't get mac address of network card\n\n");
		close(fd);
		exit(1);
	}
	

	if((fd = socket(AF_INET, SOCK_DGRAM, 0)) < 0){
		printf("Opps: socket error as %s\n\n", strerror(errno));
		close(fd);
		exit(1);
	}

	memset(&ifr, 0, sizeof(ifr));
	ea = &sea;	

	strncpy(ifr.ifr_name, device, sizeof(ifr.ifr_name));
	if(ioctl(fd, SIOCGIFHWADDR, (char *)&ifr) < 0){
		printf("Opps: ioctl error as %s\n", strerror(errno));
		close(fd);
		exit(1);
	}

	memcpy(ea, &ifr.ifr_hwaddr.sa_data, ETHER_ADDR_LEN);
	close(fd);
	return(ea);
}
#endif

