/*The Gobbler - A tool to audit DHCP networks
 *Copyright (C) 2002 Steven Jones root@networkpenetration.com
 *www.networkpenetration.com
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "gobbler.h"
pthread_mutex_t icmplock = PTHREAD_MUTEX_INITIALIZER; //lock to ensure arp scan increments by one each time

int icmpport = 0;
int icmpid = 0;
extern int onlyicmpping;
extern int icmpscanstarted;
extern int fast;
extern int icmpechosent;
extern int droppedflag;
extern int sipcount;

extern libnet_t *l;
extern pthread_mutex_t packetlock;
extern char* hostname;


void icmpscan(int pingamount, int ttl, long icmppayloadsize)
{
	void addstats(struct libnet_stats);
        void end_icmpscan(void);
	struct in_addr sa;
        libnet_ptag_t t;
        u_long i = 0; //src + dst ip addresses
        int j = 0;
	int d = 0;
	int c = 0;
	int randnum = 0;
	int a = 0;
	u_int b = 0;
	PMT p_curr;
	PMI m_curr; 
	u_char *sourceip;
        u_char enet_src[6]; 
        u_char enet_dst[6];
	u_char *s;
	u_long payload_s = icmppayloadsize;
	u_char payload[icmppayloadsize];
	
	icmpport = 1;
	p_curr = mtpoint;
	
	for(b=0;b<payload_s;b++){
		payload[b] = 0xaa;
	}
	
	if(p_curr == NULL){
		printf("Opps: linked list is empty\n\n");
		exit(1);
	}
	randnum = 1 + (int)((float)sipcount*rand()/(RAND_MAX+1.0));
	a = 0;
	while((p_curr != NULL) && (a != (randnum -1))){
        	a++;
                p_curr = (PMT) p_curr->nextmt;
	}

        if(p_curr == NULL){
        	printf("Opps: couldn't find a src IP address\n\n");
                exit(1);
	}

	//found in llist
	for(d=0;d<6;d++){
		enet_src[d] = p_curr->srcmac[d];
	}
	
	m_curr = macippoint;
	if(m_curr == NULL){
		printf("Opps: Target mac address is empty\n");
		exit(1);
	}
	
	for(d=0;d<6;d++){
		enet_dst[d] = m_curr->srcmac[d];
	}
	
	if(!inet_aton(hostname, &sa)){
		printf("Opps: %s is a invaild ip address\n", hostname);
		exit(0);
	}

	i = (u_long) p_curr->ipaddress;
	sourceip = (u_char *)&(p_curr->ipaddress);
	s = (u_char *)&sa.s_addr;

	if((pingamount == 1) && (droppedflag != 1) && (onlyicmpping || v)) printf("\nPinging target %d.%d.%d.%d with src ip %d.%d.%d.%d mac %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n\n", s[0],s[1],s[2],s[3],sourceip[0], sourceip[1], sourceip[2], sourceip[3], p_curr->srcmac[0], p_curr->srcmac[1], p_curr->srcmac[2], p_curr->srcmac[3], p_curr->srcmac[4], p_curr->srcmac[5]);
	//if(v)printf("Pinging target\n");
	
	if(!onlyicmpping) pingamount = 1;
	if(!icmpid) icmpid = libnet_get_prand(LIBNET_PR16);
	if(v>2)printf("ICMP scan thread(%ld)\n", (long int) pthread_self());
	//here fixing icmp... test on just 192.168.3.2 	
	if(v>1) printf("ping amount %d\n",pingamount);
	for(j = 0; j < pingamount; j++){
		if(pthread_mutex_lock(&packetlock) !=0){
			printf("Opps: pthread_mutex_lock (arpscan)\n");
			exit(1);
		}
	
		t = libnet_build_icmpv4_echo( 
			ICMP_ECHO,//type,
			0,//code
			0,//sum
			icmpid, //id
			icmpechosent,//libnet_get_prand(LIBNET_PR16),//seq
			payload, //NULL,//icmpdataptr,//payload
			payload_s,//0,//icmpdatalen,//payload size
			l,
			0);
	       if(t == -1){
			printf("Opps: Can;t build icmp_echo header as %s\n\n", libnet_geterror(l));
			libnet_clear_packet(l);
			exit(1);
		}
			
		t = libnet_build_ipv4(
			LIBNET_IPV4_H + LIBNET_ICMPV4_ECHO_H + payload_s,
			0,
			libnet_get_prand(LIBNET_PR16), //id
			0, //frag
			ttl, //ttl
			IPPROTO_ICMP,
			0,
			(u_long)i,
			sa.s_addr,
			NULL,
			0,
			l,
			0);
	
		if(t == -1){
			printf("Opps: Can;t build IP header as %s\n\n", libnet_geterror(l));
			libnet_clear_packet(l);
			exit(1);
		}
		
		t = libnet_build_ethernet(
			enet_dst,       //enet source
		       	enet_src,       //enet dest
		        ETHERTYPE_IP,  //proto addr
			NULL,           //payload
		       	0,              //payload size
		        l,              //libnet handle
		        0);             //libnet id
		
		if(t == -1){
			printf("Opps: Can;t build ethernet header as %s\n\n", libnet_geterror(l));
			libnet_clear_packet(l);
		        exit(1);
		}
	
		 if((c = libnet_write(l)) == -1){
			printf("Opps: libnet_write error (icmp scan) as %s\n", libnet_geterror(l));
			exit(1);
		}
		  
		libnet_stats(l, &gs);
		libnet_clear_packet(l);
		icmpechosent++;
		if(pthread_mutex_unlock(&packetlock) !=0){
			printf("Opps: pthread_mutex_unlock (icmpscan)\n");
			exit(1);
		}
		if(pingamount != 1){
			if(fast) usleep(100);
			else sleep(1);
		}
	}
}

