#include "gobbler.h"
#include "nmap.h"

#include <assert.h>

/* Zero-initializing version of safe_malloc */
void *safe_zalloc(int size)
{
	void *mymem;
	if (size < 0){
		printf("Tried to malloc negative amount of memory!!!\n\n");
		exit(1);
	}
	mymem = calloc(1, size);
	if (mymem == NULL){
		printf("Opps: Malloc Failed! Probably out of space\n\n");
		exit(1);
	}
  //  printf("Called safe_zalloc(%d) -- returning %lX\n", size, (unsigned long) mymem);
	return mymem;
}

int nmap_fetchfile(char *filename_returned, int bufferlen, char *file) {
 // char *dirptr;
  int res;
  int foundsomething = 0;
  //struct passwd *pw;
  //char dot_buffer[512];
  //static int warningcount = 0;

  int fileexistsandisreadable(char *pathname);

  /* First we try [--datadir]/file, then $NMAPDIR/file
     next we try ~user/nmap/file
     then we try NMAPDATADIR/file <--NMAPDATADIR
     finally we try ./file

         -- or on Windows --

         --datadir -> $NMAPDIR -> nmap.exe directory -> NMAPDATADIR -> .
  */
/*
  if (o.datadir) {
    res = snprintf(filename_returned, bufferlen, "%s/%s", o.datadir, file);
    if (res > 0 && res < bufferlen) {
      if (fileexistsandisreadable(filename_returned))
        foundsomething = 1;
    }
  }

  if ((dirptr = getenv("NMAPDIR"))) {
    res = snprintf(filename_returned, bufferlen, "%s/%s", dirptr, file);
    if (res > 0 && res < bufferlen) {
      if (fileexistsandisreadable(filename_returned))
        foundsomething = 1;
    }
  }
 if (!foundsomething) {
    pw = getpwuid(getuid());
    if (pw) {
      res = snprintf(filename_returned, bufferlen, "%s/.nmap/%s", pw->pw_dir, file);
      if (res > 0 && res < bufferlen) {
        if (fileexistsandisreadable(filename_returned))
          foundsomething = 1;
      }
    }
    if (!foundsomething && getuid() != geteuid()) {
      pw = getpwuid(geteuid());
      if (pw) {
        res = snprintf(filename_returned, bufferlen, "%s/nmap/%s", pw->pw_dir, file);
        if (res > 0 && res < bufferlen) {
          if (fileexistsandisreadable(filename_returned))
            foundsomething = 1;
        }
      }
    }
  }
  if (!foundsomething) {
    res = snprintf(filename_returned, bufferlen, "%s/%s", NMAPDATADIR, file);
    if (res > 0 && res < bufferlen) {
      if (fileexistsandisreadable(filename_returned))
        foundsomething = 1;
    }
  }
  if (foundsomething && (*filename_returned != '.')) {
    res = snprintf(dot_buffer, sizeof(dot_buffer), "./%s", file);
    if (res > 0 && res < bufferlen) {
      if (fileexistsandisreadable(dot_buffer)) {
 	if(warningcount++ < 5)
          error("WARNING!  The following files exist and are readable: %s and %s.  I am choosing %s for security reasons.  set NMAPDIR=. to give priority to files in your local directory", filename_returned, dot_buffer, filename_returned);
      }
    }
  }
*/
  if (!foundsomething) {
    res = snprintf(filename_returned, bufferlen, "./%s", file);
    if (res > 0 && res < bufferlen) {
      if (fileexistsandisreadable(filename_returned))
        foundsomething = 1;
    }
  }

  if (!foundsomething) {
    filename_returned[0] = '\0';
    return -1;
  }

  
  if(v>1)printf("NMAP Fetchfile found %s\n", filename_returned);

  return 0;

}

FingerPrint **parse_fingerprint_file(char *fname) {
FingerPrint **FPs;
FingerPrint *current;
FILE *fp;
int max_records = 4096;
char line[512];
int numrecords = 0;
int lineno = 0;
char *p, *q; /* OH YEAH!!!! */
struct AVal *str2AVal(char *str);
char *fp2ascii(FingerPrint *FP);

 FPs = (FingerPrint **) safe_zalloc(sizeof(FingerPrint *) * max_records);

 fp = fopen(fname, "r");

 top:
while(fgets(line, sizeof(line), fp)) {
  lineno++;
  /* Read in a record */
  if (*line == '\n' || *line == '#')
    continue;

 fparse:

  if (strncasecmp(line, "FingerPrint", 11)) {
    fprintf(stderr, "Parse error on line %d of nmap-os-fingerprints file: %s\n", lineno, line);
    continue;
  }
  p = line + 12;
  while(*p && isspace((int) *p)) p++;
  if (!*p) {
    fprintf(stderr, "Parse error on line %d of nmap-os-fingerprints file: %s\n", lineno, line);
    continue;
  }
  FPs[numrecords] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
  q = FPs[numrecords]->OS_name;
  while(*p && *p != '\n' && *p != '#') {
    if (q - FPs[numrecords]->OS_name >= (int) (sizeof(FPs[numrecords]->OS_name) -2)){
	printf("Ack!  0v3rf0w r3ad|ng fIng3rpRint FiLE!");
	exit(1);
    }
    *q++ = *p++;
  }

  q--;

  /* Now let us back up through any ending spaces */
 while(isspace((int)*q))
    q--;

  /* Terminate the sucker */
  q++;
  *q = '\0';

  current = FPs[numrecords];
  current->line = lineno;
  /* Now we read the fingerprint itself */
  while(fgets(line, sizeof(line), fp)) {
    lineno++;
    if (*line == '#')
      continue;
    if (*line == '\n')
      break;
    if (!strncmp(line, "FingerPrint",11)) {
      goto fparse;
    }
    p = line;
    q = strchr(line, '(');
    if (!q) {
      printf("Parse error on line %d of nmap-os-fingerprints file: %s\n", lineno, line);
      goto top;
    }
    *q = '\0';
    if(current->name) {
      current->next = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
      current = current->next;
    }
    current->name = strdup(p);
    p = q+1;
    *q = '(';
    q = strchr(p, ')');
    if (!q) {
      printf("Parse error on line %d of nmap-os-fingerprints file: %s\n", lineno, line);
      goto top;
    }
    *q = '\0';
    current->results = str2AVal(p);
  }
  //printf("Read in fingerprint:\n%s\n", fp2ascii(FPs[numrecords])); 
  numrecords++;
  if (numrecords >= max_records){
 	printf("Too many OS fingerprints -- 0verfl0w");
	exit(1);
  }
}
fclose(fp);
FPs[numrecords] = NULL;
return FPs;
}

char *fp2ascii(FingerPrint *FP) {
static char str[2048];
FingerPrint *current;
struct AVal *AV;
char *p = str;
int len;
bzero(str, sizeof(str));

if (!FP) return "(None)";

if(*(FP->OS_name)) {
  len = snprintf(str, 128, "FingerPrint  %s\n", FP->OS_name);
  if (len < 0){
	printf("OS name too long");
	exit(1);
  }
  p += len;
}

for(current = FP; current ; current = current->next) {
  Strncpy(p, current->name, sizeof(str) - (p-str));
  p += strlen(p);
  assert(p-str < (int) sizeof(str) - 30);
  *p++='(';
  for(AV = current->results; AV; AV = AV->next) {
    Strncpy(p, AV->attribute, sizeof(str) - (p-str));
    p += strlen(p);
    assert(p-str < (int) sizeof(str) - 30);
    *p++='=';
    Strncpy(p, AV->value, sizeof(str) - (p-str));
    p += strlen(p);
    assert(p-str < (int) sizeof(str) - 30);
    *p++ = '%';
  }
  if(*(p-1) != '(')
    p--; /* Kill the final & */
  *p++ = ')';
  *p++ = '\n';
}
*p = '\0';
return str;
}


int fileexistsandisreadable(char *pathname) {
  FILE *fp;
  /* We check this the easy way! */
  fp = fopen(pathname, "r");
  if (fp) fclose(fp);
  return (fp == NULL)? 0 : 1;
}

struct AVal *str2AVal(char *str) {
int i = 1;
int count = 1;
char *q = str, *p=str;
struct AVal *AVs;
if (!*str) return NULL;

/* count the AVals */
while((q = strchr(q, '%'))) {
  count++;
  q++;
}

AVs = (struct AVal *) safe_zalloc(count * sizeof(struct AVal));
for(i=0; i < count; i++) {
  q = strchr(p, '=');
  if (!q) {
    printf("Parse error with AVal string (%s) in nmap-os-fingerprints file", str);
    exit(1);
  }
  *q = '\0';
  AVs[i].attribute = strdup(p);
  p = q+1;
  if (i != count - 1) {
    q = strchr(p, '%');
    if (!q) {
      printf("Parse error with AVal string (%s) in nmap-os-fingerprints file", str);
      exit(1);
    }
    *q = '\0';
    AVs[i].next = &AVs[i+1];
  }
  Strncpy(AVs[i].value, p, sizeof(AVs[i].value));
  p = q + 1;
}
return AVs;
}


FingerPrint **parse_fingerprint_reference_file()
{
        int nmap_fetchfile(char *filename_returned, int bufferlen, char *file);
        char filename[256];

        if (nmap_fetchfile(filename, sizeof(filename), "nmap-os-fingerprints") == -1){
        printf("OS scan requested but I cannot find nmap-os-fingerprints file\n\n");
                exit(1);
        }

        return parse_fingerprint_file(filename);
}

//Added by ste
FingerPrint **parse_portzero_reference_file()
{
        int nmap_fetchfile(char *filename_returned, int bufferlen, char *file);
        char filename[256];

        if (nmap_fetchfile(filename, sizeof(filename), "gobbler-portzero-fingerprints") == -1){
        printf("OS scan requested but I cannot find gobbler-portzero-fingerprints\n\n");
                exit(1);
        }

        return parse_fingerprint_file(filename);
}
//end

struct AVal *gettestbyname(FingerPrint *FP, const char *name) {

  if (!FP) return NULL;
  do {
    if (!strcmp(FP->name, name))
      return FP->results;
    FP = FP->next;
  } while(FP);
  return NULL;
}

struct AVal *getattrbyname(struct AVal *AV, const char *name) {

  if (!AV) return NULL;
  do {
    if (!strcmp(AV->attribute, name))
      return AV;
    AV = AV->next;
  } while(AV);
  return NULL;
}

/* Returns true if perfect match -- if num_subtests &
   num_subtests_succeeded are non_null it ADDS THE NEW VALUES to what
   is already there.  So initialize them to zero first if you only
   want to see the results from this match.  if shortcircuit is zero,
   it does all the tests, otherwise it returns when the first one
   fails. */
int AVal_match(struct AVal *reference, struct AVal *fprint, unsigned long *num_subtests, unsigned long *num_subtests_succeeded, int shortcut) {
  struct AVal *current_ref;
  struct AVal *current_fp;
  unsigned int number;
  unsigned int val;
  char *p, *q;  /* OHHHH YEEEAAAAAHHHH!#!@#$!% */
  char valcpy[512];
  char *endptr;
  int andexp, orexp, expchar, numtrue;
  int testfailed;
  int subtests = 0, subtests_succeeded=0;

  for(current_ref = reference; current_ref; current_ref = current_ref->next) {
    current_fp = getattrbyname(fprint, current_ref->attribute);
    if (!current_fp) continue;
    /* OK, we compare an attribute value in  current_fp->value to a
       potentially large expression in current_ref->value.  The syntax uses
       < (less than), > (greather than), + (non-zero), | (or), and & (and)
       No parenthesis are allowed and an expression cannot have | AND & */
    numtrue = andexp = orexp = 0; testfailed = 0;
    Strncpy(valcpy, current_ref->value, sizeof(valcpy));
    p = valcpy;
    if (strchr(current_ref->value, '|')) {
      orexp = 1; expchar = '|';
    } else {
      andexp = 1; expchar = '&';
    }
    do {
      q = strchr(p, expchar);
      if (q) *q = '\0';
      if (strcmp(p, "+") == 0) {
        if (!*current_fp->value) { if (andexp) { testfailed=1; break; } }
        else {
          val = strtol(current_fp->value, &endptr, 16);
          if (val == 0 || *endptr) { if (andexp) { testfailed=1; break; } }
          else { numtrue++; if (orexp) break; }
        }
      } else if (*p == '<' && isxdigit((int) p[1])) {
        if (!*current_fp->value) { if (andexp) { testfailed=1; break; } }
        number = strtol(p + 1, &endptr, 16);
        val = strtol(current_fp->value, &endptr, 16);
        if (val >= number || *endptr) { if (andexp)  { testfailed=1; break; } }
        else { numtrue++; if (orexp) break; }
      } else if (*p == '>' && isxdigit((int) p[1])) {
        if (!*current_fp->value) { if (andexp) { testfailed=1; break; } }
        number = strtol(p + 1, &endptr, 16);
        val = strtol(current_fp->value, &endptr, 16);
        if (val <= number || *endptr) { if (andexp) { testfailed=1; break; } }
        else { numtrue++; if (orexp) break; }
      }
      else {
        if (strcmp(p, current_fp->value))
          { if (andexp) { testfailed=1; break; } }
        else { numtrue++; if (orexp) break; }
      }
      if (q) p = q + 1;
    } while(q);
      if (numtrue == 0) testfailed=1;
      subtests++;
      if (testfailed) {
        if (shortcut) {
          if (num_subtests) *num_subtests += subtests;
          return 0;
        }
      } else subtests_succeeded++;
      /* Whew, we made it past one Attribute alive , on to the next! */
  }
  if (num_subtests) *num_subtests += subtests;
  if (num_subtests_succeeded) *num_subtests_succeeded += subtests_succeeded;
  return (subtests == subtests_succeeded)? 1 : 0;
}

void freeFingerPrint(FingerPrint *FP) {
FingerPrint *currentFP;
FingerPrint *nextFP;

if (!FP) return;

 for(currentFP = FP; currentFP; currentFP = nextFP) {
   nextFP = currentFP->next;
   if (currentFP->results)
     free(currentFP->results);
   free(currentFP);
 }
return;
}


double compare_fingerprints(FingerPrint *referenceFP, FingerPrint *observedFP,
                            int verbose) {
  FingerPrint *currentReferenceTest;
  struct AVal *currentObservedTest;
  unsigned long num_subtests = 0, num_subtests_succeeded = 0;
  unsigned long  new_subtests, new_subtests_succeeded;
  assert(referenceFP);
  assert(observedFP);

  for(currentReferenceTest = referenceFP; currentReferenceTest;
      currentReferenceTest = currentReferenceTest->next) {
    currentObservedTest = gettestbyname(observedFP, currentReferenceTest->name);
    if (currentObservedTest) {
      new_subtests = new_subtests_succeeded = 0;
      AVal_match(currentReferenceTest->results, currentObservedTest,
                 &new_subtests, &new_subtests_succeeded, 0);
      if (verbose && new_subtests_succeeded < new_subtests)
        printf("Test %s differs in %li attributes\n",
               currentReferenceTest->name,
               new_subtests - new_subtests_succeeded);
      num_subtests += new_subtests;
      num_subtests_succeeded += new_subtests_succeeded;
    }
  }

  assert(num_subtests_succeeded <= num_subtests);
  return (num_subtests)? (num_subtests_succeeded / (double) num_subtests) : 0;
}


/* Takes a fingerprint and looks for matches inside reference_FPs[].
   The results are stored in in FPR (which must point to an allocated
   FingerPrintResults structure) -- results will be reverse-sorted by
   accuracy.  No results below accuracy_threshhold will be included.
   The max matches returned is the maximum that fits in a
   FingerPrintResults structure.  The allocated FingerPrintResults
   does not have to be initialized -- that will be done in this
   function.  */
void match_fingerprint(FingerPrint *FP, struct FingerPrintResults *FPR,
                      FingerPrint **reference_FPs, double accuracy_threshold) {

  int i;
  double FPR_entrance_requirement = accuracy_threshold; /* accuracy must be
                                                           at least this big
                                                           to be added to the
                                                           list */
  FingerPrint *current_os;
  double acc;
  int state;
  int skipfp;
  int max_prints = sizeof(FPR->prints) / sizeof(FingerPrint *);
  int idx;
  double tmp_acc=0.0, tmp_acc2; /* These are temp buffers for list swaps */
  FingerPrint *tmp_FP=NULL, *tmp_FP2;

  assert(FP);
  assert(FPR);
  assert(accuracy_threshold >= 0 && accuracy_threshold <= 1);

  bzero(FPR, sizeof(*FPR));
  FPR->overall_results = OSSCAN_SUCCESS;

  for(i = 0; reference_FPs[i]; i++) {
    current_os = reference_FPs[i];
    skipfp = 0;

    acc = compare_fingerprints(current_os, FP, 0); //1 / 0= verbose 
    /*    error("Comp to %s: %li/%li=%f", o.reference_FPs[i]->OS_name, num_subtests_succeeded, num_subtests, acc); */
    if (acc >= FPR_entrance_requirement || acc == 1.0) {

      state = 0;
      for(idx=0; idx < FPR->num_matches; idx++) {
        if (strcmp(FPR->prints[idx]->OS_name, current_os->OS_name) == 0) {
          if (FPR->accuracy[idx] >= acc) {
            skipfp = 1; /* Skip it -- a higher version is already in list */
          } else {
            /* We must shift the list left to delete this sucker */
            memmove(FPR->prints + idx, FPR->prints + idx + 1,
                    (FPR->num_matches - 1 - idx) * sizeof(FingerPrint *));
            memmove(FPR->accuracy + idx, FPR->accuracy + idx + 1,
                    (FPR->num_matches - 1 - idx) * sizeof(double));
            FPR->num_matches--;
            FPR->accuracy[FPR->num_matches] = 0;
          }
          break; /* There can only be 1 in the list with same name */
        }
      }

      if (!skipfp) {
        /* First we check whether we have overflowed with perfect matches */
        if (acc == 1) {
          /*      error("DEBUG: Perfect match #%d/%d", FPR->num_perfect_matches + 1, max_prints); */
          if (FPR->num_perfect_matches == max_prints) {
            FPR->overall_results = OSSCAN_TOOMANYMATCHES;
            return;
          }
          FPR->num_perfect_matches++;
        }

        /* Now we add the sucker to the list */
        state = 0; /* Have not yet done the insertion */
        for(idx=-1; idx < max_prints -1; idx++) {
          if (state == 1) {
            /* Push tmp_acc and tmp_FP onto the next idx */
            tmp_acc2 = FPR->accuracy[idx+1];
            tmp_FP2 = FPR->prints[idx+1];

            FPR->accuracy[idx+1] = tmp_acc;
            FPR->prints[idx+1] = tmp_FP;

            tmp_acc = tmp_acc2;
            tmp_FP = tmp_FP2;
          } else if (FPR->accuracy[idx + 1] < acc) {
            /* OK, I insert the sucker into the next slot ... */
            tmp_acc = FPR->accuracy[idx+1];
            tmp_FP = FPR->prints[idx+1];
            FPR->prints[idx+1] = current_os;
            FPR->accuracy[idx+1] = acc;
            state = 1;
          }
        }
        if (state != 1) {
          printf("Opps: NMAP: Bogus list insertion state (%d) -- num_matches = %d num_perfect_matches=%d entrance_requirement=%f", state, FPR->num_matches, FPR->num_perfect_matches, FPR_entrance_requirement);
	  exit(1);
        }
        FPR->num_matches++;
        /* If we are over max_prints, one was shoved off list */
        if (FPR->num_matches > max_prints) FPR->num_matches = max_prints;

        /* Calculate the new min req. */
        if (FPR->num_matches == max_prints) {
          FPR_entrance_requirement = FPR->accuracy[max_prints - 1] + 0.00001;
        }
      }
    }
  }

  if (FPR->num_matches == 0 && FPR->overall_results == OSSCAN_SUCCESS)
    FPR->overall_results = OSSCAN_NOMATCHES;

  return;
}

