/*The Gobbler - A tool to audit DHCP networks
 *Copyright (C) 2002 Steven Jones root@networkpenetration.com
 *www.networkpenetration.com
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "gobbler.h"

//linked list for random port order 
int addrandport(u_short num)
{
	rp * rppointer;
	rp * rpendpointer;
	rppointer = rppoint;
	rpendpointer = rpendpoint;

	
	if(v>1)printf("port %d being added to random port linked list\n", num);
	if(rppointer != NULL){ //not 1st entry
	
		rppointer = (RPT)rpendpoint;

		rppointer->nextrp = (struct rp *) malloc(sizeof(rp));
		if(rppointer->nextrp == NULL){
			printf("Opps: Malloc error not 1st\n");
			exit(1);
		}

		rppointer = (RPT) rppointer->nextrp;
		rppointer->nextrp = NULL;
		rppointer->done = 0;
		rppointer->fdone = 0; 
		rppointer->num = num;
		rpendpoint = (RPT) rppointer; //assign end pointer
		return(0);
	}
		
	else {
		//1st entry
		rppoint = (RPT) calloc(sizeof(rp), 1);
		rppoint->nextrp = NULL;
		rppoint->num = num;
		rppoint->done = 0;
		rppoint->fdone = 0;
		rpendpoint = (RPT) rppoint;
		return(0);
	}

	//shouldn;t reach here return error
	return(1);
}

void printrll(void)
{
	RPT p_curr;

	p_curr = rppoint;

	printf("Random Ports linked list\n");
	
	if(rppoint == NULL) printf("linked list is empty\n");
	else{
		while(p_curr != NULL){
			printf("%d, ", p_curr->num);
			p_curr = (RPT) p_curr->nextrp;
		}
		printf("\n");
	}
}

int rllcount(void)
{
	RPT p_curr;
	int c = 0;
	p_curr = rppoint;
	
	if(rppoint == NULL) return(0);
	else {
		while(p_curr != NULL){
			c++;
			p_curr = (RPT)p_curr->nextrp;
		}
	}
	return(c);
}

void freerportll(void)
{
	
        RPT p_curr;

        if(v>2)printf("\nFreeing open ports list\n");
        while(rppoint != NULL){
                p_curr = rppoint;
                rppoint = (RPT) rppoint->nextrp;
                free(p_curr);
        }
}

